
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2143
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _flag_b=R5
	.DEF _flag_a=R4
	.DEF _flag_c=R7
	.DEF _u_n=R8
	.DEF _u_nnn=R10
	.DEF _u_delta_a=R12
	.DEF _t=R6

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  _ext_int0_isr
	JMP  _ext_int1_isr
	JMP  _ext_int2_isr
	JMP  0x00
	JMP  _timer2_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_tbl10_G102:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G102:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x3:
	.DB  0xA
_0x2EA:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0
_0x0:
	.DB  0xA8,0x6F,0xE3,0x6F,0xB6,0xE3,0xB8,0xBF
	.DB  0x65,0x20,0x20,0x2D,0x20,0x25,0x75,0x20
	.DB  0x20,0x0,0x63,0xBF,0xB8,0x70,0x61,0xBD
	.DB  0xB8,0x65,0x20,0xBE,0x61,0xBC,0xC7,0xBF
	.DB  0xB8,0x2D,0x41,0x2E,0x2E,0x2E,0x2E,0x0
	.DB  0xE0,0x61,0xBD,0xBD,0xC3,0x65,0x2D,0x41
	.DB  0x20,0x79,0xBD,0xB8,0xC0,0xBF,0x6F,0xB6
	.DB  0x65,0xBD,0xC3,0x21,0x0,0x63,0xBF,0xB8
	.DB  0x70,0x61,0xBD,0xB8,0x65,0x20,0xBE,0x61
	.DB  0xBC,0xC7,0xBF,0xB8,0x2D,0x42,0x2E,0x2E
	.DB  0x2E,0x2E,0x0,0xE0,0x61,0xBD,0xBD,0xC3
	.DB  0x65,0x2D,0x42,0x20,0x79,0xBD,0xB8,0xC0
	.DB  0xBF,0x6F,0xB6,0x65,0xBD,0xC3,0x21,0x0
	.DB  0x63,0xBF,0xB8,0x70,0x61,0xBD,0xB8,0x65
	.DB  0x20,0xBE,0x61,0xBC,0xC7,0xBF,0xB8,0x2D
	.DB  0x43,0x2E,0x2E,0x2E,0x2E,0x0,0xE0,0x61
	.DB  0xBD,0xBD,0xC3,0x65,0x2D,0x43,0x20,0x79
	.DB  0xBD,0xB8,0xC0,0xBF,0x6F,0xB6,0x65,0xBD
	.DB  0xC3,0x21,0x0,0xE0,0x61,0xBD,0xBD,0xC3
	.DB  0x65,0x20,0x79,0xBD,0xB8,0xC0,0xBF,0x6F
	.DB  0xB6,0x65,0xBD,0xC3,0x21,0x0,0x43,0xB2
	.DB  0x70,0x6F,0x63,0x20,0xB3,0xC3,0xBE,0x6F
	.DB  0xBB,0xBD,0x65,0xBD,0x21,0x0,0x50,0x65
	.DB  0xB4,0xB8,0x63,0xBF,0x70,0x61,0xBF,0x6F
	.DB  0x70,0x20,0xBE,0x70,0x6F,0xB3,0x61,0xBB
	.DB  0x6F,0xB3,0x0,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x4D,0x50,0xA8,0x2D,0x33,0x2F,0x31
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x0,0xA4
	.DB  0x61,0xB4,0x70,0x79,0xB7,0xBA,0x61,0x2E
	.DB  0x2E,0x2E,0x2E,0x2E,0x2E,0x0,0xE3,0xBB
	.DB  0xC7,0x20,0x63,0xB2,0x70,0x6F,0x63,0x61
	.DB  0x20,0xB7,0x61,0xB6,0xBC,0xB8,0xBF,0x65
	.DB  0x0,0xB8,0x20,0x79,0xE3,0x65,0x70,0xB6
	.DB  0xB8,0xB3,0x61,0xB9,0xBF,0x65,0x20,0xBC
	.DB  0xB8,0xBD,0x79,0x63,0x0,0x50,0x65,0xB6
	.DB  0xB8,0xBC,0x20,0xBE,0x6F,0xBD,0xB8,0xB6
	.DB  0x65,0xBD,0x6F,0xB4,0x6F,0x0,0xC5,0xBD
	.DB  0x65,0x70,0xB4,0x6F,0xBE,0x6F,0xBF,0x70
	.DB  0x65,0xB2,0xBB,0x65,0xBD,0xB8,0xC7,0x0
	.DB  0x61,0xBA,0xBF,0xB8,0xB3,0xB8,0x70,0x6F
	.DB  0xB3,0x61,0xBD,0x21,0x0,0x42,0xC3,0xBA
	.DB  0xBB,0xC6,0xC0,0x61,0xC6,0x20,0xBE,0xB8
	.DB  0xBF,0x61,0xBD,0xB8,0x65,0x21,0x0,0xE0
	.DB  0xBB,0xB8,0xBF,0x65,0xBB,0xC4,0xBD,0x6F
	.DB  0x63,0xBF,0xC4,0x20,0xBE,0x70,0x6F,0xB3
	.DB  0x61,0xBB,0x61,0x0,0xAA,0x61,0xB7,0x61
	.DB  0x20,0x41,0x20,0x54,0x61,0x3D,0x25,0x75
	.DB  0x20,0x6D,0x63,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x0,0xAA,0x61,0xB7,0x61,0x20
	.DB  0x41,0x20,0x54,0x61,0x3D,0x25,0x75,0x6D
	.DB  0x25,0x75,0x63,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x0,0xAA,0x61,0xB7,0x61,0x20
	.DB  0x42,0x20,0x54,0x63,0x3D,0x25,0x75,0x20
	.DB  0x6D,0x63,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x0,0xAA,0x61,0xB7,0x61,0x20,0x42
	.DB  0x20,0x54,0x62,0x3D,0x25,0x75,0x6D,0x25
	.DB  0x75,0x63,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x0,0xAA,0x61,0xB7,0x61,0x20,0x43
	.DB  0x20,0x54,0x63,0x3D,0x25,0x75,0x20,0x6D
	.DB  0x63,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x0,0xAA,0x61,0xB7,0x61,0x20,0x43,0x20
	.DB  0x54,0x63,0x3D,0x25,0x75,0x6D,0x25,0x75
	.DB  0x63,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x0,0x25,0x69,0x3A,0x25,0x69,0x25,0x69
	.DB  0x3A,0x25,0x69,0x25,0x69,0x2D,0x25,0x69
	.DB  0x2F,0x25,0x69,0x2F,0x25,0x69,0x20,0x0
	.DB  0x50,0x65,0xB6,0xB8,0xBC,0x20,0x63,0xBA
	.DB  0x61,0xBD,0xB8,0x70,0x6F,0xB3,0x61,0xBD
	.DB  0xB8,0xC7,0x21,0x21,0x0,0xAA,0x61,0xB7
	.DB  0x61,0x20,0x41,0x20,0x55,0x61,0x3D,0x25
	.DB  0x75,0x20,0x56,0x20,0x20,0x2A,0x20,0x0
	.DB  0xAA,0x61,0xB7,0x61,0x20,0x41,0x20,0x55
	.DB  0x61,0x3D,0x25,0x75,0x20,0x56,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0xAA,0x61,0xB7
	.DB  0x61,0x20,0x42,0x20,0x55,0x62,0x3D,0x25
	.DB  0x75,0x20,0x56,0x20,0x20,0x2A,0x20,0x20
	.DB  0x0,0xAA,0x61,0xB7,0x61,0x20,0x42,0x20
	.DB  0x55,0x62,0x3D,0x25,0x75,0x20,0x56,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x0,0xAA,0x61
	.DB  0xB7,0x61,0x20,0x43,0x20,0x55,0x63,0x3D
	.DB  0x25,0x75,0x20,0x56,0x20,0x20,0x2A,0x20
	.DB  0x20,0x0,0xAA,0x61,0xB7,0x61,0x20,0x43
	.DB  0x20,0x55,0x63,0x3D,0x25,0x75,0x20,0x56
	.DB  0x20,0x20,0x20,0x20,0x20,0x0,0xAA,0x61
	.DB  0xB7,0x61,0x20,0x43,0x20,0x55,0x63,0x3D
	.DB  0x25,0x75,0x20,0x56,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x0,0xA8,0x61,0x70,0x61,0xBC
	.DB  0x65,0xBF,0x70,0xC3,0x20,0xE4,0x61,0xB7
	.DB  0xC3,0x20,0x41,0x0,0x55,0x61,0x3D,0x25
	.DB  0x75,0x56,0x2F,0x2B,0x25,0x69,0x20,0xBE
	.DB  0x70,0x6F,0xE5,0x2E,0x0,0x55,0x61,0x3D
	.DB  0x25,0x75,0x56,0x2F,0x2D,0x25,0x69,0x20
	.DB  0xBE,0x70,0x6F,0xE5,0x2E,0x0,0xA1,0xBB
	.DB  0x79,0xB2,0xB8,0xBD,0x61,0x20,0x55,0x61
	.DB  0x2A,0x3D,0x2B,0x25,0x75,0x56,0x20,0x20
	.DB  0x0,0xA1,0xBB,0x79,0xB2,0xB8,0xBD,0x61
	.DB  0x20,0x55,0x61,0x2A,0x3D,0x2D,0x25,0x75
	.DB  0x56,0x20,0x20,0x0,0x42,0x70,0x65,0xBC
	.DB  0xC7,0x20,0x54,0x61,0x3D,0x25,0x75,0x73
	.DB  0x25,0x75,0x6D,0x63,0x20,0x20,0x0,0x42
	.DB  0x70,0x65,0xBC,0xC7,0x20,0x54,0x61,0x3D
	.DB  0x25,0x75,0x6D,0x25,0x75,0x63,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x0,0xA8,0x61
	.DB  0x70,0x61,0xBC,0x65,0xBF,0x70,0xC3,0x20
	.DB  0xE4,0x61,0xB7,0xC3,0x20,0x42,0x0,0x55
	.DB  0x62,0x3D,0x25,0x75,0x56,0x2F,0x2B,0x25
	.DB  0x69,0x20,0xBE,0x70,0x6F,0xE5,0x2E,0x0
	.DB  0x55,0x62,0x3D,0x25,0x75,0x56,0x2F,0x2D
	.DB  0x25,0x69,0x20,0xBE,0x70,0x6F,0xE5,0x2E
	.DB  0x0,0xA1,0xBB,0x79,0xB2,0xB8,0xBD,0x61
	.DB  0x20,0x55,0x62,0x2A,0x3D,0x2B,0x25,0x75
	.DB  0x56,0x20,0x20,0x0,0xA1,0xBB,0x79,0xB2
	.DB  0xB8,0xBD,0x61,0x20,0x55,0x62,0x2A,0x3D
	.DB  0x2D,0x25,0x75,0x56,0x20,0x20,0x0,0x42
	.DB  0x70,0x65,0xBC,0xC7,0x20,0x54,0x62,0x3D
	.DB  0x25,0x75,0x73,0x25,0x75,0x6D,0x63,0x20
	.DB  0x20,0x0,0x42,0x70,0x65,0xBC,0xC7,0x20
	.DB  0x54,0x62,0x3D,0x25,0x75,0x6D,0x25,0x75
	.DB  0x63,0x20,0x20,0x20,0x20,0x20,0x0,0xA8
	.DB  0x61,0x70,0x61,0xBC,0x65,0xBF,0x70,0xC3
	.DB  0x20,0xE4,0x61,0xB7,0xC3,0x20,0x43,0x0
	.DB  0x55,0x63,0x3D,0x25,0x75,0x56,0x2F,0x2B
	.DB  0x25,0x69,0x20,0xBE,0x70,0x6F,0xE5,0x2E
	.DB  0x0,0x55,0x63,0x3D,0x25,0x75,0x56,0x2F
	.DB  0x2D,0x25,0x69,0x20,0xBE,0x70,0x6F,0xE5
	.DB  0x2E,0x0,0xA1,0xBB,0x79,0xB2,0xB8,0xBD
	.DB  0x61,0x20,0x55,0x63,0x2A,0x3D,0x2B,0x25
	.DB  0x75,0x56,0x20,0x20,0x0,0xA1,0xBB,0x79
	.DB  0xB2,0xB8,0xBD,0x61,0x20,0x55,0x63,0x2A
	.DB  0x3D,0x2D,0x25,0x75,0x56,0x20,0x20,0x0
	.DB  0x42,0x70,0x65,0xBC,0xC7,0x20,0x54,0x63
	.DB  0x3D,0x25,0x75,0x73,0x25,0x75,0x6D,0x63
	.DB  0x20,0x20,0x0,0x42,0x70,0x65,0xBC,0xC7
	.DB  0x20,0x54,0x63,0x3D,0x25,0x75,0x73,0x25
	.DB  0x75,0x63,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x0,0xA0,0x61,0xBF,0x61,0x70,0x65,0xC7
	.DB  0x2D,0x25,0x75,0x20,0x6D,0x42,0x20,0x20
	.DB  0x20,0x20,0x0,0xA8,0x6F,0xE3,0xBA,0xBB
	.DB  0xC6,0xC0,0xB8,0xBF,0x65,0x20,0xB7,0x61
	.DB  0x70,0xC7,0xE3,0xBD,0x6F,0x65,0x21,0x0
	.DB  0xA9,0x70,0x6F,0xB3,0x65,0xBD,0xC4,0x2D
	.DB  0x25,0x69,0x2A,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0x43,0xB8,0x63
	.DB  0xBF,0x65,0xBC,0x61,0x2D,0x25,0x69,0x20
	.DB  0x6D,0x42,0x20,0x20,0x20,0x20,0x0,0xA4
	.DB  0x61,0x70,0xC7,0xE3,0xBA,0x61,0x2D,0x25
	.DB  0x69,0x20,0x6D,0x42,0x20,0x20,0x20,0x20
	.DB  0x0,0x4F,0xBE,0xE5,0xB8,0xB8,0x20,0x63
	.DB  0xBA,0x61,0xBD,0xB8,0x70,0x6F,0xB3,0x61
	.DB  0xBD,0xB8,0xC7,0x0,0x54,0x70,0xB8,0x20
	.DB  0xE4,0x61,0xB7,0xC3,0x20,0x3C,0x3C,0x3C
	.DB  0x0,0x4F,0xE3,0xBD,0x61,0x20,0xE4,0x61
	.DB  0xB7,0x61,0x20,0x20,0x20,0x0,0x54,0x70
	.DB  0xB8,0x20,0xE4,0x61,0xB7,0xC3,0x20,0x20
	.DB  0x20,0x0,0x4F,0xE3,0xBD,0x61,0x20,0xE4
	.DB  0x61,0xB7,0x61,0x20,0x3C,0x3C,0x3C,0x0
	.DB  0x42,0xC3,0xB2,0x65,0x70,0xB8,0xBF,0x65
	.DB  0x20,0xE4,0x61,0xB7,0x79,0x0,0xAA,0x61
	.DB  0xB7,0x61,0x20,0x20,0x41,0x20,0x20,0x3C
	.DB  0x3C,0x3C,0x0,0xAA,0x61,0xB7,0x61,0x20
	.DB  0x20,0x42,0x20,0x20,0x20,0x20,0x20,0x0
	.DB  0xAA,0x61,0xB7,0x61,0x20,0x20,0x43,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0xAA,0x61,0xB7
	.DB  0x61,0x20,0x20,0x41,0x20,0x20,0x20,0x20
	.DB  0x20,0x0,0xAA,0x61,0xB7,0x61,0x20,0x20
	.DB  0x42,0x20,0x20,0x3C,0x3C,0x3C,0x0,0xAA
	.DB  0x61,0xB7,0x61,0x20,0x20,0x43,0x20,0x20
	.DB  0x3C,0x3C,0x3C,0x0,0x4F,0x63,0xBF,0x61
	.DB  0xBD,0x6F,0xB3,0xB8,0xBF,0xC4,0x20,0x63
	.DB  0xBA,0x61,0xBD,0x65,0x70,0x3F,0x20,0x0
	.DB  0x48,0x61,0xB6,0xBC,0xB8,0xBF,0x65,0x20
	.DB  0x3E,0x3E,0x44,0x3C,0x3C,0x0,0x48,0x61
	.DB  0x63,0xBF,0x70,0x6F,0xB9,0xBA,0xB8,0x20
	.DB  0x20,0x3C,0x3C,0x3C,0x0,0x42,0x70,0x65
	.DB  0xBC,0xC7,0x0,0x43,0xBF,0x61,0xBF,0xB8
	.DB  0x63,0xBF,0xB8,0xBA,0x61,0x0,0x52,0x45
	.DB  0x53,0x45,0x54,0x0,0x48,0x61,0x63,0xBF
	.DB  0x70,0x6F,0xB9,0xBA,0xB8,0x0,0x42,0x70
	.DB  0x65,0xBC,0xC7,0x20,0x20,0x20,0x20,0x3C
	.DB  0x3C,0x3C,0x0,0x43,0xBF,0x61,0xBF,0xB8
	.DB  0x63,0xBF,0xB8,0xBA,0x61,0x20,0x20,0x3C
	.DB  0x3C,0x3C,0x0,0x52,0x45,0x53,0x45,0x54
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x3C,0x3C
	.DB  0x3C,0x0,0x55,0x20,0xBD,0x6F,0xBC,0xB8
	.DB  0xBD,0x61,0xBB,0xC4,0xBD,0x6F,0x65,0x20
	.DB  0x3C,0x3C,0x3C,0x0,0x55,0x20,0xBC,0xB8
	.DB  0xBD,0xB8,0xBC,0x61,0xBB,0xC4,0xBD,0x6F
	.DB  0x65,0x0,0x55,0x20,0xBC,0x61,0xBA,0x63
	.DB  0xB8,0xBC,0x61,0xBB,0xC4,0xBD,0x6F,0x65
	.DB  0x0,0xA4,0x61,0xE3,0x65,0x70,0xB6,0xBA
	.DB  0x61,0x20,0x20,0x0,0x55,0x20,0xBD,0x6F
	.DB  0xBC,0xB8,0xBD,0x61,0xBB,0xC4,0xBD,0x6F
	.DB  0x65,0x0,0x55,0x20,0xBC,0xB8,0xBD,0xB8
	.DB  0xBC,0x61,0xBB,0xC4,0xBD,0x6F,0x65,0x20
	.DB  0x3C,0x3C,0x3C,0x0,0x55,0x20,0xBC,0x61
	.DB  0xBA,0x63,0xB8,0xBC,0x61,0xBB,0xC4,0xBD
	.DB  0x6F,0x65,0x20,0x3C,0x3C,0x3C,0x0,0x55
	.DB  0x20,0xBC,0x61,0xBA,0x63,0xB8,0xBC,0x61
	.DB  0xBB,0xC4,0xBD,0x6F,0x65,0x20,0x20,0x0
	.DB  0xA4,0x61,0xE3,0x65,0x70,0xB6,0xBA,0x61
	.DB  0x20,0x3C,0x3C,0x3C,0x0,0x48,0x6F,0xBC
	.DB  0xB8,0xBD,0x61,0xBB,0xC4,0xBD,0x6F,0x65
	.DB  0x0,0x20,0x20,0xBD,0x61,0xBE,0x70,0xC7
	.DB  0xB6,0x65,0xBD,0xB8,0x65,0x0,0x55,0x6E
	.DB  0x20,0x3D,0x20,0x25,0x75,0x56,0x20,0x0
	.DB  0x4D,0xB8,0xBD,0xB8,0xBC,0x61,0xBB,0xC4
	.DB  0xBD,0x6F,0x65,0x20,0x0,0x55,0x2A,0x3D
	.DB  0x25,0x75,0x20,0xBE,0x70,0x6F,0xE5,0x65
	.DB  0xBD,0xBF,0x6F,0xB3,0x0,0x55,0x6D,0x69
	.DB  0x6E,0x3D,0x25,0x75,0x20,0x56,0x0,0x4D
	.DB  0x61,0xBA,0x63,0xB8,0xBC,0x61,0xBB,0xC4
	.DB  0xBD,0x6F,0x65,0x0,0x55,0x6D,0x61,0x78
	.DB  0x3D,0x25,0x75,0x20,0x56,0x0,0xA4,0x61
	.DB  0xE3,0x65,0x70,0xB6,0xBA,0x61,0x20,0x70
	.DB  0x65,0xB4,0xB8,0x63,0xBF,0x70,0x61,0xE5
	.DB  0xB8,0xB8,0x0,0x54,0x3D,0x25,0x75,0x20
	.DB  0xBC,0xB8,0xBB,0xB8,0x63,0x65,0xBA,0x79
	.DB  0xBD,0xE3,0x0,0x48,0x61,0x63,0xBF,0x70
	.DB  0x6F,0xB9,0xBA,0x61,0x20,0xC0,0x61,0x63
	.DB  0x6F,0xB3,0x0,0xAB,0x61,0x63,0xC3,0x0
	.DB  0xE0,0x61,0xBF,0x61,0x20,0x25,0x69,0x2E
	.DB  0x25,0x69,0x2E,0x25,0x69,0x0,0x42,0x70
	.DB  0x65,0xBC,0xC7,0x20,0x25,0x69,0x3C,0x3A
	.DB  0x25,0x69,0x25,0x69,0x3A,0x25,0x69,0x25
	.DB  0x69,0x20,0x0,0x4D,0xB8,0xBD,0x79,0xBF
	.DB  0xC3,0x0,0x42,0x70,0x65,0xBC,0xC7,0x20
	.DB  0x25,0x69,0x3A,0x25,0x69,0x25,0x69,0x3C
	.DB  0x3A,0x25,0x69,0x25,0x69,0x20,0x0,0x43
	.DB  0x65,0xBA,0x79,0xBD,0xE3,0xC3,0x0,0x42
	.DB  0x70,0x65,0xBC,0xC7,0x20,0x25,0x69,0x3A
	.DB  0x25,0x69,0x25,0x69,0x3A,0x25,0x69,0x25
	.DB  0x69,0x3C,0x20,0x0,0xE0,0xBD,0xB8,0x0
	.DB  0xE0,0x61,0xBF,0x61,0x20,0x25,0x69,0x3C
	.DB  0x2E,0x25,0x69,0x2E,0x25,0x69,0x0,0x42
	.DB  0x70,0x65,0xBC,0xC7,0x20,0x25,0x69,0x3A
	.DB  0x25,0x69,0x25,0x69,0x3A,0x25,0x69,0x25
	.DB  0x69,0x20,0x0,0x4D,0x65,0x63,0xC7,0xE5
	.DB  0x0,0xE0,0x61,0xBF,0x61,0x20,0x25,0x69
	.DB  0x2E,0x25,0x69,0x3C,0x2E,0x25,0x69,0x0
	.DB  0xA1,0x6F,0xE3,0x0,0xE0,0x61,0xBF,0x61
	.DB  0x20,0x25,0x69,0x2E,0x25,0x69,0x2E,0x25
	.DB  0x69,0x3C,0x0,0xAA,0x61,0xB7,0x61,0x20
	.DB  0x20,0x42,0x0,0xAA,0x61,0xB7,0x61,0x20
	.DB  0x20,0x43,0x0,0xAA,0x61,0xB7,0x61,0x20
	.DB  0x20,0x41,0x0,0xAA,0x61,0xB7,0x61,0x20
	.DB  0x20,0x43,0x20,0x20,0x20,0x3C,0x3C,0x3C
	.DB  0x0,0x43,0xBF,0x61,0xBF,0xB8,0x63,0xBF
	.DB  0xB8,0xBA,0x61,0x20,0xE4,0x61,0xB7,0xC3
	.DB  0x20,0x41,0x0,0x4E,0x3D,0x25,0x75,0x20
	.DB  0x20,0x54,0x61,0x3D,0x25,0x75,0x6D,0x25
	.DB  0x75,0x6D,0x63,0x0,0x4E,0x3D,0x25,0x75
	.DB  0x20,0x20,0x54,0x61,0x3D,0x25,0x75,0x6D
	.DB  0x25,0x75,0x63,0x0,0x55,0x61,0x3D,0x25
	.DB  0x75,0x20,0x55,0x61,0x2A,0x3D,0x2B,0x25
	.DB  0x75,0x0,0x55,0x61,0x3D,0x25,0x75,0x20
	.DB  0x55,0x61,0x2A,0x3D,0x2D,0x25,0x75,0x0
	.DB  0x25,0x69,0x3A,0x25,0x69,0x25,0x69,0x20
	.DB  0x2D,0x20,0x25,0x69,0x2F,0x25,0x69,0x20
	.DB  0x20,0x0,0xA9,0xE3,0x61,0xBB,0xB8,0xBF
	.DB  0xC4,0x20,0xBE,0x61,0xBC,0xC7,0xBF,0xC4
	.DB  0x20,0x2D,0x20,0x41,0x20,0x3F,0x0,0xE0
	.DB  0xBB,0xC7,0x20,0x6F,0xBF,0xBC,0x65,0xBD
	.DB  0xC3,0x20,0x2D,0x20,0x4F,0x4B,0x20,0x20
	.DB  0x20,0x20,0x0,0xE0,0xBB,0xC7,0x20,0xBE
	.DB  0x6F,0xE3,0xBF,0xB3,0x65,0x70,0xB6,0xE3
	.DB  0x65,0xBD,0xB8,0xC7,0x20,0x20,0x0,0xBD
	.DB  0x61,0xB6,0xBC,0xB8,0xBF,0x65,0x20,0xBC
	.DB  0xB8,0xBD,0x79,0x63,0x20,0x20,0x20,0x20
	.DB  0x20,0x0,0x43,0xBF,0x61,0xBF,0xB8,0x63
	.DB  0xBF,0xB8,0xBA,0x61,0x20,0xE4,0x61,0xB7
	.DB  0xC3,0x20,0x42,0x0,0x4E,0x3D,0x25,0x75
	.DB  0x20,0x20,0x54,0x62,0x3D,0x25,0x75,0x6D
	.DB  0x25,0x75,0x6D,0x63,0x0,0x4E,0x3D,0x25
	.DB  0x75,0x20,0x20,0x54,0x62,0x3D,0x25,0x75
	.DB  0x6D,0x25,0x75,0x63,0x0,0x55,0x62,0x3D
	.DB  0x25,0x75,0x20,0x55,0x62,0x2A,0x3D,0x2B
	.DB  0x25,0x75,0x0,0x55,0x62,0x3D,0x25,0x75
	.DB  0x20,0x55,0x62,0x2A,0x3D,0x2D,0x25,0x75
	.DB  0x0,0xA9,0xE3,0x61,0xBB,0xB8,0xBF,0xC4
	.DB  0x20,0xBE,0x61,0xBC,0xC7,0xBF,0xC4,0x20
	.DB  0x2D,0x20,0x42,0x20,0x3F,0x0,0x43,0xBF
	.DB  0x61,0xBF,0xB8,0x63,0xBF,0xB8,0xBA,0x61
	.DB  0x20,0xE4,0x61,0xB7,0xC3,0x20,0x43,0x0
	.DB  0x4E,0x3D,0x25,0x75,0x20,0x20,0x54,0x63
	.DB  0x3D,0x25,0x75,0x6D,0x25,0x75,0x6D,0x63
	.DB  0x0,0x4E,0x3D,0x25,0x75,0x20,0x20,0x54
	.DB  0x63,0x3D,0x25,0x75,0x6D,0x25,0x75,0x63
	.DB  0x0,0x55,0x63,0x3D,0x25,0x75,0x20,0x55
	.DB  0x63,0x2A,0x3D,0x2B,0x25,0x75,0x0,0x55
	.DB  0x63,0x3D,0x25,0x75,0x20,0x55,0x63,0x2A
	.DB  0x3D,0x2D,0x25,0x75,0x0,0xA9,0xE3,0x61
	.DB  0xBB,0xB8,0xBF,0xC4,0x20,0xBE,0x61,0xBC
	.DB  0xC7,0xBF,0xC4,0x20,0x2D,0x20,0x43,0x20
	.DB  0x3F,0x0,0x43,0xBA,0x61,0xBD,0x65,0x70
	.DB  0x20,0xB7,0x61,0xBE,0x79,0xE6,0x65,0xBD
	.DB  0x21,0x0,0x43,0xBA,0x61,0xBD,0x65,0x70
	.DB  0x20,0x6F,0x63,0xBF,0x61,0xBD,0x6F,0xB3
	.DB  0xBB,0x65,0xBD,0x21,0x0
_0x2020003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  _t_zad
	.DW  _0x3*2

	.DW  0x0A
	.DW  0x04
	.DW  _0x2EA*2

	.DW  0x02
	.DW  __base_y_G101
	.DW  _0x2020003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.0 Professional
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 25.09.2013
;Author  : NeVaDa
;Company :
;Comments:
;
;
;Chip type               : ATmega32
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 512
;*****************************************************/
;
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;// I2C Bus functions
;#asm
   .equ __i2c_port=0x18 ;PORTB
   .equ __sda_bit=0
   .equ __scl_bit=1
; 0000 001F #endasm
;#include <i2c.h>
;// DS1307 Real Time Clock functions
;#include <ds1307.h>
;#asm
   .equ __lcd_port=0x15 //PORTC
; 0000 0025 #endasm
;// Alphanumeric LCD Module functions
;#include <alcd.h>
;#include <stdio.h>
;#include <string.h>
;#include <sleep.h>   //Power Down
;
;#define stop   TCCR2=0x00;
;#define go     TCCR2=0x01;
;#define go_p   TCCR0=0x02
;#define stop_p TCCR0=0x00
;#define btn_m PINB.7
;#define btn_plus PINB.5
;#define btn_minus PINB.6
;#define btn_d PINB.4
;#define nahalo_timer 0xe0   //  
; #define ADC_VREF_TYPE 0xC0      //    2.5 
;#define mem 37    //     
;#define mini 219  //   
;#define maxi 221  //    
;#define u_min 45  //   
;#define bat_low 378  //  
;#define time_min 1  //     
;
;unsigned char lcd_buffer[128];
;unsigned char flag_b=0,flag_a=0,flag_c=0;
;signed int u_n,u_nnn,u_delta_a=0,u_delta_b=0,u_delta_c=0,u_delta_ua=0,u_delta_ub=0,u_delta_uc=0;
;signed int ua_r=0,ub_r=0,uc_r=0,u_a=0,u_b=0,u_c=0;
;float u_aa=0,u_bb=0,u_cc=0,u_nn;
; signed int u_batp=0;
;unsigned int u_bat=0,sis=0,zar=0;
;float u_batt=0;
;unsigned int tna=0,tnb=0,tnc=0;
;unsigned int t_msa=0,t_msb=0,t_msc=0;
;unsigned long int t_ms=0;
;unsigned char t=0;
;unsigned char menu=0,menu_def=0,i=0,menu_p=0,menu_pp=0,menu_ppp=0,flag=0,rtc=0;
;unsigned char stat_na=0,stat_nb=0,stat_nc=0,flag_st=0;
;float dopusk=0,dop=0,dopusk_m=0,dop_m=0;
;int ddop,ddop_m;
;unsigned char faza=0,izm=0;
;unsigned char go_izm=0,izm_faza=0,rezjim=0,rez=0,del_a=0,del_b=0,del_c=0;
;unsigned int t_zad=10,tt=0,ta=0,tb=0,tc=0;

	.DSEG
;unsigned char hour,minut,sek; //, , 
;unsigned char m,h,s; //, , 
;unsigned int mm=0,hh=0,ss=0; //, , 
;unsigned char day,month,year; //, , 
;unsigned char d,mo,y; //, , 
;unsigned long int sssa=0,temp_sa=0,temp_ssa=0,temp_ma=0,sss=0,sma=0,sha=0; //
;unsigned long int sssb=0,temp_sb=0,temp_ssb=0,temp_mb=0,smb=0,shb=0;
;unsigned long int sssc=0,temp_sc=0,temp_ssc=0,temp_mc=0,smc=0,shc=0;
;unsigned char dat_a=0,dat_b=0,dat_c=0;
;unsigned char mem_a=0, mem_b=0, mem_c=0;
;
;eeprom signed int save[6];
;eeprom unsigned int proval_ua[mem],proval_ub[mem],proval_uc[mem];
;eeprom unsigned int proval_ta[mem],proval_tb[mem],proval_tc[mem];
;eeprom unsigned char proval_tma[mem],proval_tmb[mem],proval_tmc[mem];
;eeprom unsigned char time_ha[mem],time_ma[mem],date_ma[mem],date_da[mem];
;eeprom unsigned char time_hb[mem],time_mb[mem],date_mb[mem],date_db[mem];
;eeprom unsigned char time_hc[mem],time_mc[mem],date_mc[mem],date_dc[mem];
;eeprom unsigned char proval_na,proval_nb,proval_nc;
;
;
;void clear_mem_a()   //    
; 0000 0066 {

	.CSEG
_clear_mem_a:
; 0000 0067     for ( i=0; i<mem; i++) //  
	LDI  R30,LOW(0)
	STS  _i,R30
_0x5:
	LDS  R26,_i
	CPI  R26,LOW(0x25)
	BRSH _0x6
; 0000 0068      {
; 0000 0069       proval_ta[i] =  proval_tma[i] = proval_ua[i]=0;
	LDS  R30,_i
	CALL SUBOPT_0x0
	CALL SUBOPT_0x1
	SUBI R30,LOW(-_proval_tma)
	SBCI R31,HIGH(-_proval_tma)
	MOVW R0,R30
	LDS  R30,_i
	CALL SUBOPT_0x2
	CALL SUBOPT_0x3
; 0000 006A       time_ha[i] = time_ma[i] = date_ma[i] = date_da[i]=0;
	SUBI R30,LOW(-_time_ha)
	SBCI R31,HIGH(-_time_ha)
	PUSH R31
	PUSH R30
	MOVW R30,R26
	SUBI R30,LOW(-_time_ma)
	SBCI R31,HIGH(-_time_ma)
	MOVW R22,R30
	MOVW R30,R0
	SUBI R30,LOW(-_date_ma)
	SBCI R31,HIGH(-_date_ma)
	CALL SUBOPT_0x4
	SUBI R26,LOW(-_date_da)
	SBCI R27,HIGH(-_date_da)
	CALL SUBOPT_0x5
	POP  R26
	POP  R27
	CALL SUBOPT_0x6
; 0000 006B       proval_na=0;
	CALL SUBOPT_0x7
; 0000 006C 
; 0000 006D       lcd_gotoxy(0,1);              //  1    1 
; 0000 006E       sprintf(lcd_buffer,"oo㸿e  - %u  ",i*2); //    
; 0000 006F       lcd_puts(lcd_buffer);         //      
; 0000 0070        lcd_gotoxy(0,2);              //  1    1 
; 0000 0071       sprintf(lcd_buffer,"cpae aǿ-A....",); //     
	__POINTW1FN _0x0,18
	CALL SUBOPT_0x8
; 0000 0072       lcd_puts(lcd_buffer);         //      
; 0000 0073 
; 0000 0074      }
	CALL SUBOPT_0x9
	RJMP _0x5
_0x6:
; 0000 0075      lcd_clear();
	CALL SUBOPT_0xA
; 0000 0076      i=0; mem_a=0;
	STS  _mem_a,R30
; 0000 0077            lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 0078       sprintf(lcd_buffer,"ae-A yoe!",); //     
	__POINTW1FN _0x0,40
	CALL SUBOPT_0x8
; 0000 0079       lcd_puts(lcd_buffer);         //      
; 0000 007A        delay_ms(1000);
	CALL SUBOPT_0xC
; 0000 007B      lcd_clear();
; 0000 007C      del_a=0;
	STS  _del_a,R30
; 0000 007D }
	RET
;
;void clear_mem_b()  //    
; 0000 0080 {
_clear_mem_b:
; 0000 0081     for ( i=0; i<mem; i++) //  
	LDI  R30,LOW(0)
	STS  _i,R30
_0x8:
	LDS  R26,_i
	CPI  R26,LOW(0x25)
	BRSH _0x9
; 0000 0082      {
; 0000 0083       proval_tb[i] =  proval_tmb[i] = proval_ub[i]=0;
	LDS  R30,_i
	CALL SUBOPT_0xD
	CALL SUBOPT_0x1
	SUBI R30,LOW(-_proval_tmb)
	SBCI R31,HIGH(-_proval_tmb)
	MOVW R0,R30
	LDS  R30,_i
	CALL SUBOPT_0xE
	CALL SUBOPT_0x3
; 0000 0084       time_hb[i] = time_mb[i] = date_mb[i] = date_db[i]=0;
	SUBI R30,LOW(-_time_hb)
	SBCI R31,HIGH(-_time_hb)
	PUSH R31
	PUSH R30
	MOVW R30,R26
	SUBI R30,LOW(-_time_mb)
	SBCI R31,HIGH(-_time_mb)
	MOVW R22,R30
	MOVW R30,R0
	SUBI R30,LOW(-_date_mb)
	SBCI R31,HIGH(-_date_mb)
	CALL SUBOPT_0x4
	SUBI R26,LOW(-_date_db)
	SBCI R27,HIGH(-_date_db)
	CALL SUBOPT_0x5
	POP  R26
	POP  R27
	CALL SUBOPT_0xF
; 0000 0085       proval_nb=0;
	CALL SUBOPT_0x7
; 0000 0086 
; 0000 0087       lcd_gotoxy(0,1);              //  1    1 
; 0000 0088       sprintf(lcd_buffer,"oo㸿e  - %u  ",i*2); //    
; 0000 0089       lcd_puts(lcd_buffer);         //      
; 0000 008A        lcd_gotoxy(0,2);              //  1    1 
; 0000 008B       sprintf(lcd_buffer,"cpae aǿ-B....",); //     
	__POINTW1FN _0x0,61
	CALL SUBOPT_0x8
; 0000 008C       lcd_puts(lcd_buffer);         //      
; 0000 008D 
; 0000 008E      }
	CALL SUBOPT_0x9
	RJMP _0x8
_0x9:
; 0000 008F      lcd_clear();
	CALL SUBOPT_0xA
; 0000 0090      i=0; mem_b=0;
	STS  _mem_b,R30
; 0000 0091            lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 0092       sprintf(lcd_buffer,"ae-B yoe!",); //     
	__POINTW1FN _0x0,83
	CALL SUBOPT_0x8
; 0000 0093       lcd_puts(lcd_buffer);         //      
; 0000 0094        delay_ms(1000);
	CALL SUBOPT_0xC
; 0000 0095      lcd_clear();
; 0000 0096      del_b=0;
	STS  _del_b,R30
; 0000 0097 }
	RET
;
;void clear_mem_c()     //    
; 0000 009A {
_clear_mem_c:
; 0000 009B     for ( i=0; i<mem; i++) //  
	LDI  R30,LOW(0)
	STS  _i,R30
_0xB:
	LDS  R26,_i
	CPI  R26,LOW(0x25)
	BRSH _0xC
; 0000 009C      {
; 0000 009D       proval_tc[i] =  proval_tmc[i] = proval_uc[i]=0;
	LDS  R30,_i
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1
	SUBI R30,LOW(-_proval_tmc)
	SBCI R31,HIGH(-_proval_tmc)
	MOVW R0,R30
	LDS  R30,_i
	CALL SUBOPT_0x11
	CALL SUBOPT_0x3
; 0000 009E       time_hc[i] = time_mc[i] = date_mc[i] = date_dc[i]=0;
	SUBI R30,LOW(-_time_hc)
	SBCI R31,HIGH(-_time_hc)
	PUSH R31
	PUSH R30
	MOVW R30,R26
	SUBI R30,LOW(-_time_mc)
	SBCI R31,HIGH(-_time_mc)
	MOVW R22,R30
	MOVW R30,R0
	SUBI R30,LOW(-_date_mc)
	SBCI R31,HIGH(-_date_mc)
	CALL SUBOPT_0x4
	SUBI R26,LOW(-_date_dc)
	SBCI R27,HIGH(-_date_dc)
	CALL SUBOPT_0x5
	POP  R26
	POP  R27
	CALL SUBOPT_0x12
; 0000 009F       proval_nc=0;
	CALL SUBOPT_0x7
; 0000 00A0 
; 0000 00A1       lcd_gotoxy(0,1);              //  1    1 
; 0000 00A2       sprintf(lcd_buffer,"oo㸿e  - %u  ",i*2); //    
; 0000 00A3       lcd_puts(lcd_buffer);         //      
; 0000 00A4        lcd_gotoxy(0,2);              //  1    1 
; 0000 00A5       sprintf(lcd_buffer,"cpae aǿ-C....",); //     
	__POINTW1FN _0x0,104
	CALL SUBOPT_0x8
; 0000 00A6       lcd_puts(lcd_buffer);         //      
; 0000 00A7 
; 0000 00A8      }
	CALL SUBOPT_0x9
	RJMP _0xB
_0xC:
; 0000 00A9      lcd_clear();
	CALL SUBOPT_0xA
; 0000 00AA      i=0; mem_c=0;
	STS  _mem_c,R30
; 0000 00AB            lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 00AC       sprintf(lcd_buffer,"ae-C yoe!",); //     
	__POINTW1FN _0x0,126
	CALL SUBOPT_0x8
; 0000 00AD       lcd_puts(lcd_buffer);         //      
; 0000 00AE        delay_ms(1000);
	CALL SUBOPT_0xC
; 0000 00AF      lcd_clear();
; 0000 00B0      del_c=0;
	STS  _del_c,R30
; 0000 00B1 }
	RET
;
;void clear_mem()    //   
; 0000 00B4  {
_clear_mem:
; 0000 00B5     clear_mem_a();
	RCALL _clear_mem_a
; 0000 00B6     clear_mem_b();
	RCALL _clear_mem_b
; 0000 00B7     clear_mem_c();
	RCALL _clear_mem_c
; 0000 00B8            lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 00B9       sprintf(lcd_buffer,"ae yoe!",); //     
	__POINTW1FN _0x0,147
	CALL SUBOPT_0x8
; 0000 00BA       lcd_puts(lcd_buffer);         //      
; 0000 00BB        lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 00BC       sprintf(lcd_buffer,"Cpoc þoe!",); //     
	__POINTW1FN _0x0,166
	CALL SUBOPT_0x8
; 0000 00BD       lcd_puts(lcd_buffer);         //      
; 0000 00BE        delay_ms(1000);
	CALL SUBOPT_0x14
; 0000 00BF      lcd_clear();
	RJMP _0x20E0005
; 0000 00C0 
; 0000 00C1  }
;
;void start_mem()    //      
; 0000 00C4 {
_start_mem:
; 0000 00C5 
; 0000 00C6         lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 00C7        sprintf(lcd_buffer,"Pecpaop poao"); //     
	__POINTW1FN _0x0,182
	CALL SUBOPT_0x8
; 0000 00C8        lcd_puts(lcd_buffer);         //      
; 0000 00C9        lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 00CA        sprintf(lcd_buffer,"      MP-3/1      "); //      
	__POINTW1FN _0x0,203
	CALL SUBOPT_0x8
; 0000 00CB        lcd_puts(lcd_buffer);         //      
; 0000 00CC        lcd_gotoxy(0,3);              //  2    1 
	CALL SUBOPT_0x16
; 0000 00CD        sprintf(lcd_buffer,"apya......" ); //    
	__POINTW1FN _0x0,223
	CALL SUBOPT_0x8
; 0000 00CE        lcd_puts(lcd_buffer);         //      
; 0000 00CF 
; 0000 00D0        delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	CALL SUBOPT_0x17
; 0000 00D1             lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x13
; 0000 00D2        sprintf(lcd_buffer," cpoca ae" ); //       -
	__POINTW1FN _0x0,238
	CALL SUBOPT_0x8
; 0000 00D3        lcd_puts(lcd_buffer);         //      
; 0000 00D4             lcd_gotoxy(0,3);              //  2    1 
	CALL SUBOPT_0x16
; 0000 00D5        sprintf(lcd_buffer," yepae yc" ); //       -
	__POINTW1FN _0x0,257
	CALL SUBOPT_0x8
; 0000 00D6        lcd_puts(lcd_buffer);         //      
; 0000 00D7        delay_ms(5000);
	LDI  R30,LOW(5000)
	LDI  R31,HIGH(5000)
	CALL SUBOPT_0x17
; 0000 00D8        lcd_clear();
	CALL _lcd_clear
; 0000 00D9 
; 0000 00DA          if(btn_minus==0)    //reset
	SBIC 0x16,6
	RJMP _0xD
; 0000 00DB          {
; 0000 00DC           save[0]=0;
	CALL SUBOPT_0x18
; 0000 00DD           save[5]=0;
	CALL SUBOPT_0x19
; 0000 00DE           }    // 
; 0000 00DF 
; 0000 00E0                if(save[0]==1) //   
_0xD:
	LDI  R26,LOW(_save)
	LDI  R27,HIGH(_save)
	CALL __EEPROMRDW
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xE
; 0000 00E1                {
; 0000 00E2                 u_n=save[1];
	__POINTW2MN _save,2
	CALL __EEPROMRDW
	MOVW R8,R30
; 0000 00E3                 ddop=save[2];
	__POINTW2MN _save,4
	CALL __EEPROMRDW
	CALL SUBOPT_0x1A
; 0000 00E4                 ddop_m=save[3];
	__POINTW2MN _save,6
	CALL __EEPROMRDW
	CALL SUBOPT_0x1B
; 0000 00E5                 t_zad=save[4];
	__POINTW2MN _save,8
	CALL __EEPROMRDW
	RJMP _0x2DB
; 0000 00E6                }
; 0000 00E7                else
_0xE:
; 0000 00E8                {
; 0000 00E9                clear_mem();
	RCALL _clear_mem
; 0000 00EA                u_n=220;
	LDI  R30,LOW(220)
	LDI  R31,HIGH(220)
	MOVW R8,R30
; 0000 00EB                ddop=90;
	LDI  R30,LOW(90)
	LDI  R31,HIGH(90)
	CALL SUBOPT_0x1A
; 0000 00EC                ddop_m=90;
	LDI  R30,LOW(90)
	LDI  R31,HIGH(90)
	CALL SUBOPT_0x1B
; 0000 00ED                t_zad=10;
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
_0x2DB:
	STS  _t_zad,R30
	STS  _t_zad+1,R31
; 0000 00EE 
; 0000 00EF                }
; 0000 00F0        lcd_clear();
_0x20E0005:
	CALL _lcd_clear
; 0000 00F1 }
	RET
;
;
;void slep()  //  
; 0000 00F5 {
_slep:
; 0000 00F6         lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 00F7          sprintf(lcd_buffer,"Pe oeoo",); //     
	__POINTW1FN _0x0,277
	CALL SUBOPT_0x8
; 0000 00F8          lcd_puts(lcd_buffer);         //      
; 0000 00F9          lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 00FA          sprintf(lcd_buffer,"Žepoopee",); //   
	__POINTW1FN _0x0,294
	CALL SUBOPT_0x8
; 0000 00FB          lcd_puts(lcd_buffer);         //      
; 0000 00FC                  lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 00FD          sprintf(lcd_buffer,"apoa!",); //    !
	__POINTW1FN _0x0,312
	CALL SUBOPT_0x8
; 0000 00FE          lcd_puts(lcd_buffer);         //      
; 0000 00FF          lcd_gotoxy(0,3);              //  1    1 
	CALL SUBOPT_0x16
; 0000 0100          sprintf(lcd_buffer,"Búa ae!",); //    
	__POINTW1FN _0x0,325
	CALL SUBOPT_0x8
; 0000 0101          lcd_puts(lcd_buffer);         //      
; 0000 0102          delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	CALL SUBOPT_0x17
; 0000 0103           lcd_clear();
	CALL _lcd_clear
; 0000 0104        TIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x39,R30
; 0000 0105        TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0106        TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0107        TCCR0=0x00;
	OUT  0x33,R30
; 0000 0108        TCCR2=0x00;
	OUT  0x25,R30
; 0000 0109        sleep_enable();
	CALL _sleep_enable
; 0000 010A        powerdown();
	CALL _powerdown
; 0000 010B        #asm("sleep");
	sleep
; 0000 010C 
; 0000 010D }
	RET
;
;void read_time()  //  
; 0000 0110  {
_read_time:
; 0000 0111    rtc_get_time(&hour,&minut,&sek); // 
	LDI  R30,LOW(_hour)
	LDI  R31,HIGH(_hour)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_minut)
	LDI  R31,HIGH(_minut)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_sek)
	LDI  R31,HIGH(_sek)
	ST   -Y,R31
	ST   -Y,R30
	CALL _rtc_get_time
; 0000 0112    h=hour;
	LDS  R30,_hour
	STS  _h,R30
; 0000 0113    m=minut;
	LDS  R30,_minut
	STS  _m,R30
; 0000 0114    s=sek;
	LDS  R30,_sek
	STS  _s,R30
; 0000 0115  }
	RET
;
;void read_date() //  
; 0000 0118  {
_read_date:
; 0000 0119    rtc_get_date(&day,&month,&year); // 
	LDI  R30,LOW(_day)
	LDI  R31,HIGH(_day)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_month)
	LDI  R31,HIGH(_month)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_year)
	LDI  R31,HIGH(_year)
	ST   -Y,R31
	ST   -Y,R30
	CALL _rtc_get_date
; 0000 011A    d=day;
	LDS  R30,_day
	STS  _d,R30
; 0000 011B    mo=month;
	LDS  R30,_month
	STS  _mo,R30
; 0000 011C    y=year;
	LDS  R30,_year
	STS  _y,R30
; 0000 011D  }
	RET
;
;//    
;unsigned int read_adc(unsigned char adc_input)
; 0000 0121 {
_read_adc:
; 0000 0122 ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,LOW(0xC0)
	OUT  0x7,R30
; 0000 0123 // Delay needed for the stabilization of the ADC input voltage
; 0000 0124 delay_us(10);
	__DELAY_USB 53
; 0000 0125 // Start the AD conversion
; 0000 0126 ADCSRA|=0x40;
	SBI  0x6,6
; 0000 0127 // Wait for the AD conversion to complete
; 0000 0128 while ((ADCSRA & 0x10)==0);
_0x10:
	SBIS 0x6,4
	RJMP _0x10
; 0000 0129 ADCSRA|=0x10;
	SBI  0x6,4
; 0000 012A return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
; 0000 012B }
;
;//   0 -  
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 012F {
_ext_int0_isr:
	CALL SUBOPT_0x1C
; 0000 0130  if(izm==0){go_p;izm=1;ta=0;}
	BRNE _0x13
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0000 0131   faza=1;
_0x13:
	LDI  R30,LOW(1)
	RJMP _0x2E9
; 0000 0132 }
;
;//   1  -  
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 0136 {
_ext_int1_isr:
	CALL SUBOPT_0x1C
; 0000 0137   if(izm==0){go_p;izm=1;tb=0;}
	BRNE _0x14
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1F
; 0000 0138   faza=2;
_0x14:
	LDI  R30,LOW(2)
	RJMP _0x2E9
; 0000 0139 }
;
;//   2  -  
;interrupt [EXT_INT2] void ext_int2_isr(void)
; 0000 013D {
_ext_int2_isr:
	CALL SUBOPT_0x1C
; 0000 013E  if(izm==0){go_p;izm=1;tc=0;}
	BRNE _0x15
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x20
; 0000 013F   faza=3;
_0x15:
	LDI  R30,LOW(3)
_0x2E9:
	STS  _faza,R30
; 0000 0140 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;//  Timer 0 -    
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0144  {
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0145   TCNT0=0x86;
	LDI  R30,LOW(134)
	OUT  0x32,R30
; 0000 0146   t++; //...
	INC  R6
; 0000 0147   if(t==49)
	LDI  R30,LOW(49)
	CP   R30,R6
	BREQ PC+3
	JMP _0x16
; 0000 0148   {
; 0000 0149   //  5  -   
; 0000 014A     if(rezjim==0)
	LDS  R30,_rezjim
	CPI  R30,0
	BRNE _0x17
; 0000 014B    {
; 0000 014C    if(faza==1&&izm==1){u_a=read_adc(0)*2;ta=0;}
	LDS  R26,_faza
	CPI  R26,LOW(0x1)
	BRNE _0x19
	LDS  R26,_izm
	CPI  R26,LOW(0x1)
	BREQ _0x1A
_0x19:
	RJMP _0x18
_0x1A:
	CALL SUBOPT_0x21
; 0000 014D    if(faza==2&&izm==2){u_b=read_adc(1)*2;tb=0;}
_0x18:
	LDS  R26,_faza
	CPI  R26,LOW(0x2)
	BRNE _0x1C
	LDS  R26,_izm
	CPI  R26,LOW(0x2)
	BREQ _0x1D
_0x1C:
	RJMP _0x1B
_0x1D:
	CALL SUBOPT_0x22
; 0000 014E    if(faza==3&&izm==3){u_c=read_adc(2)*2;tc=0;}
_0x1B:
	LDS  R26,_faza
	CPI  R26,LOW(0x3)
	BRNE _0x1F
	LDS  R26,_izm
	CPI  R26,LOW(0x3)
	BREQ _0x20
_0x1F:
	RJMP _0x1E
_0x20:
	CALL SUBOPT_0x23
; 0000 014F    }
_0x1E:
; 0000 0150    if(rezjim==1)
_0x17:
	LDS  R26,_rezjim
	CPI  R26,LOW(0x1)
	BRNE _0x21
; 0000 0151    {
; 0000 0152    if(faza==1&&izm==1){u_a=read_adc(0)*2;ta=0;izm_faza=0;}
	LDS  R26,_faza
	CPI  R26,LOW(0x1)
	BRNE _0x23
	LDS  R26,_izm
	CPI  R26,LOW(0x1)
	BREQ _0x24
_0x23:
	RJMP _0x22
_0x24:
	CALL SUBOPT_0x21
	LDI  R30,LOW(0)
	STS  _izm_faza,R30
; 0000 0153    if(faza==2&&izm==2){u_b=read_adc(1)*2;tb=0;izm_faza=1;}
_0x22:
	LDS  R26,_faza
	CPI  R26,LOW(0x2)
	BRNE _0x26
	LDS  R26,_izm
	CPI  R26,LOW(0x2)
	BREQ _0x27
_0x26:
	RJMP _0x25
_0x27:
	CALL SUBOPT_0x22
	LDI  R30,LOW(1)
	STS  _izm_faza,R30
; 0000 0154    if(faza==3&&izm==3){u_c=read_adc(2)*2;tc=0;izm_faza=2;}
_0x25:
	LDS  R26,_faza
	CPI  R26,LOW(0x3)
	BRNE _0x29
	LDS  R26,_izm
	CPI  R26,LOW(0x3)
	BREQ _0x2A
_0x29:
	RJMP _0x28
_0x2A:
	CALL SUBOPT_0x23
	LDI  R30,LOW(2)
	STS  _izm_faza,R30
; 0000 0155    }
_0x28:
; 0000 0156    if(rezjim==2)
_0x21:
	LDS  R26,_rezjim
	CPI  R26,LOW(0x2)
	BRNE _0x2B
; 0000 0157    {
; 0000 0158    if(faza==1&&izm_faza==0&&izm==1){u_a=read_adc(0)*2;ta=0;}
	LDS  R26,_faza
	CPI  R26,LOW(0x1)
	BRNE _0x2D
	LDS  R26,_izm_faza
	CPI  R26,LOW(0x0)
	BRNE _0x2D
	LDS  R26,_izm
	CPI  R26,LOW(0x1)
	BREQ _0x2E
_0x2D:
	RJMP _0x2C
_0x2E:
	CALL SUBOPT_0x21
; 0000 0159    if(faza==2&&izm_faza==1&&izm==2){u_b=read_adc(1)*2;tb=0;}
_0x2C:
	LDS  R26,_faza
	CPI  R26,LOW(0x2)
	BRNE _0x30
	LDS  R26,_izm_faza
	CPI  R26,LOW(0x1)
	BRNE _0x30
	LDS  R26,_izm
	CPI  R26,LOW(0x2)
	BREQ _0x31
_0x30:
	RJMP _0x2F
_0x31:
	CALL SUBOPT_0x22
; 0000 015A    if(faza==3&&izm_faza==2&&izm==3){u_c=read_adc(2)*2;tc=0;}
_0x2F:
	LDS  R26,_faza
	CPI  R26,LOW(0x3)
	BRNE _0x33
	LDS  R26,_izm_faza
	CPI  R26,LOW(0x2)
	BRNE _0x33
	LDS  R26,_izm
	CPI  R26,LOW(0x3)
	BREQ _0x34
_0x33:
	RJMP _0x32
_0x34:
	CALL SUBOPT_0x23
; 0000 015B    }
_0x32:
; 0000 015C   }
_0x2B:
; 0000 015D   if(t>=50){t=0;izm++;}   //   
_0x16:
	LDI  R30,LOW(50)
	CP   R6,R30
	BRLO _0x35
	CLR  R6
	LDS  R30,_izm
	SUBI R30,-LOW(1)
	STS  _izm,R30
; 0000 015E   if(izm>4){izm=0;stop_p;} //   , -  
_0x35:
	LDS  R26,_izm
	CPI  R26,LOW(0x5)
	BRLO _0x36
	LDI  R30,LOW(0)
	STS  _izm,R30
	OUT  0x33,R30
; 0000 015F 
; 0000 0160  }
_0x36:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;//  Timer2 -    
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0164 {
_timer2_ovf_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0165 // Reinitialize Timer2 value
; 0000 0166 TCNT2=0xE0;
	LDI  R30,LOW(224)
	OUT  0x24,R30
; 0000 0167  t_ms++;
	LDI  R26,LOW(_t_ms)
	LDI  R27,HIGH(_t_ms)
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
; 0000 0168 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;
;
;void out_adc() //    
; 0000 016C  {
_out_adc:
; 0000 016D 
; 0000 016E    if(go_izm==1)
	LDS  R26,_go_izm
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x37
; 0000 016F    {
; 0000 0170      //statistika A
; 0000 0171     if(flag_a==2)
	LDI  R30,LOW(2)
	CP   R30,R4
	BRNE _0x38
; 0000 0172     {
; 0000 0173      if(u_a<u_n)
	CALL SUBOPT_0x24
	CP   R26,R8
	CPC  R27,R9
	BRGE _0x39
; 0000 0174      {
; 0000 0175       if(u_a<ua_r)
	CALL SUBOPT_0x25
	CALL SUBOPT_0x24
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x3A
; 0000 0176       {
; 0000 0177        ua_r=u_a;
	CALL SUBOPT_0x26
; 0000 0178        proval_ua[proval_na]=ua_r;
	CALL SUBOPT_0x27
; 0000 0179       }
; 0000 017A       }
_0x3A:
; 0000 017B       else
	RJMP _0x3B
_0x39:
; 0000 017C       {
; 0000 017D           if(u_a>ua_r)
	CALL SUBOPT_0x25
	CALL SUBOPT_0x24
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x3C
; 0000 017E        {
; 0000 017F        ua_r=u_a;
	CALL SUBOPT_0x26
; 0000 0180        proval_ua[proval_na]=ua_r;
	CALL SUBOPT_0x27
; 0000 0181        }
; 0000 0182       }
_0x3C:
_0x3B:
; 0000 0183     }
; 0000 0184         //statistika B
; 0000 0185     if(flag_b==2)
_0x38:
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x3D
; 0000 0186     {
; 0000 0187       if(u_b<u_n)
	CALL SUBOPT_0x28
	CP   R26,R8
	CPC  R27,R9
	BRGE _0x3E
; 0000 0188      {
; 0000 0189       if(u_b<=ub_r)
	CALL SUBOPT_0x29
	CALL SUBOPT_0x28
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x3F
; 0000 018A       {
; 0000 018B        ub_r=u_b;
	CALL SUBOPT_0x2A
; 0000 018C        proval_ub[proval_nb]=ub_r;
	CALL SUBOPT_0x2B
; 0000 018D       }
; 0000 018E       }
_0x3F:
; 0000 018F       else
	RJMP _0x40
_0x3E:
; 0000 0190       {
; 0000 0191        if(u_b>=ub_r)
	CALL SUBOPT_0x29
	CALL SUBOPT_0x28
	CP   R26,R30
	CPC  R27,R31
	BRLT _0x41
; 0000 0192        {
; 0000 0193         ub_r=u_b;
	CALL SUBOPT_0x2A
; 0000 0194         proval_ub[proval_nb]=ub_r;
	CALL SUBOPT_0x2B
; 0000 0195        }
; 0000 0196       }
_0x41:
_0x40:
; 0000 0197     }
; 0000 0198         //statistika C
; 0000 0199     if(flag_c==2)
_0x3D:
	LDI  R30,LOW(2)
	CP   R30,R7
	BRNE _0x42
; 0000 019A     {
; 0000 019B            if(u_c<u_n)
	CALL SUBOPT_0x2C
	CP   R26,R8
	CPC  R27,R9
	BRGE _0x43
; 0000 019C      {
; 0000 019D       if(u_c<=uc_r)
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x2C
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x44
; 0000 019E       {
; 0000 019F        uc_r=u_c;
	CALL SUBOPT_0x2E
; 0000 01A0        proval_uc[proval_nc]=uc_r;
	CALL SUBOPT_0x2F
; 0000 01A1       }
; 0000 01A2      }
_0x44:
; 0000 01A3       else
	RJMP _0x45
_0x43:
; 0000 01A4       {
; 0000 01A5           if(u_c>uc_r)
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x2C
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x46
; 0000 01A6        {
; 0000 01A7        uc_r=u_c;
	CALL SUBOPT_0x2E
; 0000 01A8        proval_uc[proval_nc]=uc_r;
	CALL SUBOPT_0x2F
; 0000 01A9        }
; 0000 01AA       }
_0x46:
_0x45:
; 0000 01AB     }
; 0000 01AC 
; 0000 01AD    }
_0x42:
; 0000 01AE     //  minimuma
; 0000 01AF     dopusk=ddop;
_0x37:
	CALL SUBOPT_0x30
	LDI  R26,LOW(_dopusk)
	LDI  R27,HIGH(_dopusk)
	CALL SUBOPT_0x31
; 0000 01B0    dop=dopusk/100;
	LDS  R26,_dopusk
	LDS  R27,_dopusk+1
	LDS  R24,_dopusk+2
	LDS  R25,_dopusk+3
	CALL SUBOPT_0x32
	CALL SUBOPT_0x33
; 0000 01B1         //  maximuma
; 0000 01B2     dopusk_m=ddop_m;
	CALL SUBOPT_0x34
	LDI  R26,LOW(_dopusk_m)
	LDI  R27,HIGH(_dopusk_m)
	CALL SUBOPT_0x31
; 0000 01B3    dop_m=dopusk_m/100;
	LDS  R26,_dopusk_m
	LDS  R27,_dopusk_m+1
	LDS  R24,_dopusk_m+2
	LDS  R25,_dopusk_m+3
	CALL SUBOPT_0x32
	CALL SUBOPT_0x35
; 0000 01B4    //A
; 0000 01B5    //   
; 0000 01B6    u_aa=u_a; u_nn=u_n;
	CALL SUBOPT_0x36
	LDI  R26,LOW(_u_aa)
	LDI  R27,HIGH(_u_aa)
	CALL SUBOPT_0x31
	CALL SUBOPT_0x37
; 0000 01B7    if(u_a>u_n){ u_delta_a=((u_nn*100-u_aa*100)/u_nn*-100); }
	CALL SUBOPT_0x24
	CP   R8,R26
	CPC  R9,R27
	BRGE _0x47
	CALL SUBOPT_0x38
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x39
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x3A
	CALL SUBOPT_0x3B
	CALL __CFD1
	MOVW R12,R30
; 0000 01B8    if(u_a<u_n){ u_delta_a=((u_nn*100-u_aa*100)/u_nn*100);}
_0x47:
	CALL SUBOPT_0x3C
	BRGE _0x48
	CALL SUBOPT_0x38
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x39
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x3A
	CALL SUBOPT_0x3D
	CALL __CFD1
	MOVW R12,R30
; 0000 01B9    //   
; 0000 01BA      if(u_a>u_n){ u_delta_ua = 65536-(u_n-u_a);}
_0x48:
	CALL SUBOPT_0x24
	CP   R8,R26
	CPC  R9,R27
	BRGE _0x49
	CALL SUBOPT_0x24
	CALL SUBOPT_0x3E
	STS  _u_delta_ua,R30
	STS  _u_delta_ua+1,R31
; 0000 01BB     if(u_a<u_n)  {u_delta_ua = u_n-u_a;  }
_0x49:
	CALL SUBOPT_0x3C
	BRGE _0x4A
	CALL SUBOPT_0x24
	MOVW R30,R8
	SUB  R30,R26
	SBC  R31,R27
	STS  _u_delta_ua,R30
	STS  _u_delta_ua+1,R31
; 0000 01BC      //B
; 0000 01BD    //   
; 0000 01BE    u_bb=u_b; u_nn=u_n;
_0x4A:
	CALL SUBOPT_0x3F
	LDI  R26,LOW(_u_bb)
	LDI  R27,HIGH(_u_bb)
	CALL SUBOPT_0x31
	CALL SUBOPT_0x37
; 0000 01BF    if(u_b>u_n){ u_delta_b=((u_nn*100-u_bb*100)/u_nn*-100); }
	CALL SUBOPT_0x28
	CP   R8,R26
	CPC  R9,R27
	BRGE _0x4B
	CALL SUBOPT_0x38
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x40
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x3A
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x41
; 0000 01C0    if(u_b<u_n){ u_delta_b=((u_nn*100-u_bb*100)/u_nn*100);}
_0x4B:
	CALL SUBOPT_0x42
	BRGE _0x4C
	CALL SUBOPT_0x38
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x40
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x3A
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x41
; 0000 01C1    //   
; 0000 01C2      if(u_b>u_n){ u_delta_ub = 65536-(u_n-u_b);}
_0x4C:
	CALL SUBOPT_0x28
	CP   R8,R26
	CPC  R9,R27
	BRGE _0x4D
	CALL SUBOPT_0x28
	CALL SUBOPT_0x3E
	STS  _u_delta_ub,R30
	STS  _u_delta_ub+1,R31
; 0000 01C3     if(u_b<u_n)  {u_delta_ub = u_n-u_b;  }
_0x4D:
	CALL SUBOPT_0x42
	BRGE _0x4E
	CALL SUBOPT_0x28
	MOVW R30,R8
	SUB  R30,R26
	SBC  R31,R27
	STS  _u_delta_ub,R30
	STS  _u_delta_ub+1,R31
; 0000 01C4      //C
; 0000 01C5    //   
; 0000 01C6    u_cc=u_c; u_nn=u_n;
_0x4E:
	CALL SUBOPT_0x43
	LDI  R26,LOW(_u_cc)
	LDI  R27,HIGH(_u_cc)
	CALL SUBOPT_0x31
	CALL SUBOPT_0x37
; 0000 01C7    if(u_c>u_n){ u_delta_c=((u_nn*100-u_cc*100)/u_nn*-100); }
	CALL SUBOPT_0x2C
	CP   R8,R26
	CPC  R9,R27
	BRGE _0x4F
	CALL SUBOPT_0x38
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x44
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x3A
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x45
; 0000 01C8    if(u_c<u_n){ u_delta_c=((u_nn*100-u_cc*100)/u_nn*100);}
_0x4F:
	CALL SUBOPT_0x46
	BRGE _0x50
	CALL SUBOPT_0x38
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x44
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x3A
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x45
; 0000 01C9    //   
; 0000 01CA      if(u_c>u_n){ u_delta_uc = 65536-(u_n-u_c);}
_0x50:
	CALL SUBOPT_0x2C
	CP   R8,R26
	CPC  R9,R27
	BRGE _0x51
	CALL SUBOPT_0x2C
	CALL SUBOPT_0x3E
	STS  _u_delta_uc,R30
	STS  _u_delta_uc+1,R31
; 0000 01CB     if(u_c<u_n)  {u_delta_uc = u_n-u_c;  }
_0x51:
	CALL SUBOPT_0x46
	BRGE _0x52
	CALL SUBOPT_0x2C
	MOVW R30,R8
	SUB  R30,R26
	SBC  R31,R27
	STS  _u_delta_uc,R30
	STS  _u_delta_uc+1,R31
; 0000 01CC   }
_0x52:
	RET
;
;  void proval_proverka()  //     
; 0000 01CF   {
_proval_proverka:
; 0000 01D0        ta++; tb++; tc++;      //  
	LDI  R26,LOW(_ta)
	LDI  R27,HIGH(_ta)
	CALL SUBOPT_0x47
	LDI  R26,LOW(_tb)
	LDI  R27,HIGH(_tb)
	CALL SUBOPT_0x47
	LDI  R26,LOW(_tc)
	LDI  R27,HIGH(_tc)
	CALL SUBOPT_0x47
; 0000 01D1      if(ta>=200){u_a=0;ta=0;}
	LDS  R26,_ta
	LDS  R27,_ta+1
	CPI  R26,LOW(0xC8)
	LDI  R30,HIGH(0xC8)
	CPC  R27,R30
	BRLO _0x53
	LDI  R30,LOW(0)
	STS  _u_a,R30
	STS  _u_a+1,R30
	CALL SUBOPT_0x1E
; 0000 01D2      if(tb>=200){u_b=0;tb=0;}
_0x53:
	LDS  R26,_tb
	LDS  R27,_tb+1
	CPI  R26,LOW(0xC8)
	LDI  R30,HIGH(0xC8)
	CPC  R27,R30
	BRLO _0x54
	LDI  R30,LOW(0)
	STS  _u_b,R30
	STS  _u_b+1,R30
	CALL SUBOPT_0x1F
; 0000 01D3      if(tc>=200){u_c=0;tc=0;}
_0x54:
	LDS  R26,_tc
	LDS  R27,_tc+1
	CPI  R26,LOW(0xC8)
	LDI  R30,HIGH(0xC8)
	CPC  R27,R30
	BRLO _0x55
	LDI  R30,LOW(0)
	STS  _u_c,R30
	STS  _u_c+1,R30
	CALL SUBOPT_0x20
; 0000 01D4       dop_m=u_n+(u_n-(u_n*dop_m));
_0x55:
	CALL SUBOPT_0x48
	CALL SUBOPT_0x49
	CALL __MULF12
	CALL SUBOPT_0x49
	CALL __SWAPD12
	CALL __SUBF12
	CALL SUBOPT_0x49
	CALL __ADDF12
	CALL SUBOPT_0x35
; 0000 01D5       dop=u_n*dop;
	CALL SUBOPT_0x4A
	CALL SUBOPT_0x49
	CALL __MULF12
	CALL SUBOPT_0x33
; 0000 01D6    if(go_izm==1)
	LDS  R26,_go_izm
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x56
; 0000 01D7    {
; 0000 01D8 
; 0000 01D9      if(rezjim==1)
	LDS  R26,_rezjim
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x57
; 0000 01DA      {
; 0000 01DB       //   A
; 0000 01DC       if(u_a>dop&&flag_a==2&&u_a<dop_m)    //    
	CALL SUBOPT_0x4B
	BREQ PC+2
	BRCC PC+3
	JMP  _0x59
	LDI  R30,LOW(2)
	CP   R30,R4
	BRNE _0x59
	CALL SUBOPT_0x4C
	BRLO _0x5A
_0x59:
	RJMP _0x58
_0x5A:
; 0000 01DD       {
; 0000 01DE       flag_a=0;
	CALL SUBOPT_0x4D
; 0000 01DF       t_msa=0;
; 0000 01E0       }
; 0000 01E1       if(u_a<u_min){flag_a=0; t_msa=0;}
_0x58:
	CALL SUBOPT_0x24
	SBIW R26,45
	BRGE _0x5B
	CALL SUBOPT_0x4D
; 0000 01E2 
; 0000 01E3       if(mem_a<mem&&u_a>=u_min&&time_ma[proval_na]!=m)
_0x5B:
	LDS  R26,_mem_a
	CPI  R26,LOW(0x25)
	BRSH _0x5D
	CALL SUBOPT_0x24
	SBIW R26,45
	BRLT _0x5D
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x50
	BRNE _0x5E
_0x5D:
	RJMP _0x5C
_0x5E:
; 0000 01E4        {
; 0000 01E5         if(u_a<dop&&flag_a==0)  //    
	CALL SUBOPT_0x4B
	BRSH _0x60
	LDI  R30,LOW(0)
	CP   R30,R4
	BREQ _0x61
_0x60:
	RJMP _0x5F
_0x61:
; 0000 01E6         {
; 0000 01E7         tna=t_ms;
	CALL SUBOPT_0x51
; 0000 01E8         flag_a=1;
; 0000 01E9         go;  // 
; 0000 01EA         ua_r=mini;
	CALL SUBOPT_0x52
; 0000 01EB         lcd_clear();
; 0000 01EC         }
; 0000 01ED          if(u_a>dop_m&&flag_a==0)  //    
_0x5F:
	CALL SUBOPT_0x4C
	BREQ PC+2
	BRCC PC+3
	JMP  _0x63
	LDI  R30,LOW(0)
	CP   R30,R4
	BREQ _0x64
_0x63:
	RJMP _0x62
_0x64:
; 0000 01EE          {
; 0000 01EF          tna=t_ms;
	CALL SUBOPT_0x51
; 0000 01F0          flag_a=1;
; 0000 01F1          go;  // 
; 0000 01F2          ua_r=maxi;
	CALL SUBOPT_0x53
; 0000 01F3          lcd_clear();
; 0000 01F4          }
; 0000 01F5         if(flag_a==1&&t_msa>=t_zad)
_0x62:
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0x66
	CALL SUBOPT_0x54
	CALL SUBOPT_0x55
	BRSH _0x67
_0x66:
	RJMP _0x65
_0x67:
; 0000 01F6         {
; 0000 01F7         proval_na++;
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x56
; 0000 01F8         mem_a = proval_na;
	CALL SUBOPT_0x4E
	STS  _mem_a,R30
; 0000 01F9         time_ha[proval_na]=h;
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x57
; 0000 01FA         time_ma[proval_na]=m;
	CALL __EEPROMRDB
	CALL SUBOPT_0x4F
	MOVW R26,R30
	LDS  R30,_m
	CALL SUBOPT_0x6
; 0000 01FB         date_ma[proval_na]=mo;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x59
; 0000 01FC         date_da[proval_na]=d;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x5A
; 0000 01FD         temp_sa=s;
; 0000 01FE         flag_a=2;
; 0000 01FF         }
; 0000 0200        }
_0x65:
; 0000 0201        //  B
; 0000 0202        if(u_b>dop&&flag_b==2&&u_b<dop_m)    //    
_0x5C:
	CALL SUBOPT_0x5B
	BREQ PC+2
	BRCC PC+3
	JMP  _0x69
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x69
	CALL SUBOPT_0x5C
	BRLO _0x6A
_0x69:
	RJMP _0x68
_0x6A:
; 0000 0203       {
; 0000 0204       flag_b=0;
	CALL SUBOPT_0x5D
; 0000 0205       t_msb=0;
; 0000 0206       }
; 0000 0207       if(u_b<u_min){flag_b=0; t_msb=0;}
_0x68:
	CALL SUBOPT_0x28
	SBIW R26,45
	BRGE _0x6B
	CALL SUBOPT_0x5D
; 0000 0208 
; 0000 0209       if(mem_b<mem&&u_b>=u_min&&time_mb[proval_nb]!=m)
_0x6B:
	LDS  R26,_mem_b
	CPI  R26,LOW(0x25)
	BRSH _0x6D
	CALL SUBOPT_0x28
	SBIW R26,45
	BRLT _0x6D
	CALL SUBOPT_0x5E
	SUBI R30,LOW(-_time_mb)
	SBCI R31,HIGH(-_time_mb)
	CALL SUBOPT_0x50
	BRNE _0x6E
_0x6D:
	RJMP _0x6C
_0x6E:
; 0000 020A        {
; 0000 020B         if(u_b<dop&&flag_b==0)  //    
	CALL SUBOPT_0x5B
	BRSH _0x70
	LDI  R30,LOW(0)
	CP   R30,R5
	BREQ _0x71
_0x70:
	RJMP _0x6F
_0x71:
; 0000 020C         {
; 0000 020D         tnb=t_ms;
	CALL SUBOPT_0x5F
; 0000 020E         flag_b=1;
; 0000 020F         go;  // 
; 0000 0210         ub_r=mini;
	CALL SUBOPT_0x60
; 0000 0211         lcd_clear();
; 0000 0212         }
; 0000 0213          if(u_b>dop_m&&flag_b==0)  //    
_0x6F:
	CALL SUBOPT_0x5C
	BREQ PC+2
	BRCC PC+3
	JMP  _0x73
	LDI  R30,LOW(0)
	CP   R30,R5
	BREQ _0x74
_0x73:
	RJMP _0x72
_0x74:
; 0000 0214          {
; 0000 0215          tnb=t_ms;
	CALL SUBOPT_0x5F
; 0000 0216          flag_b=1;
; 0000 0217          go;  // 
; 0000 0218          ub_r=maxi;
	CALL SUBOPT_0x61
; 0000 0219          lcd_clear();
; 0000 021A          }
; 0000 021B         if(flag_b==1&&t_msb>=t_zad)
_0x72:
	LDI  R30,LOW(1)
	CP   R30,R5
	BRNE _0x76
	CALL SUBOPT_0x62
	BRSH _0x77
_0x76:
	RJMP _0x75
_0x77:
; 0000 021C         {
; 0000 021D         proval_nb++;
	CALL SUBOPT_0x63
	CALL SUBOPT_0x56
; 0000 021E         mem_b = proval_nb;
	CALL SUBOPT_0x63
	STS  _mem_b,R30
; 0000 021F         time_hb[proval_nb]=h;
	CALL SUBOPT_0x5E
	CALL SUBOPT_0x64
; 0000 0220         time_mb[proval_nb]=m;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x65
; 0000 0221         date_mb[proval_nb]=mo;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x66
; 0000 0222         date_db[proval_nb]=d;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x67
; 0000 0223         temp_sb=s;
; 0000 0224         flag_b=2;
; 0000 0225         }
; 0000 0226        }
_0x75:
; 0000 0227        //   C
; 0000 0228        if(u_c>dop&&flag_c==2&&u_c<dop_m)    //    
_0x6C:
	CALL SUBOPT_0x68
	BREQ PC+2
	BRCC PC+3
	JMP  _0x79
	LDI  R30,LOW(2)
	CP   R30,R7
	BRNE _0x79
	CALL SUBOPT_0x69
	BRLO _0x7A
_0x79:
	RJMP _0x78
_0x7A:
; 0000 0229       {
; 0000 022A       flag_c=0;
	CALL SUBOPT_0x6A
; 0000 022B       t_msc=0;
; 0000 022C       }
; 0000 022D       if(u_c<u_min){flag_c=0; t_msc=0;}
_0x78:
	CALL SUBOPT_0x2C
	SBIW R26,45
	BRGE _0x7B
	CALL SUBOPT_0x6A
; 0000 022E 
; 0000 022F       if(mem_c<mem&&u_c>=u_min&&time_mc[proval_nc]!=m)
_0x7B:
	LDS  R26,_mem_c
	CPI  R26,LOW(0x25)
	BRSH _0x7D
	CALL SUBOPT_0x2C
	SBIW R26,45
	BRLT _0x7D
	CALL SUBOPT_0x6B
	SUBI R30,LOW(-_time_mc)
	SBCI R31,HIGH(-_time_mc)
	CALL SUBOPT_0x50
	BRNE _0x7E
_0x7D:
	RJMP _0x7C
_0x7E:
; 0000 0230        {
; 0000 0231         if(u_c<dop&&flag_c==0)  //    
	CALL SUBOPT_0x68
	BRSH _0x80
	LDI  R30,LOW(0)
	CP   R30,R7
	BREQ _0x81
_0x80:
	RJMP _0x7F
_0x81:
; 0000 0232         {
; 0000 0233         tnc=t_ms;
	CALL SUBOPT_0x6C
; 0000 0234         flag_c=1;
; 0000 0235         go;  // 
; 0000 0236         uc_r=mini;
	CALL SUBOPT_0x6D
; 0000 0237         lcd_clear();
; 0000 0238         }
; 0000 0239          if(u_c>dop_m&&flag_c==0)  //    
_0x7F:
	CALL SUBOPT_0x69
	BREQ PC+2
	BRCC PC+3
	JMP  _0x83
	LDI  R30,LOW(0)
	CP   R30,R7
	BREQ _0x84
_0x83:
	RJMP _0x82
_0x84:
; 0000 023A          {
; 0000 023B          tnc=t_ms;
	CALL SUBOPT_0x6C
; 0000 023C          flag_c=1;
; 0000 023D          go;  // 
; 0000 023E          uc_r=maxi;
	CALL SUBOPT_0x6E
; 0000 023F          lcd_clear();
; 0000 0240          }
; 0000 0241         if(flag_c==1&&t_msc>=t_zad)
_0x82:
	LDI  R30,LOW(1)
	CP   R30,R7
	BRNE _0x86
	CALL SUBOPT_0x6F
	BRSH _0x87
_0x86:
	RJMP _0x85
_0x87:
; 0000 0242         {
; 0000 0243         proval_nc++;
	CALL SUBOPT_0x70
	CALL SUBOPT_0x56
; 0000 0244         mem_c = proval_nc;
	CALL SUBOPT_0x70
	STS  _mem_c,R30
; 0000 0245         time_hc[proval_nc]=h;
	CALL SUBOPT_0x6B
	CALL SUBOPT_0x71
; 0000 0246         time_mc[proval_nc]=m;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x72
; 0000 0247         date_mc[proval_nc]=mo;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x73
; 0000 0248         date_dc[proval_nc]=d;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x74
; 0000 0249         temp_sc=s;
; 0000 024A         flag_c=2;
; 0000 024B         }
; 0000 024C        }
_0x85:
; 0000 024D 
; 0000 024E     }
_0x7C:
; 0000 024F 
; 0000 0250     if(rezjim==2)
_0x57:
	LDS  R26,_rezjim
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0x88
; 0000 0251    {
; 0000 0252       //   A
; 0000 0253      if(izm_faza==0)
	LDS  R30,_izm_faza
	CPI  R30,0
	BREQ PC+3
	JMP _0x89
; 0000 0254       {
; 0000 0255        if(u_a>dop&&flag_a==2&&u_a<dop_m)    //    
	CALL SUBOPT_0x4B
	BREQ PC+2
	BRCC PC+3
	JMP  _0x8B
	LDI  R30,LOW(2)
	CP   R30,R4
	BRNE _0x8B
	CALL SUBOPT_0x4C
	BRLO _0x8C
_0x8B:
	RJMP _0x8A
_0x8C:
; 0000 0256        {
; 0000 0257        flag_a=0;
	CALL SUBOPT_0x4D
; 0000 0258        t_msa=0;
; 0000 0259        }
; 0000 025A        if(u_a<u_min){flag_a=0; t_msa=0;}
_0x8A:
	CALL SUBOPT_0x24
	SBIW R26,45
	BRGE _0x8D
	CALL SUBOPT_0x4D
; 0000 025B 
; 0000 025C        if(mem_a<mem&&u_a>=u_min&&time_ma[proval_na]!=m)
_0x8D:
	LDS  R26,_mem_a
	CPI  R26,LOW(0x25)
	BRSH _0x8F
	CALL SUBOPT_0x24
	SBIW R26,45
	BRLT _0x8F
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x50
	BRNE _0x90
_0x8F:
	RJMP _0x8E
_0x90:
; 0000 025D        {
; 0000 025E         if(u_a<dop&&flag_a==0)  //    
	CALL SUBOPT_0x4B
	BRSH _0x92
	LDI  R30,LOW(0)
	CP   R30,R4
	BREQ _0x93
_0x92:
	RJMP _0x91
_0x93:
; 0000 025F         {
; 0000 0260         tna=t_ms;
	CALL SUBOPT_0x51
; 0000 0261         flag_a=1;
; 0000 0262         go;  // 
; 0000 0263         ua_r=mini;
	CALL SUBOPT_0x52
; 0000 0264         lcd_clear();
; 0000 0265         }
; 0000 0266         if(u_a>dop_m&&flag_a==0)  //    
_0x91:
	CALL SUBOPT_0x4C
	BREQ PC+2
	BRCC PC+3
	JMP  _0x95
	LDI  R30,LOW(0)
	CP   R30,R4
	BREQ _0x96
_0x95:
	RJMP _0x94
_0x96:
; 0000 0267         {
; 0000 0268         tna=t_ms;
	CALL SUBOPT_0x51
; 0000 0269         flag_a=1;
; 0000 026A         go;  // 
; 0000 026B         ua_r=maxi;
	CALL SUBOPT_0x53
; 0000 026C         lcd_clear();
; 0000 026D         }
; 0000 026E         if(flag_a==1&&t_msa>=t_zad)
_0x94:
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0x98
	CALL SUBOPT_0x54
	CALL SUBOPT_0x55
	BRSH _0x99
_0x98:
	RJMP _0x97
_0x99:
; 0000 026F         {
; 0000 0270         proval_na++;
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x56
; 0000 0271         mem_a = proval_na;
	CALL SUBOPT_0x4E
	STS  _mem_a,R30
; 0000 0272         time_ha[proval_na]=h;
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x57
; 0000 0273         time_ma[proval_na]=m;
	CALL __EEPROMRDB
	CALL SUBOPT_0x4F
	MOVW R26,R30
	LDS  R30,_m
	CALL SUBOPT_0x6
; 0000 0274         date_ma[proval_na]=mo;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x59
; 0000 0275         date_da[proval_na]=d;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x5A
; 0000 0276         temp_sa=s;
; 0000 0277         flag_a=2;
; 0000 0278         }
; 0000 0279        }
_0x97:
; 0000 027A       }
_0x8E:
; 0000 027B        //  B
; 0000 027C      if(izm_faza==1)
_0x89:
	LDS  R26,_izm_faza
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x9A
; 0000 027D       {
; 0000 027E       if(u_b>dop&&flag_b==2&&u_b<dop_m)    //    
	CALL SUBOPT_0x5B
	BREQ PC+2
	BRCC PC+3
	JMP  _0x9C
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x9C
	CALL SUBOPT_0x5C
	BRLO _0x9D
_0x9C:
	RJMP _0x9B
_0x9D:
; 0000 027F       {
; 0000 0280       flag_b=0;
	CALL SUBOPT_0x5D
; 0000 0281       t_msb=0;
; 0000 0282       }
; 0000 0283       if(u_b<u_min){flag_b=0; t_msb=0;}
_0x9B:
	CALL SUBOPT_0x28
	SBIW R26,45
	BRGE _0x9E
	CALL SUBOPT_0x5D
; 0000 0284 
; 0000 0285       if(mem_b<mem&&u_b>=u_min&&time_mb[proval_nb]!=m)
_0x9E:
	LDS  R26,_mem_b
	CPI  R26,LOW(0x25)
	BRSH _0xA0
	CALL SUBOPT_0x28
	SBIW R26,45
	BRLT _0xA0
	CALL SUBOPT_0x5E
	SUBI R30,LOW(-_time_mb)
	SBCI R31,HIGH(-_time_mb)
	CALL SUBOPT_0x50
	BRNE _0xA1
_0xA0:
	RJMP _0x9F
_0xA1:
; 0000 0286       {
; 0000 0287         if(u_b<dop&&flag_b==0)  //    
	CALL SUBOPT_0x5B
	BRSH _0xA3
	LDI  R30,LOW(0)
	CP   R30,R5
	BREQ _0xA4
_0xA3:
	RJMP _0xA2
_0xA4:
; 0000 0288         {
; 0000 0289        tnb=t_ms;
	CALL SUBOPT_0x5F
; 0000 028A        flag_b=1;
; 0000 028B        go;  // 
; 0000 028C        ub_r=mini;
	CALL SUBOPT_0x60
; 0000 028D        lcd_clear();
; 0000 028E        }
; 0000 028F        if(u_b>dop_m&&flag_b==0)  //    
_0xA2:
	CALL SUBOPT_0x5C
	BREQ PC+2
	BRCC PC+3
	JMP  _0xA6
	LDI  R30,LOW(0)
	CP   R30,R5
	BREQ _0xA7
_0xA6:
	RJMP _0xA5
_0xA7:
; 0000 0290         {
; 0000 0291        tnb=t_ms;
	CALL SUBOPT_0x5F
; 0000 0292        flag_b=1;
; 0000 0293        go;  // 
; 0000 0294        ub_r=maxi;
	CALL SUBOPT_0x61
; 0000 0295        lcd_clear();
; 0000 0296        }
; 0000 0297        if(flag_b==1&&t_msb>=t_zad)
_0xA5:
	LDI  R30,LOW(1)
	CP   R30,R5
	BRNE _0xA9
	CALL SUBOPT_0x62
	BRSH _0xAA
_0xA9:
	RJMP _0xA8
_0xAA:
; 0000 0298        {
; 0000 0299         proval_nb++;
	CALL SUBOPT_0x63
	CALL SUBOPT_0x56
; 0000 029A         mem_b = proval_nb;
	CALL SUBOPT_0x63
	STS  _mem_b,R30
; 0000 029B         time_hb[proval_nb]=h;
	CALL SUBOPT_0x5E
	CALL SUBOPT_0x64
; 0000 029C         time_mb[proval_nb]=m;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x65
; 0000 029D         date_mb[proval_nb]=mo;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x66
; 0000 029E         date_db[proval_nb]=d;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x67
; 0000 029F         temp_sb=s;
; 0000 02A0         flag_b=2;
; 0000 02A1        }
; 0000 02A2       }
_0xA8:
; 0000 02A3      }
_0x9F:
; 0000 02A4       //   C
; 0000 02A5      if(izm_faza==2)
_0x9A:
	LDS  R26,_izm_faza
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0xAB
; 0000 02A6       {
; 0000 02A7       if(u_c>dop&&flag_c==2&&u_c<dop_m)    //    
	CALL SUBOPT_0x68
	BREQ PC+2
	BRCC PC+3
	JMP  _0xAD
	LDI  R30,LOW(2)
	CP   R30,R7
	BRNE _0xAD
	CALL SUBOPT_0x69
	BRLO _0xAE
_0xAD:
	RJMP _0xAC
_0xAE:
; 0000 02A8       {
; 0000 02A9       flag_c=0;
	CALL SUBOPT_0x6A
; 0000 02AA       t_msc=0;
; 0000 02AB       }
; 0000 02AC       if(u_c<u_min){flag_c=0; t_msc=0;}
_0xAC:
	CALL SUBOPT_0x2C
	SBIW R26,45
	BRGE _0xAF
	CALL SUBOPT_0x6A
; 0000 02AD 
; 0000 02AE       if(mem_c<mem&&u_c>=u_min&&time_mc[proval_nc]!=m)
_0xAF:
	LDS  R26,_mem_c
	CPI  R26,LOW(0x25)
	BRSH _0xB1
	CALL SUBOPT_0x2C
	SBIW R26,45
	BRLT _0xB1
	CALL SUBOPT_0x6B
	SUBI R30,LOW(-_time_mc)
	SBCI R31,HIGH(-_time_mc)
	CALL SUBOPT_0x50
	BRNE _0xB2
_0xB1:
	RJMP _0xB0
_0xB2:
; 0000 02AF       {
; 0000 02B0         if(u_c<dop&&flag_c==0)  //    
	CALL SUBOPT_0x68
	BRSH _0xB4
	LDI  R30,LOW(0)
	CP   R30,R7
	BREQ _0xB5
_0xB4:
	RJMP _0xB3
_0xB5:
; 0000 02B1         {
; 0000 02B2        tnc=t_ms;
	CALL SUBOPT_0x6C
; 0000 02B3        flag_c=1;
; 0000 02B4        go;  // 
; 0000 02B5        uc_r=mini;
	CALL SUBOPT_0x6D
; 0000 02B6        lcd_clear();
; 0000 02B7        }
; 0000 02B8        if(u_c>dop_m&&flag_c==0)  //    
_0xB3:
	CALL SUBOPT_0x69
	BREQ PC+2
	BRCC PC+3
	JMP  _0xB7
	LDI  R30,LOW(0)
	CP   R30,R7
	BREQ _0xB8
_0xB7:
	RJMP _0xB6
_0xB8:
; 0000 02B9         {
; 0000 02BA        tnc=t_ms;
	CALL SUBOPT_0x6C
; 0000 02BB        flag_c=1;
; 0000 02BC        go;  // 
; 0000 02BD        uc_r=maxi;
	CALL SUBOPT_0x6E
; 0000 02BE        lcd_clear();
; 0000 02BF        }
; 0000 02C0        if(flag_c==1&&t_msc>=t_zad)
_0xB6:
	LDI  R30,LOW(1)
	CP   R30,R7
	BRNE _0xBA
	CALL SUBOPT_0x6F
	BRSH _0xBB
_0xBA:
	RJMP _0xB9
_0xBB:
; 0000 02C1        {
; 0000 02C2         proval_nc++;
	CALL SUBOPT_0x70
	CALL SUBOPT_0x56
; 0000 02C3         mem_c = proval_nc;
	CALL SUBOPT_0x70
	STS  _mem_c,R30
; 0000 02C4         time_hc[proval_nc]=h;
	CALL SUBOPT_0x6B
	CALL SUBOPT_0x71
; 0000 02C5         time_mc[proval_nc]=m;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x72
; 0000 02C6         date_mc[proval_nc]=mo;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x73
; 0000 02C7         date_dc[proval_nc]=d;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x74
; 0000 02C8         temp_sc=s;
; 0000 02C9         flag_c=2;
; 0000 02CA        }
; 0000 02CB       }
_0xB9:
; 0000 02CC      }
_0xB0:
; 0000 02CD      //
; 0000 02CE     }
_0xAB:
; 0000 02CF     //   
; 0000 02D0     if(t_ms<=60000)
_0x88:
	CALL SUBOPT_0x75
	__CPD2N 0xEA61
	BRLO PC+3
	JMP _0xBC
; 0000 02D1     {
; 0000 02D2      if(flag_a==1) { t_msa = t_ms - tna; }
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0xBD
	CALL SUBOPT_0x76
; 0000 02D3      if(flag_b==1) { t_msb = t_ms - tnb; }
_0xBD:
	LDI  R30,LOW(1)
	CP   R30,R5
	BRNE _0xBE
	CALL SUBOPT_0x77
; 0000 02D4      if(flag_c==1) { t_msc = t_ms - tnc; }
_0xBE:
	LDI  R30,LOW(1)
	CP   R30,R7
	BRNE _0xBF
	CALL SUBOPT_0x78
; 0000 02D5      if(flag_a==2) { t_msa = t_ms - tna; proval_ta[proval_na]=t_msa;}
_0xBF:
	LDI  R30,LOW(2)
	CP   R30,R4
	BRNE _0xC0
	CALL SUBOPT_0x76
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x0
	ADD  R26,R30
	ADC  R27,R31
	LDS  R30,_t_msa
	LDS  R31,_t_msa+1
	CALL __EEPROMWRW
; 0000 02D6      if(flag_b==2) { t_msb = t_ms - tnb; proval_tb[proval_nb]=t_msb;}
_0xC0:
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0xC1
	CALL SUBOPT_0x77
	CALL SUBOPT_0x63
	CALL SUBOPT_0xD
	ADD  R26,R30
	ADC  R27,R31
	LDS  R30,_t_msb
	LDS  R31,_t_msb+1
	CALL __EEPROMWRW
; 0000 02D7      if(flag_c==2) { t_msc = t_ms - tnc; proval_tc[proval_nc]=t_msc;}
_0xC1:
	LDI  R30,LOW(2)
	CP   R30,R7
	BRNE _0xC2
	CALL SUBOPT_0x78
	CALL SUBOPT_0x70
	CALL SUBOPT_0x10
	ADD  R26,R30
	ADC  R27,R31
	LDS  R30,_t_msc
	LDS  R31,_t_msc+1
	CALL __EEPROMWRW
; 0000 02D8     }
_0xC2:
; 0000 02D9     else
	RJMP _0xC3
_0xBC:
; 0000 02DA     {
; 0000 02DB      read_time(); hh=h*3600; mm=m*60; ss=s;
	RCALL _read_time
	LDS  R26,_h
	LDI  R27,0
	LDI  R30,LOW(3600)
	LDI  R31,HIGH(3600)
	CALL __MULW12
	STS  _hh,R30
	STS  _hh+1,R31
	LDS  R26,_m
	LDI  R30,LOW(60)
	MUL  R30,R26
	MOVW R30,R0
	STS  _mm,R30
	STS  _mm+1,R31
	LDS  R30,_s
	LDI  R31,0
	STS  _ss,R30
	STS  _ss+1,R31
; 0000 02DC      sss=hh+mm+ss;
	LDS  R30,_mm
	LDS  R31,_mm+1
	LDS  R26,_hh
	LDS  R27,_hh+1
	ADD  R30,R26
	ADC  R31,R27
	LDS  R26,_ss
	LDS  R27,_ss+1
	ADD  R30,R26
	ADC  R31,R27
	CLR  R22
	CLR  R23
	STS  _sss,R30
	STS  _sss+1,R31
	STS  _sss+2,R22
	STS  _sss+3,R23
; 0000 02DD      if(flag_a==2)
	LDI  R30,LOW(2)
	CP   R30,R4
	BREQ PC+3
	JMP _0xC4
; 0000 02DE      {  dat_a=d;
	LDS  R30,_d
	STS  _dat_a,R30
; 0000 02DF        if(dat_a==date_da[proval_na])
	CALL SUBOPT_0x4E
	LDI  R31,0
	SUBI R30,LOW(-_date_da)
	SBCI R31,HIGH(-_date_da)
	MOVW R26,R30
	CALL __EEPROMRDB
	LDS  R26,_dat_a
	CP   R30,R26
	BREQ PC+3
	JMP _0xC5
; 0000 02E0        {
; 0000 02E1         sha= time_ha[proval_na];
	CALL SUBOPT_0x4E
	LDI  R31,0
	SUBI R30,LOW(-_time_ha)
	SBCI R31,HIGH(-_time_ha)
	CALL SUBOPT_0x79
	STS  _sha,R30
	STS  _sha+1,R31
	STS  _sha+2,R22
	STS  _sha+3,R23
; 0000 02E2         sma=time_ma[proval_na];
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x79
	STS  _sma,R30
	STS  _sma+1,R31
	STS  _sma+2,R22
	STS  _sma+3,R23
; 0000 02E3         sssa = (sha*3600)+(sma*60)+temp_sa;
	LDS  R30,_sha
	LDS  R31,_sha+1
	LDS  R22,_sha+2
	LDS  R23,_sha+3
	CALL SUBOPT_0x7A
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_sma
	LDS  R31,_sma+1
	LDS  R22,_sma+2
	LDS  R23,_sma+3
	CALL SUBOPT_0x7B
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	LDS  R26,_temp_sa
	LDS  R27,_temp_sa+1
	LDS  R24,_temp_sa+2
	LDS  R25,_temp_sa+3
	CALL __ADDD12
	STS  _sssa,R30
	STS  _sssa+1,R31
	STS  _sssa+2,R22
	STS  _sssa+3,R23
; 0000 02E4         temp_ssa=sss-sssa;
	LDS  R26,_sssa
	LDS  R27,_sssa+1
	LDS  R24,_sssa+2
	LDS  R25,_sssa+3
	CALL SUBOPT_0x7C
	STS  _temp_ssa,R30
	STS  _temp_ssa+1,R31
	STS  _temp_ssa+2,R22
	STS  _temp_ssa+3,R23
; 0000 02E5         temp_ma = temp_ssa/60;
	CALL SUBOPT_0x7D
	CALL SUBOPT_0x7E
	STS  _temp_ma,R30
	STS  _temp_ma+1,R31
	STS  _temp_ma+2,R22
	STS  _temp_ma+3,R23
; 0000 02E6         proval_tma[proval_na] = temp_ma;
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x7F
	MOVW R26,R30
	LDS  R30,_temp_ma
	CALL SUBOPT_0x6
; 0000 02E7         proval_ta[proval_na]=temp_ssa-(temp_ma*60);
	CALL __EEPROMRDB
	CALL SUBOPT_0x0
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_temp_ma
	LDS  R31,_temp_ma+1
	LDS  R22,_temp_ma+2
	LDS  R23,_temp_ma+3
	CALL SUBOPT_0x7B
	CALL SUBOPT_0x7D
	CALL SUBOPT_0x80
	POP  R26
	POP  R27
	CALL __EEPROMWRW
; 0000 02E8        }
; 0000 02E9      }
_0xC5:
; 0000 02EA      if(flag_b==2)
_0xC4:
	LDI  R30,LOW(2)
	CP   R30,R5
	BREQ PC+3
	JMP _0xC6
; 0000 02EB      {  dat_b=d;
	LDS  R30,_d
	STS  _dat_b,R30
; 0000 02EC      if(dat_b==date_db[proval_nb])
	CALL SUBOPT_0x5E
	SUBI R30,LOW(-_date_db)
	SBCI R31,HIGH(-_date_db)
	MOVW R26,R30
	CALL __EEPROMRDB
	LDS  R26,_dat_b
	CP   R30,R26
	BREQ PC+3
	JMP _0xC7
; 0000 02ED        {
; 0000 02EE         shb= time_hb[proval_nb];
	CALL SUBOPT_0x5E
	SUBI R30,LOW(-_time_hb)
	SBCI R31,HIGH(-_time_hb)
	CALL SUBOPT_0x79
	STS  _shb,R30
	STS  _shb+1,R31
	STS  _shb+2,R22
	STS  _shb+3,R23
; 0000 02EF         smb=time_mb[proval_nb];
	CALL SUBOPT_0x5E
	SUBI R30,LOW(-_time_mb)
	SBCI R31,HIGH(-_time_mb)
	CALL SUBOPT_0x79
	STS  _smb,R30
	STS  _smb+1,R31
	STS  _smb+2,R22
	STS  _smb+3,R23
; 0000 02F0         sssb = (shb*3600)+(smb*60)+temp_sb;
	LDS  R30,_shb
	LDS  R31,_shb+1
	LDS  R22,_shb+2
	LDS  R23,_shb+3
	CALL SUBOPT_0x7A
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_smb
	LDS  R31,_smb+1
	LDS  R22,_smb+2
	LDS  R23,_smb+3
	CALL SUBOPT_0x7B
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	LDS  R26,_temp_sb
	LDS  R27,_temp_sb+1
	LDS  R24,_temp_sb+2
	LDS  R25,_temp_sb+3
	CALL __ADDD12
	STS  _sssb,R30
	STS  _sssb+1,R31
	STS  _sssb+2,R22
	STS  _sssb+3,R23
; 0000 02F1         temp_ssb=sss-sssb;
	LDS  R26,_sssb
	LDS  R27,_sssb+1
	LDS  R24,_sssb+2
	LDS  R25,_sssb+3
	CALL SUBOPT_0x7C
	STS  _temp_ssb,R30
	STS  _temp_ssb+1,R31
	STS  _temp_ssb+2,R22
	STS  _temp_ssb+3,R23
; 0000 02F2         temp_mb = temp_ssb/60;
	CALL SUBOPT_0x81
	CALL SUBOPT_0x7E
	STS  _temp_mb,R30
	STS  _temp_mb+1,R31
	STS  _temp_mb+2,R22
	STS  _temp_mb+3,R23
; 0000 02F3         proval_tmb[proval_nb] = temp_mb;
	CALL SUBOPT_0x5E
	SUBI R30,LOW(-_proval_tmb)
	SBCI R31,HIGH(-_proval_tmb)
	MOVW R26,R30
	LDS  R30,_temp_mb
	CALL SUBOPT_0xF
; 0000 02F4         proval_tb[proval_nb]=temp_ssb-(temp_mb*60);
	CALL __EEPROMRDB
	CALL SUBOPT_0xD
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_temp_mb
	LDS  R31,_temp_mb+1
	LDS  R22,_temp_mb+2
	LDS  R23,_temp_mb+3
	CALL SUBOPT_0x7B
	CALL SUBOPT_0x81
	CALL SUBOPT_0x80
	POP  R26
	POP  R27
	CALL __EEPROMWRW
; 0000 02F5         }
; 0000 02F6      }
_0xC7:
; 0000 02F7      if(flag_c==2)
_0xC6:
	LDI  R30,LOW(2)
	CP   R30,R7
	BREQ PC+3
	JMP _0xC8
; 0000 02F8      {   dat_c=d;
	LDS  R30,_d
	STS  _dat_c,R30
; 0000 02F9      if(dat_c==date_dc[proval_nc])
	CALL SUBOPT_0x6B
	SUBI R30,LOW(-_date_dc)
	SBCI R31,HIGH(-_date_dc)
	MOVW R26,R30
	CALL __EEPROMRDB
	LDS  R26,_dat_c
	CP   R30,R26
	BREQ PC+3
	JMP _0xC9
; 0000 02FA        {
; 0000 02FB         shc= time_hc[proval_nc];
	CALL SUBOPT_0x6B
	SUBI R30,LOW(-_time_hc)
	SBCI R31,HIGH(-_time_hc)
	CALL SUBOPT_0x79
	STS  _shc,R30
	STS  _shc+1,R31
	STS  _shc+2,R22
	STS  _shc+3,R23
; 0000 02FC         smc=time_mc[proval_nc];
	CALL SUBOPT_0x6B
	SUBI R30,LOW(-_time_mc)
	SBCI R31,HIGH(-_time_mc)
	CALL SUBOPT_0x79
	STS  _smc,R30
	STS  _smc+1,R31
	STS  _smc+2,R22
	STS  _smc+3,R23
; 0000 02FD         sssc = (shc*3600)+(smc*60)+temp_sc;
	LDS  R30,_shc
	LDS  R31,_shc+1
	LDS  R22,_shc+2
	LDS  R23,_shc+3
	CALL SUBOPT_0x7A
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_smc
	LDS  R31,_smc+1
	LDS  R22,_smc+2
	LDS  R23,_smc+3
	CALL SUBOPT_0x7B
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	LDS  R26,_temp_sc
	LDS  R27,_temp_sc+1
	LDS  R24,_temp_sc+2
	LDS  R25,_temp_sc+3
	CALL __ADDD12
	STS  _sssc,R30
	STS  _sssc+1,R31
	STS  _sssc+2,R22
	STS  _sssc+3,R23
; 0000 02FE         temp_ssc=sss-sssc;
	LDS  R26,_sssc
	LDS  R27,_sssc+1
	LDS  R24,_sssc+2
	LDS  R25,_sssc+3
	CALL SUBOPT_0x7C
	STS  _temp_ssc,R30
	STS  _temp_ssc+1,R31
	STS  _temp_ssc+2,R22
	STS  _temp_ssc+3,R23
; 0000 02FF         temp_mc = temp_ssc/60;
	CALL SUBOPT_0x82
	CALL SUBOPT_0x7E
	STS  _temp_mc,R30
	STS  _temp_mc+1,R31
	STS  _temp_mc+2,R22
	STS  _temp_mc+3,R23
; 0000 0300         proval_tmc[proval_nc] = temp_mc;
	CALL SUBOPT_0x6B
	SUBI R30,LOW(-_proval_tmc)
	SBCI R31,HIGH(-_proval_tmc)
	MOVW R26,R30
	LDS  R30,_temp_mc
	CALL SUBOPT_0x12
; 0000 0301         proval_tc[proval_nc]=temp_ssc-(temp_mc*60);
	CALL __EEPROMRDB
	CALL SUBOPT_0x10
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDS  R30,_temp_mc
	LDS  R31,_temp_mc+1
	LDS  R22,_temp_mc+2
	LDS  R23,_temp_mc+3
	CALL SUBOPT_0x7B
	CALL SUBOPT_0x82
	CALL SUBOPT_0x80
	POP  R26
	POP  R27
	CALL __EEPROMWRW
; 0000 0302         }
; 0000 0303      }
_0xC9:
; 0000 0304     }
_0xC8:
_0xC3:
; 0000 0305 
; 0000 0306   }
; 0000 0307  }
_0x56:
	RET
;  void lsd()    // 
; 0000 0309   {
_lsd:
; 0000 030A    if(menu==0)
	LDS  R30,_menu
	CPI  R30,0
	BREQ PC+3
	JMP _0xCA
; 0000 030B    {
; 0000 030C      if(menu_def==1)   //   
	LDS  R26,_menu_def
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0xCB
; 0000 030D      {
; 0000 030E       lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 030F       sprintf(lcd_buffer,"໸eĽoc poaa",); //     
	__POINTW1FN _0x0,343
	CALL SUBOPT_0x8
; 0000 0310       lcd_puts(lcd_buffer);         //      
; 0000 0311       lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0x83
; 0000 0312       if(t_msa<59000) {sprintf(lcd_buffer,"aa A Ta=%u mc       ",t_msa);} //    
	CALL SUBOPT_0x84
	BRSH _0xCC
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,364
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_t_msa
	LDS  R31,_t_msa+1
	CALL SUBOPT_0x86
	CALL SUBOPT_0x87
; 0000 0313       else {sprintf(lcd_buffer,"aa A Ta=%um%uc       ",proval_tma[proval_na],proval_ta[proval_na]);}
	RJMP _0xCD
_0xCC:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,387
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x7F
	CALL SUBOPT_0x79
	CALL __PUTPARD1
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x0
	CALL SUBOPT_0x88
	CALL SUBOPT_0x89
_0xCD:
; 0000 0314       lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 0315       lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x8B
; 0000 0316       if(t_msb<59000) {sprintf(lcd_buffer,"aa B Tc=%u mc       ",t_msb);}//    
	CALL SUBOPT_0x8C
	BRSH _0xCE
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,411
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_t_msb
	LDS  R31,_t_msb+1
	CALL SUBOPT_0x86
	CALL SUBOPT_0x87
; 0000 0317       else {sprintf(lcd_buffer,"aa B Tb=%um%uc       ",proval_tmb[proval_nb],proval_tb[proval_nb]);}
	RJMP _0xCF
_0xCE:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,434
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x5E
	SUBI R30,LOW(-_proval_tmb)
	SBCI R31,HIGH(-_proval_tmb)
	CALL SUBOPT_0x79
	CALL __PUTPARD1
	CALL SUBOPT_0x63
	CALL SUBOPT_0xD
	CALL SUBOPT_0x88
	CALL SUBOPT_0x89
_0xCF:
; 0000 0318       lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 0319       lcd_gotoxy(0,3);              //  2    1 
	CALL SUBOPT_0x8D
; 0000 031A       if(t_msc<59000) {sprintf(lcd_buffer,"aa C Tc=%u mc       ",t_msc);}//    
	CALL SUBOPT_0x8E
	BRSH _0xD0
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,458
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_t_msc
	LDS  R31,_t_msc+1
	CALL SUBOPT_0x86
	CALL SUBOPT_0x87
; 0000 031B       else {sprintf(lcd_buffer,"aa C Tc=%um%uc       ",proval_tmc[proval_nc],proval_tc[proval_nc]);}
	RJMP _0xD1
_0xD0:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,481
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x6B
	SUBI R30,LOW(-_proval_tmc)
	SBCI R31,HIGH(-_proval_tmc)
	CALL SUBOPT_0x79
	CALL __PUTPARD1
	CALL SUBOPT_0x70
	CALL SUBOPT_0x10
	CALL SUBOPT_0x88
	CALL SUBOPT_0x89
_0xD1:
; 0000 031C       lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 031D       }
; 0000 031E       if(menu_def==0)    // 
_0xCB:
	LDS  R30,_menu_def
	CPI  R30,0
	BREQ PC+3
	JMP _0xD2
; 0000 031F      {
; 0000 0320        if(go_izm==1)
	LDS  R26,_go_izm
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0xD3
; 0000 0321        {
; 0000 0322         tt++;
	LDI  R26,LOW(_tt)
	LDI  R27,HIGH(_tt)
	CALL SUBOPT_0x47
; 0000 0323          lcd_gotoxy(0,0);              //  1    1 
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 0324         if(tt<=1500){sprintf(lcd_buffer,"%i:%i%i:%i%i-%i/%i/%i ", h,m/10,m%10,s/10,s%10,d,mo,y+2000 );} //      
	LDS  R26,_tt
	LDS  R27,_tt+1
	CPI  R26,LOW(0x5DD)
	LDI  R30,HIGH(0x5DD)
	CPC  R27,R30
	BRSH _0xD4
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8F
; 0000 0325          else{sprintf(lcd_buffer,"Pe capoa!!");} // 
	RJMP _0xD5
_0xD4:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,528
	CALL SUBOPT_0x90
_0xD5:
; 0000 0326          if(tt>=3000){tt=0;}
	LDS  R26,_tt
	LDS  R27,_tt+1
	CPI  R26,LOW(0xBB8)
	LDI  R30,HIGH(0xBB8)
	CPC  R27,R30
	BRLO _0xD6
	LDI  R30,LOW(0)
	STS  _tt,R30
	STS  _tt+1,R30
; 0000 0327         lcd_puts(lcd_buffer);         //      
_0xD6:
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 0328          lcd_gotoxy(0,1);
	CALL SUBOPT_0x83
; 0000 0329         if(t_msa>=t_zad) {sprintf(lcd_buffer,"aa A Ua=%u V  * ",u_a );}
	CALL SUBOPT_0x54
	CALL SUBOPT_0x55
	BRLO _0xD7
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,549
	RJMP _0x2DC
; 0000 032A         else{sprintf(lcd_buffer,"aa A Ua=%u V      ",u_a );} //      
_0xD7:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,568
_0x2DC:
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x91
; 0000 032B         lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 032C         lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x8B
; 0000 032D         if(t_msb>=t_zad) {sprintf(lcd_buffer,"aa B Ub=%u V  *  ",u_b );}
	CALL SUBOPT_0x62
	BRLO _0xD9
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,589
	RJMP _0x2DD
; 0000 032E         else{sprintf(lcd_buffer,"aa B Ub=%u V      ",u_b );} //      
_0xD9:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,609
_0x2DD:
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x92
; 0000 032F         lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 0330         lcd_gotoxy(0,3);              //  2    1 
	CALL SUBOPT_0x8D
; 0000 0331         if(t_msc>=t_zad) {sprintf(lcd_buffer,"aa C Uc=%u V  *  ",u_c ); }//      
	CALL SUBOPT_0x6F
	BRLO _0xDB
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,630
	RJMP _0x2DE
; 0000 0332         else{sprintf(lcd_buffer,"aa C Uc=%u V     ",u_c );}
_0xDB:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,650
_0x2DE:
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x93
; 0000 0333         lcd_puts(lcd_buffer);         //      
	RJMP _0x2DF
; 0000 0334         }
; 0000 0335         else
_0xD3:
; 0000 0336         {
; 0000 0337         lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0338         sprintf(lcd_buffer,"%i:%i%i:%i%i-%i/%i/%i ", h,m/10,m%10,s/10,s%10,d,mo,y+2000 ); //      
	CALL SUBOPT_0x8F
; 0000 0339         lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 033A         lcd_gotoxy(0,1);
	CALL SUBOPT_0xB
; 0000 033B         sprintf(lcd_buffer,"aa A Ua=%u V      ",u_a ); //      
	__POINTW1FN _0x0,568
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x91
; 0000 033C         lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 033D         lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x13
; 0000 033E         sprintf(lcd_buffer,"aa B Ub=%u V      ",u_b ); //      
	__POINTW1FN _0x0,609
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x92
; 0000 033F         lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL SUBOPT_0x94
; 0000 0340         lcd_gotoxy(0,3);              //  2    1 
; 0000 0341         sprintf(lcd_buffer,"aa C Uc=%u V      ",u_c );
	__POINTW1FN _0x0,670
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x93
; 0000 0342         lcd_puts(lcd_buffer);         //      
_0x2DF:
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	CALL SUBOPT_0x95
; 0000 0343         }
; 0000 0344       }
; 0000 0345       if(menu_def==2)     // 
_0xD2:
	LDS  R26,_menu_def
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0xDE
; 0000 0346      {
; 0000 0347       lcd_gotoxy(0,0);              //  2    1 
	CALL SUBOPT_0x15
; 0000 0348       sprintf(lcd_buffer,"apaep a A",);//      
	__POINTW1FN _0x0,691
	CALL SUBOPT_0x8
; 0000 0349       lcd_puts(lcd_buffer);         //      
; 0000 034A       lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0x83
; 0000 034B       if(u_a>=u_n){ sprintf(lcd_buffer,"Ua=%uV/+%i po.",u_a, u_delta_a/100);} //      
	CALL SUBOPT_0x3C
	BRLT _0xDF
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,708
	CALL SUBOPT_0x96
; 0000 034C       if(u_a<u_n){ sprintf(lcd_buffer,"Ua=%uV/-%i po.",u_a, u_delta_a/100);} //      
_0xDF:
	CALL SUBOPT_0x3C
	BRGE _0xE0
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,725
	CALL SUBOPT_0x96
; 0000 034D       lcd_puts(lcd_buffer);         //      
_0xE0:
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 034E       lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x8B
; 0000 034F       if(u_a>=u_n) {sprintf(lcd_buffer,"ya Ua*=+%uV  ",u_delta_ua);}//      
	CALL SUBOPT_0x3C
	BRLT _0xE1
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,742
	CALL SUBOPT_0x97
; 0000 0350       if(u_a<u_n) {sprintf(lcd_buffer,"ya Ua*=-%uV  ",u_delta_ua);} //      
_0xE1:
	CALL SUBOPT_0x3C
	BRGE _0xE2
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,761
	CALL SUBOPT_0x97
; 0000 0351       lcd_puts(lcd_buffer);         //      
_0xE2:
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 0352       lcd_gotoxy(0,3);              //  2    1 
	CALL SUBOPT_0x8D
; 0000 0353      if(t_msa<59000) {sprintf(lcd_buffer,"Bpe Ta=%us%umc  ",t_msa/1000,t_msa%1000);}//      
	CALL SUBOPT_0x84
	BRSH _0xE3
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,780
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x98
	CALL SUBOPT_0x99
	CALL SUBOPT_0x98
	CALL __MODW21U
	RJMP _0x2E0
; 0000 0354      else{sprintf(lcd_buffer,"Bpe Ta=%um%uc       ",proval_tma[proval_na],proval_ta[proval_na]);}
_0xE3:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,799
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x7F
	CALL SUBOPT_0x79
	CALL __PUTPARD1
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x0
	CALL SUBOPT_0x9A
_0x2E0:
	CLR  R22
	CLR  R23
	CALL SUBOPT_0x9B
; 0000 0355       lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 0356       }
; 0000 0357       if(menu_def==3)      // 
_0xDE:
	LDS  R26,_menu_def
	CPI  R26,LOW(0x3)
	BREQ PC+3
	JMP _0xE5
; 0000 0358      {
; 0000 0359       lcd_gotoxy(0,0);              //  2    1 
	CALL SUBOPT_0x15
; 0000 035A       sprintf(lcd_buffer,"apaep a B",);//      
	__POINTW1FN _0x0,822
	CALL SUBOPT_0x8
; 0000 035B       lcd_puts(lcd_buffer);         //      
; 0000 035C       lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0x83
; 0000 035D       if(u_b>=u_n){ sprintf(lcd_buffer,"Ub=%uV/+%i po.",u_b, u_delta_b/100);} //    
	CALL SUBOPT_0x42
	BRLT _0xE6
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,839
	CALL SUBOPT_0x9C
; 0000 035E       if(u_b<u_n){ sprintf(lcd_buffer,"Ub=%uV/-%i po.",u_b, u_delta_b/100);} //      
_0xE6:
	CALL SUBOPT_0x42
	BRGE _0xE7
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,856
	CALL SUBOPT_0x9C
; 0000 035F       lcd_puts(lcd_buffer);         //      
_0xE7:
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 0360       lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x8B
; 0000 0361       if(u_b>=u_n) {sprintf(lcd_buffer,"ya Ub*=+%uV  ",u_delta_ub);}//   
	CALL SUBOPT_0x42
	BRLT _0xE8
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,873
	CALL SUBOPT_0x9D
; 0000 0362       if(u_b<u_n) {sprintf(lcd_buffer,"ya Ub*=-%uV  ",u_delta_ub);} //      
_0xE8:
	CALL SUBOPT_0x42
	BRGE _0xE9
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,892
	CALL SUBOPT_0x9D
; 0000 0363       lcd_puts(lcd_buffer);         //      
_0xE9:
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 0364       lcd_gotoxy(0,3);              //  2    1 
	CALL SUBOPT_0x8D
; 0000 0365       if(t_msb<59000) {sprintf(lcd_buffer,"Bpe Tb=%us%umc  ",t_msb/1000,t_msb%1000);}//   
	CALL SUBOPT_0x8C
	BRSH _0xEA
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,911
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x9E
	CALL SUBOPT_0x99
	CALL SUBOPT_0x9E
	CALL __MODW21U
	RJMP _0x2E1
; 0000 0366       else {sprintf(lcd_buffer,"Bpe Tb=%um%uc     ",proval_tmb[proval_nb],proval_tb[proval_nb]);}
_0xEA:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,930
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x5E
	SUBI R30,LOW(-_proval_tmb)
	SBCI R31,HIGH(-_proval_tmb)
	CALL SUBOPT_0x79
	CALL __PUTPARD1
	CALL SUBOPT_0x63
	CALL SUBOPT_0xD
	CALL SUBOPT_0x9A
_0x2E1:
	CLR  R22
	CLR  R23
	CALL SUBOPT_0x9B
; 0000 0367       lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 0368       }
; 0000 0369       if(menu_def==4)     // 
_0xE5:
	LDS  R26,_menu_def
	CPI  R26,LOW(0x4)
	BREQ PC+3
	JMP _0xEC
; 0000 036A      {
; 0000 036B       lcd_gotoxy(0,0);              //  2    1 
	CALL SUBOPT_0x15
; 0000 036C       sprintf(lcd_buffer,"apaep a C",);//      
	__POINTW1FN _0x0,951
	CALL SUBOPT_0x8
; 0000 036D       lcd_puts(lcd_buffer);         //      
; 0000 036E       lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0x83
; 0000 036F       if(u_c>=u_n){ sprintf(lcd_buffer,"Uc=%uV/+%i po.",u_c, u_delta_c/100);} //      
	CALL SUBOPT_0x46
	BRLT _0xED
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,968
	CALL SUBOPT_0x9F
; 0000 0370       if(u_c<u_n){ sprintf(lcd_buffer,"Uc=%uV/-%i po.",u_c, u_delta_c/100);} //      
_0xED:
	CALL SUBOPT_0x46
	BRGE _0xEE
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,985
	CALL SUBOPT_0x9F
; 0000 0371       lcd_puts(lcd_buffer);         //      
_0xEE:
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 0372       lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x8B
; 0000 0373       if(u_c>=u_n) {sprintf(lcd_buffer,"ya Uc*=+%uV  ",u_delta_uc);}//      
	CALL SUBOPT_0x46
	BRLT _0xEF
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,1002
	CALL SUBOPT_0xA0
; 0000 0374       if(u_c<u_n) {sprintf(lcd_buffer,"ya Uc*=-%uV  ",u_delta_uc);} //      
_0xEF:
	CALL SUBOPT_0x46
	BRGE _0xF0
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,1021
	CALL SUBOPT_0xA0
; 0000 0375       lcd_puts(lcd_buffer);         //      
_0xF0:
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 0376       lcd_gotoxy(0,3);              //  2    1 
	CALL SUBOPT_0x8D
; 0000 0377        if(t_msc<59000) {sprintf(lcd_buffer,"Bpe Tc=%us%umc  ",t_msc/1000,t_msc%1000);}//      
	CALL SUBOPT_0x8E
	BRSH _0xF1
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,1040
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xA1
	CALL SUBOPT_0x99
	CALL SUBOPT_0xA1
	CALL __MODW21U
	RJMP _0x2E2
; 0000 0378        else {sprintf(lcd_buffer,"Bpe Tc=%us%uc      ",proval_tmc[proval_nc],proval_tc[proval_nc]);}
_0xF1:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,1059
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x6B
	SUBI R30,LOW(-_proval_tmc)
	SBCI R31,HIGH(-_proval_tmc)
	CALL SUBOPT_0x79
	CALL __PUTPARD1
	CALL SUBOPT_0x70
	CALL SUBOPT_0x10
	CALL SUBOPT_0x9A
_0x2E2:
	CLR  R22
	CLR  R23
	CALL SUBOPT_0x9B
; 0000 0379       lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 037A       }
; 0000 037B       if(menu_def==5)     // 
_0xEC:
	LDS  R26,_menu_def
	CPI  R26,LOW(0x5)
	BREQ PC+3
	JMP _0xF3
; 0000 037C       {
; 0000 037D        if(izm==0){u_bat=read_adc(3);sis=read_adc(4);zar=read_adc(5);} // ,  
	LDS  R30,_izm
	CPI  R30,0
	BRNE _0xF4
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _read_adc
	STS  _u_bat,R30
	STS  _u_bat+1,R31
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _read_adc
	STS  _sis,R30
	STS  _sis+1,R31
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _read_adc
	STS  _zar,R30
	STS  _zar+1,R31
; 0000 037E        lcd_gotoxy(0,0);              //  2    1 
_0xF4:
	CALL SUBOPT_0x15
; 0000 037F       sprintf(lcd_buffer,"aape-%u mB    ",u_bat*10);//    
	__POINTW1FN _0x0,1081
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_u_bat
	LDS  R27,_u_bat+1
	CALL SUBOPT_0xA2
	CALL SUBOPT_0x87
; 0000 0380       lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 0381          u_batt=u_bat;
	LDS  R30,_u_bat
	LDS  R31,_u_bat+1
	LDI  R26,LOW(_u_batt)
	LDI  R27,HIGH(_u_batt)
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __PUTDP1
; 0000 0382       u_batp = ((42000*100-u_batt*10000)/42000*100);
	LDS  R26,_u_batt
	LDS  R27,_u_batt+1
	LDS  R24,_u_batt+2
	LDS  R25,_u_batt+3
	__GETD1N 0x461C4000
	CALL __MULF12
	__GETD2N 0x4A802C80
	CALL __SWAPD12
	CALL __SUBF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x47241000
	CALL __DIVF21
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_u_batp)
	LDI  R27,HIGH(_u_batp)
	CALL __CFD1
	ST   X+,R30
	ST   X,R31
; 0000 0383        u_batp = u_batp/10;
	LDS  R26,_u_batp
	LDS  R27,_u_batp+1
	CALL SUBOPT_0xA3
	STS  _u_batp,R30
	STS  _u_batp+1,R31
; 0000 0384         lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0x83
; 0000 0385        if(u_bat<=bat_low){ sprintf(lcd_buffer,"o㺻e apoe!",);}//     
	LDS  R26,_u_bat
	LDS  R27,_u_bat+1
	CPI  R26,LOW(0x17B)
	LDI  R30,HIGH(0x17B)
	CPC  R27,R30
	BRSH _0xF5
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,1099
	CALL SUBOPT_0x90
; 0000 0386        else{sprintf(lcd_buffer,"poe-%i*         ",105 - u_batp);}  //    
	RJMP _0xF6
_0xF5:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,1120
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_u_batp
	LDS  R27,_u_batp+1
	LDI  R30,LOW(105)
	LDI  R31,HIGH(105)
	CALL SUBOPT_0xA4
_0xF6:
; 0000 0387       lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 0388        lcd_gotoxy(0,2);
	CALL SUBOPT_0x13
; 0000 0389        sprintf(lcd_buffer,"Ccea-%i mB    ",sis*10);// 
	__POINTW1FN _0x0,1141
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_sis
	LDS  R27,_sis+1
	CALL SUBOPT_0xA2
	CALL SUBOPT_0x87
; 0000 038A        lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL SUBOPT_0x94
; 0000 038B       lcd_gotoxy(0,3);
; 0000 038C        sprintf(lcd_buffer,"apa-%i mB    ",zar*10);//
	__POINTW1FN _0x0,1159
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_zar
	LDS  R27,_zar+1
	CALL SUBOPT_0xA2
	CALL SUBOPT_0x87
; 0000 038D        lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 038E       }
; 0000 038F 
; 0000 0390 
; 0000 0391    if(menu_def==8||menu_def==9)     //  
_0xF3:
	LDS  R26,_menu_def
	CPI  R26,LOW(0x8)
	BREQ _0xF8
	CPI  R26,LOW(0x9)
	BREQ _0xF8
	RJMP _0xF7
_0xF8:
; 0000 0392     {
; 0000 0393       if(go_izm==0)
	LDS  R30,_go_izm
	CPI  R30,0
	BREQ PC+3
	JMP _0xFA
; 0000 0394      {
; 0000 0395         if(menu_def==8)// 3 phaza
	LDS  R26,_menu_def
	CPI  R26,LOW(0x8)
	BRNE _0xFB
; 0000 0396         {
; 0000 0397        lcd_gotoxy(0,0);              //   
	CALL SUBOPT_0x15
; 0000 0398       sprintf(lcd_buffer,"O常 capoa",);//     
	CALL SUBOPT_0xA5
; 0000 0399       lcd_puts(lcd_buffer);         //      
; 0000 039A         lcd_gotoxy(0,2);              //   
	CALL SUBOPT_0x13
; 0000 039B       sprintf(lcd_buffer,"Tp a <<<",);//     
	__POINTW1FN _0x0,1196
	CALL SUBOPT_0x8
; 0000 039C       lcd_puts(lcd_buffer);         //      
; 0000 039D        lcd_gotoxy(0,3);              //   
	CALL SUBOPT_0x16
; 0000 039E       sprintf(lcd_buffer,"Oa aa   ",);//     
	__POINTW1FN _0x0,1209
	CALL SUBOPT_0x8
; 0000 039F       lcd_puts(lcd_buffer);         //      
; 0000 03A0 
; 0000 03A1       }
; 0000 03A2 
; 0000 03A3         if(menu_def==9)// 1 phaza
_0xFB:
	LDS  R26,_menu_def
	CPI  R26,LOW(0x9)
	BREQ PC+3
	JMP _0xFC
; 0000 03A4       {
; 0000 03A5        if(rez==0)
	LDS  R30,_rez
	CPI  R30,0
	BRNE _0xFD
; 0000 03A6        {
; 0000 03A7         lcd_gotoxy(0,0);              //   
	CALL SUBOPT_0x15
; 0000 03A8         sprintf(lcd_buffer,"O常 capoa",);//      
	CALL SUBOPT_0xA5
; 0000 03A9         lcd_puts(lcd_buffer);         //      
; 0000 03AA         lcd_gotoxy(0,2);              //   
	CALL SUBOPT_0x13
; 0000 03AB         sprintf(lcd_buffer,"Tp a   ",);//      
	__POINTW1FN _0x0,1222
	CALL SUBOPT_0x8
; 0000 03AC         lcd_puts(lcd_buffer);         //      
; 0000 03AD         lcd_gotoxy(0,3);              //   
	CALL SUBOPT_0x16
; 0000 03AE         sprintf(lcd_buffer,"Oa aa <<<",);//      
	__POINTW1FN _0x0,1234
	CALL SUBOPT_0x8
; 0000 03AF         lcd_puts(lcd_buffer);         //      
; 0000 03B0         }
; 0000 03B1        if(rez==1)
_0xFD:
	LDS  R26,_rez
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0xFE
; 0000 03B2         {
; 0000 03B3          lcd_gotoxy(0,0);              //   
	CALL SUBOPT_0x15
; 0000 03B4           sprintf(lcd_buffer,"Bòepe ay",);//     
	__POINTW1FN _0x0,1248
	CALL SUBOPT_0x8
; 0000 03B5           lcd_puts(lcd_buffer);         //      
; 0000 03B6 
; 0000 03B7        if(izm_faza==0)
	LDS  R30,_izm_faza
	CPI  R30,0
	BRNE _0xFF
; 0000 03B8         {
; 0000 03B9          lcd_gotoxy(0,1);              //   
	CALL SUBOPT_0xB
; 0000 03BA          sprintf(lcd_buffer,"aa  A  <<<",);//      
	__POINTW1FN _0x0,1262
	CALL SUBOPT_0x8
; 0000 03BB          lcd_puts(lcd_buffer);         //      
; 0000 03BC                   lcd_gotoxy(0,2);              //   
	CALL SUBOPT_0x13
; 0000 03BD          sprintf(lcd_buffer,"aa  B     ",);//      
	__POINTW1FN _0x0,1275
	CALL SUBOPT_0x8
; 0000 03BE          lcd_puts(lcd_buffer);         //      
; 0000 03BF                   lcd_gotoxy(0,3);              //   
	CALL SUBOPT_0x16
; 0000 03C0          sprintf(lcd_buffer,"aa  C     ",);//      
	__POINTW1FN _0x0,1288
	CALL SUBOPT_0x8
; 0000 03C1          lcd_puts(lcd_buffer);         //      
; 0000 03C2         }
; 0000 03C3                if(izm_faza==1)
_0xFF:
	LDS  R26,_izm_faza
	CPI  R26,LOW(0x1)
	BRNE _0x100
; 0000 03C4         {
; 0000 03C5          lcd_gotoxy(0,1);              //   
	CALL SUBOPT_0xB
; 0000 03C6          sprintf(lcd_buffer,"aa  A     ",);//      
	__POINTW1FN _0x0,1301
	CALL SUBOPT_0x8
; 0000 03C7          lcd_puts(lcd_buffer);         //      
; 0000 03C8                   lcd_gotoxy(0,2);              //   
	CALL SUBOPT_0x13
; 0000 03C9          sprintf(lcd_buffer,"aa  B  <<<",);//      
	__POINTW1FN _0x0,1314
	CALL SUBOPT_0x8
; 0000 03CA          lcd_puts(lcd_buffer);         //      
; 0000 03CB                   lcd_gotoxy(0,3);              //   
	CALL SUBOPT_0x16
; 0000 03CC          sprintf(lcd_buffer,"aa  C     ",);//      
	__POINTW1FN _0x0,1288
	CALL SUBOPT_0x8
; 0000 03CD          lcd_puts(lcd_buffer);         //      
; 0000 03CE         }
; 0000 03CF                if(izm_faza==2)
_0x100:
	LDS  R26,_izm_faza
	CPI  R26,LOW(0x2)
	BRNE _0x101
; 0000 03D0         {
; 0000 03D1          lcd_gotoxy(0,1);              //   
	CALL SUBOPT_0xB
; 0000 03D2          sprintf(lcd_buffer,"aa  A     ",);//      
	__POINTW1FN _0x0,1301
	CALL SUBOPT_0x8
; 0000 03D3          lcd_puts(lcd_buffer);         //      
; 0000 03D4                   lcd_gotoxy(0,2);              //   
	CALL SUBOPT_0x13
; 0000 03D5          sprintf(lcd_buffer,"aa  B     ",);//      
	__POINTW1FN _0x0,1275
	CALL SUBOPT_0x8
; 0000 03D6          lcd_puts(lcd_buffer);         //      
; 0000 03D7                   lcd_gotoxy(0,3);              //   
	CALL SUBOPT_0x16
; 0000 03D8          sprintf(lcd_buffer,"aa  C  <<<",);//      
	__POINTW1FN _0x0,1327
	CALL SUBOPT_0x8
; 0000 03D9          lcd_puts(lcd_buffer);         //      
; 0000 03DA         }
; 0000 03DB 
; 0000 03DC        }
_0x101:
; 0000 03DD 
; 0000 03DE       }
_0xFE:
; 0000 03DF      }
_0xFC:
; 0000 03E0       else
	RJMP _0x102
_0xFA:
; 0000 03E1       {
; 0000 03E2       lcd_gotoxy(0,0);              //   
	CALL SUBOPT_0x15
; 0000 03E3       sprintf(lcd_buffer,"O常 capoa",);//      
	CALL SUBOPT_0xA5
; 0000 03E4       lcd_puts(lcd_buffer);         //      
; 0000 03E5         lcd_gotoxy(0,2);              //   
	CALL SUBOPT_0x13
; 0000 03E6       sprintf(lcd_buffer,"Ocao caep? ",);//     
	__POINTW1FN _0x0,1340
	CALL SUBOPT_0x8
; 0000 03E7       lcd_puts(lcd_buffer);         //      
; 0000 03E8        lcd_gotoxy(0,3);              //   
	CALL SUBOPT_0x16
; 0000 03E9       sprintf(lcd_buffer,"Hae >>D<<",);//     D
	__POINTW1FN _0x0,1360
	CALL SUBOPT_0x8
; 0000 03EA       lcd_puts(lcd_buffer);         //      
; 0000 03EB      }
_0x102:
; 0000 03EC      }
; 0000 03ED     }
_0xF7:
; 0000 03EE        if(menu!=0)
_0xCA:
	LDS  R30,_menu
	CPI  R30,0
	BRNE PC+3
	JMP _0x103
; 0000 03EF    {
; 0000 03F0       if(menu_p==0)  //  
	LDS  R30,_menu_p
	CPI  R30,0
	BREQ PC+3
	JMP _0x104
; 0000 03F1       {
; 0000 03F2          if(menu==1)      //
	LDS  R26,_menu
	CPI  R26,LOW(0x1)
	BRNE _0x105
; 0000 03F3          {
; 0000 03F4          lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 03F5          sprintf(lcd_buffer,"Hacpo  <<<");//    
	__POINTW1FN _0x0,1374
	CALL SUBOPT_0x8
; 0000 03F6          lcd_puts(lcd_buffer);         //      
; 0000 03F7          lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 03F8          sprintf(lcd_buffer,"Bpe");//   
	CALL SUBOPT_0xA6
; 0000 03F9          lcd_puts(lcd_buffer);         //      
; 0000 03FA          lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 03FB          sprintf(lcd_buffer,"Caca");//    
	CALL SUBOPT_0xA7
; 0000 03FC          lcd_puts(lcd_buffer);         //      
; 0000 03FD          lcd_gotoxy(0,3);              //  2    1 
	CALL SUBOPT_0x16
; 0000 03FE          sprintf(lcd_buffer,"RESET");//    
	CALL SUBOPT_0xA8
; 0000 03FF          lcd_puts(lcd_buffer);         //      
; 0000 0400          }
; 0000 0401                   if(menu==2)  //
_0x105:
	LDS  R26,_menu
	CPI  R26,LOW(0x2)
	BRNE _0x106
; 0000 0402          {
; 0000 0403          lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0404          sprintf(lcd_buffer,"Hacpo"  );//    
	CALL SUBOPT_0xA9
; 0000 0405          lcd_puts(lcd_buffer);         //      
; 0000 0406          lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 0407          sprintf(lcd_buffer,"Bpe    <<<" );//   
	__POINTW1FN _0x0,1422
	CALL SUBOPT_0x8
; 0000 0408          lcd_puts(lcd_buffer);         //      
; 0000 0409          lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 040A          sprintf(lcd_buffer,"Caca");//    
	CALL SUBOPT_0xA7
; 0000 040B          lcd_puts(lcd_buffer);         //      
; 0000 040C          lcd_gotoxy(0,3);              //  2    1 
	CALL SUBOPT_0x16
; 0000 040D          sprintf(lcd_buffer,"RESET");//    
	CALL SUBOPT_0xA8
; 0000 040E          lcd_puts(lcd_buffer);         //      
; 0000 040F          }
; 0000 0410                   if(menu==3)    //
_0x106:
	LDS  R26,_menu
	CPI  R26,LOW(0x3)
	BRNE _0x107
; 0000 0411          {
; 0000 0412          lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0413          sprintf(lcd_buffer,"Hacpo"     );//    
	CALL SUBOPT_0xA9
; 0000 0414          lcd_puts(lcd_buffer);         //      
; 0000 0415          lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 0416          sprintf(lcd_buffer,"Bpe");//   
	CALL SUBOPT_0xA6
; 0000 0417          lcd_puts(lcd_buffer);         //      
; 0000 0418          lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 0419          sprintf(lcd_buffer,"Caca  <<<");//    
	__POINTW1FN _0x0,1435
	CALL SUBOPT_0x8
; 0000 041A          lcd_puts(lcd_buffer);         //      
; 0000 041B          lcd_gotoxy(0,3);              //  2    1 
	CALL SUBOPT_0x16
; 0000 041C          sprintf(lcd_buffer,"RESET");//    
	CALL SUBOPT_0xA8
; 0000 041D          lcd_puts(lcd_buffer);         //      
; 0000 041E          }
; 0000 041F                   if(menu==4)   //
_0x107:
	LDS  R26,_menu
	CPI  R26,LOW(0x4)
	BRNE _0x108
; 0000 0420          {
; 0000 0421          lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0422          sprintf(lcd_buffer,"Hacpo"   );//    
	CALL SUBOPT_0xA9
; 0000 0423          lcd_puts(lcd_buffer);         //      
; 0000 0424          lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 0425          sprintf(lcd_buffer,"Bpe");//   
	CALL SUBOPT_0xA6
; 0000 0426          lcd_puts(lcd_buffer);         //      
; 0000 0427          lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 0428          sprintf(lcd_buffer,"Caca");//    
	CALL SUBOPT_0xA7
; 0000 0429          lcd_puts(lcd_buffer);         //      
; 0000 042A          lcd_gotoxy(0,3);              //  2    1 
	CALL SUBOPT_0x16
; 0000 042B          sprintf(lcd_buffer,"RESET      <<<");//    
	__POINTW1FN _0x0,1451
	CALL SUBOPT_0x8
; 0000 042C          lcd_puts(lcd_buffer);         //      
; 0000 042D          }
; 0000 042E       }
_0x108:
; 0000 042F       if(menu_p==1)
_0x104:
	LDS  R26,_menu_p
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x109
; 0000 0430       {
; 0000 0431         if(menu_pp==0)    //  
	LDS  R30,_menu_pp
	CPI  R30,0
	BREQ PC+3
	JMP _0x10A
; 0000 0432         {
; 0000 0433           if(menu_ppp==0)    // 
	LDS  R30,_menu_ppp
	CPI  R30,0
	BRNE _0x10B
; 0000 0434           {
; 0000 0435            lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0436            sprintf(lcd_buffer,"U oaĽoe <<<"  );// 
	__POINTW1FN _0x0,1466
	CALL SUBOPT_0x8
; 0000 0437            lcd_puts(lcd_buffer);         //      
; 0000 0438            lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 0439            sprintf(lcd_buffer,"U aĽoe");//      
	CALL SUBOPT_0xAA
; 0000 043A            lcd_puts(lcd_buffer);         //      
; 0000 043B            lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 043C            sprintf(lcd_buffer,"U acaĽoe");// 
	__POINTW1FN _0x0,1498
	CALL SUBOPT_0x8
; 0000 043D            lcd_puts(lcd_buffer);         //      
; 0000 043E                                  lcd_gotoxy(0,3);              //  1    1 
	CALL SUBOPT_0x16
; 0000 043F            sprintf(lcd_buffer,"aepa  ");//
	CALL SUBOPT_0xAB
; 0000 0440            lcd_puts(lcd_buffer);         //      
; 0000 0441            }
; 0000 0442            if(menu_ppp==1)  // 
_0x10B:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x1)
	BRNE _0x10C
; 0000 0443           {
; 0000 0444            lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0445            sprintf(lcd_buffer,"U oaĽoe"  );//
	CALL SUBOPT_0xAC
; 0000 0446            lcd_puts(lcd_buffer);         //      
; 0000 0447            lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 0448            sprintf(lcd_buffer,"U aĽoe <<<");//
	__POINTW1FN _0x0,1538
	CALL SUBOPT_0x8
; 0000 0449            lcd_puts(lcd_buffer);         //      
; 0000 044A            lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 044B            sprintf(lcd_buffer,"U acaĽoe");//
	__POINTW1FN _0x0,1498
	CALL SUBOPT_0x8
; 0000 044C            lcd_puts(lcd_buffer);         //      
; 0000 044D                                  lcd_gotoxy(0,3);              //  1    1 
	CALL SUBOPT_0x16
; 0000 044E            sprintf(lcd_buffer,"aepa  ");//
	CALL SUBOPT_0xAB
; 0000 044F            lcd_puts(lcd_buffer);         //      
; 0000 0450            }
; 0000 0451            if(menu_ppp==2)  // 
_0x10C:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x2)
	BRNE _0x10D
; 0000 0452           {
; 0000 0453            lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0454            sprintf(lcd_buffer,"U oaĽoe"  );//
	CALL SUBOPT_0xAC
; 0000 0455            lcd_puts(lcd_buffer);         //      
; 0000 0456            lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 0457            sprintf(lcd_buffer,"U aĽoe");//
	CALL SUBOPT_0xAA
; 0000 0458            lcd_puts(lcd_buffer);         //      
; 0000 0459            lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 045A            sprintf(lcd_buffer,"U acaĽoe <<<");//
	__POINTW1FN _0x0,1556
	CALL SUBOPT_0x8
; 0000 045B            lcd_puts(lcd_buffer);         //      
; 0000 045C                                  lcd_gotoxy(0,3);              //  1    1 
	CALL SUBOPT_0x16
; 0000 045D            sprintf(lcd_buffer,"aepa  ");//
	CALL SUBOPT_0xAB
; 0000 045E            lcd_puts(lcd_buffer);         //      
; 0000 045F            }
; 0000 0460            if(menu_ppp==3)  //
_0x10D:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x3)
	BRNE _0x10E
; 0000 0461           {
; 0000 0462            lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0463            sprintf(lcd_buffer,"U oaĽoe"  );//
	CALL SUBOPT_0xAC
; 0000 0464            lcd_puts(lcd_buffer);         //      
; 0000 0465            lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 0466            sprintf(lcd_buffer,"U aĽoe");//
	CALL SUBOPT_0xAA
; 0000 0467            lcd_puts(lcd_buffer);         //      
; 0000 0468            lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 0469            sprintf(lcd_buffer,"U acaĽoe  ");//
	__POINTW1FN _0x0,1575
	CALL SUBOPT_0x8
; 0000 046A            lcd_puts(lcd_buffer);         //      
; 0000 046B                       lcd_gotoxy(0,3);              //  1    1 
	CALL SUBOPT_0x16
; 0000 046C            sprintf(lcd_buffer,"aepa <<<");//
	__POINTW1FN _0x0,1592
	CALL SUBOPT_0x8
; 0000 046D            lcd_puts(lcd_buffer);         //      
; 0000 046E            }
; 0000 046F 
; 0000 0470          }
_0x10E:
; 0000 0471         if(menu_pp==1)
_0x10A:
	LDS  R26,_menu_pp
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x10F
; 0000 0472         {
; 0000 0473            if(menu_ppp==0)   // 
	LDS  R30,_menu_ppp
	CPI  R30,0
	BRNE _0x110
; 0000 0474           {
; 0000 0475                                    lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0476            sprintf(lcd_buffer,"HoaĽoe");//    
	__POINTW1FN _0x0,1605
	CALL SUBOPT_0x8
; 0000 0477            lcd_puts(lcd_buffer);         //      
; 0000 0478            lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 0479            sprintf(lcd_buffer,"  apǶee");//      
	CALL SUBOPT_0xAD
; 0000 047A            lcd_puts(lcd_buffer);         //      
; 0000 047B             lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x13
; 0000 047C            sprintf(lcd_buffer,"Un = %uV ",u_n);//      
	__POINTW1FN _0x0,1630
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R8
	CALL SUBOPT_0xAE
; 0000 047D            lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 047E 
; 0000 047F            }
; 0000 0480            if(menu_ppp==1)   // 
_0x110:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x1)
	BRNE _0x111
; 0000 0481           {
; 0000 0482             u_nnn=u_n;
	MOVW R10,R8
; 0000 0483                       lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0484            sprintf(lcd_buffer,"MaĽoe ");//    
	__POINTW1FN _0x0,1640
	CALL SUBOPT_0x8
; 0000 0485            lcd_puts(lcd_buffer);         //      
; 0000 0486                                  lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 0487            sprintf(lcd_buffer,"  apǶee");//   
	CALL SUBOPT_0xAD
; 0000 0488            lcd_puts(lcd_buffer);         //      
; 0000 0489            lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x13
; 0000 048A            sprintf(lcd_buffer,"U*=%u poeo",(100 - ddop));//      
	__POINTW1FN _0x0,1653
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xAF
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL SUBOPT_0xA4
; 0000 048B            lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL SUBOPT_0x94
; 0000 048C             lcd_gotoxy(0,3);              //  2    1 
; 0000 048D            sprintf(lcd_buffer,"Umin=%u V",(u_nnn*ddop)/100);//      
	__POINTW1FN _0x0,1669
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x30
	CALL SUBOPT_0xB0
	CALL SUBOPT_0xAE
; 0000 048E            lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 048F            }
; 0000 0490            if(menu_ppp==2)   // 
_0x111:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x2)
	BRNE _0x112
; 0000 0491           {
; 0000 0492            u_nnn=u_n;
	MOVW R10,R8
; 0000 0493            lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0494            sprintf(lcd_buffer,"MacaĽoe"  );//
	__POINTW1FN _0x0,1679
	CALL SUBOPT_0x8
; 0000 0495            lcd_puts(lcd_buffer);         //      
; 0000 0496            lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 0497            sprintf(lcd_buffer,"  apǶee");//
	CALL SUBOPT_0xAD
; 0000 0498            lcd_puts(lcd_buffer);         //      
; 0000 0499                      lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x13
; 0000 049A            sprintf(lcd_buffer,"U*=%u poeo",(100 - ddop_m));//      
	__POINTW1FN _0x0,1653
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xB1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL SUBOPT_0xA4
; 0000 049B            lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL SUBOPT_0x94
; 0000 049C                  lcd_gotoxy(0,3);              //  2    1 
; 0000 049D            sprintf(lcd_buffer,"Umax=%u V",u_nnn+(u_nnn-(u_nnn*ddop_m)/100));//      
	__POINTW1FN _0x0,1692
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x34
	CALL SUBOPT_0xB0
	MOVW R26,R30
	MOVW R30,R10
	SUB  R30,R26
	SBC  R31,R27
	ADD  R30,R10
	ADC  R31,R11
	CALL SUBOPT_0xAE
; 0000 049E            lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 049F            }
; 0000 04A0 
; 0000 04A1             if(menu_ppp==3)   // 
_0x112:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x3)
	BRNE _0x113
; 0000 04A2           {
; 0000 04A3 
; 0000 04A4            lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 04A5            sprintf(lcd_buffer,"aepa pecpa常"  );//  
	__POINTW1FN _0x0,1702
	CALL SUBOPT_0x8
; 0000 04A6            lcd_puts(lcd_buffer);         //      
; 0000 04A7                      lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x13
; 0000 04A8            sprintf(lcd_buffer,"T=%u cey",t_zad);//      
	__POINTW1FN _0x0,1723
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x54
	CALL SUBOPT_0x86
	CALL SUBOPT_0x87
; 0000 04A9            lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL _lcd_puts
; 0000 04AA 
; 0000 04AB            }
; 0000 04AC 
; 0000 04AD         }
_0x113:
; 0000 04AE       }
_0x10F:
; 0000 04AF       if(menu_p==2)   // 
_0x109:
	LDS  R26,_menu_p
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0x114
; 0000 04B0       {
; 0000 04B1           if(rtc==0)
	LDS  R30,_rtc
	CPI  R30,0
	BRNE _0x115
; 0000 04B2           {
; 0000 04B3                         lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 04B4             sprintf(lcd_buffer,"Hacpoa aco",);//     
	CALL SUBOPT_0xB2
; 0000 04B5              lcd_puts(lcd_buffer);         //      
; 0000 04B6            lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 04B7            sprintf(lcd_buffer,"ac",);//    
	__POINTW1FN _0x0,1755
	CALL SUBOPT_0x8
; 0000 04B8             lcd_puts(lcd_buffer);         //      
; 0000 04B9             lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x13
; 0000 04BA            sprintf(lcd_buffer,"aa %i.%i.%i",d,mo,y+2000);//      
	CALL SUBOPT_0xB3
; 0000 04BB             lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x94
; 0000 04BC             lcd_gotoxy(0,3);              //  2    1 
; 0000 04BD            sprintf(lcd_buffer,"Bpe %i<:%i%i:%i%i ",h,m/10,m%10,s/10,s%10 );//      
	__POINTW1FN _0x0,1774
	CALL SUBOPT_0xB4
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xB6
	CALL SUBOPT_0xB7
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xB8
	CALL SUBOPT_0xB9
; 0000 04BE            lcd_puts(lcd_buffer);         //      
	CALL _lcd_puts
; 0000 04BF           }
; 0000 04C0                     if(rtc==1)  //
_0x115:
	LDS  R26,_rtc
	CPI  R26,LOW(0x1)
	BRNE _0x116
; 0000 04C1           {
; 0000 04C2                         lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 04C3             sprintf(lcd_buffer,"Hacpoa aco",);//     
	CALL SUBOPT_0xB2
; 0000 04C4              lcd_puts(lcd_buffer);         //      
; 0000 04C5            lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 04C6            sprintf(lcd_buffer,"My",);//    
	__POINTW1FN _0x0,1795
	CALL SUBOPT_0x8
; 0000 04C7             lcd_puts(lcd_buffer);         //      
; 0000 04C8             lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x13
; 0000 04C9            sprintf(lcd_buffer,"aa %i.%i.%i",d,mo,y+2000);//      
	CALL SUBOPT_0xB3
; 0000 04CA             lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x94
; 0000 04CB             lcd_gotoxy(0,3);              //  2    1 
; 0000 04CC            sprintf(lcd_buffer,"Bpe %i:%i%i<:%i%i ",h,m/10,m%10,s/10,s%10 );//      
	__POINTW1FN _0x0,1802
	CALL SUBOPT_0xB4
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xB6
	CALL SUBOPT_0xB7
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xB8
	CALL SUBOPT_0xB9
; 0000 04CD            lcd_puts(lcd_buffer);         //      
	CALL _lcd_puts
; 0000 04CE           }
; 0000 04CF                     if(rtc==2)   //
_0x116:
	LDS  R26,_rtc
	CPI  R26,LOW(0x2)
	BRNE _0x117
; 0000 04D0           {
; 0000 04D1                         lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 04D2             sprintf(lcd_buffer,"Hacpoa aco",);//     
	CALL SUBOPT_0xB2
; 0000 04D3              lcd_puts(lcd_buffer);         //      
; 0000 04D4            lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 04D5            sprintf(lcd_buffer,"Cey",);//    
	__POINTW1FN _0x0,1823
	CALL SUBOPT_0x8
; 0000 04D6             lcd_puts(lcd_buffer);         //      
; 0000 04D7             lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x13
; 0000 04D8            sprintf(lcd_buffer,"aa %i.%i.%i",d,mo,y+2000);//      
	CALL SUBOPT_0xB3
; 0000 04D9             lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x94
; 0000 04DA             lcd_gotoxy(0,3);              //  2    1 
; 0000 04DB            sprintf(lcd_buffer,"Bpe %i:%i%i:%i%i< ",h,m/10,m%10,s/10,s%10 );//      
	__POINTW1FN _0x0,1831
	CALL SUBOPT_0xB4
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xB6
	CALL SUBOPT_0xB7
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xB8
	CALL SUBOPT_0xB9
; 0000 04DC            lcd_puts(lcd_buffer);         //      
	CALL _lcd_puts
; 0000 04DD           }
; 0000 04DE                     if(rtc==3)   //
_0x117:
	LDS  R26,_rtc
	CPI  R26,LOW(0x3)
	BRNE _0x118
; 0000 04DF           {
; 0000 04E0                         lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 04E1             sprintf(lcd_buffer,"Hacpoa aco",);//     
	CALL SUBOPT_0xB2
; 0000 04E2              lcd_puts(lcd_buffer);         //      
; 0000 04E3            lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 04E4            sprintf(lcd_buffer,"ླྀ",);//    
	__POINTW1FN _0x0,1852
	CALL SUBOPT_0x8
; 0000 04E5             lcd_puts(lcd_buffer);         //      
; 0000 04E6             lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x13
; 0000 04E7            sprintf(lcd_buffer,"aa %i<.%i.%i",d,mo,y+2000);//      
	__POINTW1FN _0x0,1856
	CALL SUBOPT_0xBA
	CALL SUBOPT_0xBB
; 0000 04E8             lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x94
; 0000 04E9             lcd_gotoxy(0,3);              //  2    1 
; 0000 04EA            sprintf(lcd_buffer,"Bpe %i:%i%i:%i%i ",h,m/10,m%10,s/10,s%10 );//      
	CALL SUBOPT_0xBC
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xB6
	CALL SUBOPT_0xB7
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xB8
	CALL SUBOPT_0xB9
; 0000 04EB            lcd_puts(lcd_buffer);         //      
	CALL _lcd_puts
; 0000 04EC           }
; 0000 04ED                     if(rtc==4)   //
_0x118:
	LDS  R26,_rtc
	CPI  R26,LOW(0x4)
	BRNE _0x119
; 0000 04EE           {
; 0000 04EF                         lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 04F0             sprintf(lcd_buffer,"Hacpoa aco",);//     
	CALL SUBOPT_0xB2
; 0000 04F1              lcd_puts(lcd_buffer);         //      
; 0000 04F2            lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 04F3            sprintf(lcd_buffer,"Mec",);//    
	__POINTW1FN _0x0,1891
	CALL SUBOPT_0x8
; 0000 04F4             lcd_puts(lcd_buffer);         //      
; 0000 04F5             lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x13
; 0000 04F6            sprintf(lcd_buffer,"aa %i.%i<.%i",d,mo,y+2000);//      
	__POINTW1FN _0x0,1897
	CALL SUBOPT_0xBA
	CALL SUBOPT_0xBB
; 0000 04F7             lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x94
; 0000 04F8             lcd_gotoxy(0,3);              //  2    1 
; 0000 04F9            sprintf(lcd_buffer,"Bpe %i:%i%i:%i%i ",h,m/10,m%10,s/10,s%10 );//      
	CALL SUBOPT_0xBC
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xB6
	CALL SUBOPT_0xB7
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xB8
	CALL SUBOPT_0xB9
; 0000 04FA            lcd_puts(lcd_buffer);         //      
	CALL _lcd_puts
; 0000 04FB           }
; 0000 04FC                     if(rtc==5) //
_0x119:
	LDS  R26,_rtc
	CPI  R26,LOW(0x5)
	BRNE _0x11A
; 0000 04FD           {
; 0000 04FE                         lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 04FF             sprintf(lcd_buffer,"Hacpoa aco",);//     
	CALL SUBOPT_0xB2
; 0000 0500              lcd_puts(lcd_buffer);         //      
; 0000 0501            lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 0502            sprintf(lcd_buffer,"o",);//    
	__POINTW1FN _0x0,1912
	CALL SUBOPT_0x8
; 0000 0503             lcd_puts(lcd_buffer);         //      
; 0000 0504             lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x13
; 0000 0505            sprintf(lcd_buffer,"aa %i.%i.%i<",d,mo,y+2000);//      
	__POINTW1FN _0x0,1916
	CALL SUBOPT_0xBA
	CALL SUBOPT_0xBB
; 0000 0506             lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x94
; 0000 0507             lcd_gotoxy(0,3);              //  2    1 
; 0000 0508            sprintf(lcd_buffer,"Bpe %i:%i%i:%i%i ",h,m/10,m%10,s/10,s%10 );//      
	CALL SUBOPT_0xBC
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xB6
	CALL SUBOPT_0xB7
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xB8
	CALL SUBOPT_0xB9
; 0000 0509            lcd_puts(lcd_buffer);         //      
	CALL _lcd_puts
; 0000 050A           }
; 0000 050B       }
_0x11A:
; 0000 050C       if(menu_p==3)   //
_0x114:
	LDS  R26,_menu_p
	CPI  R26,LOW(0x3)
	BREQ PC+3
	JMP _0x11B
; 0000 050D       {
; 0000 050E            if(menu_pp==0)    // 
	LDS  R30,_menu_pp
	CPI  R30,0
	BREQ PC+3
	JMP _0x11C
; 0000 050F         {
; 0000 0510           if(menu_ppp==0)      //  
	LDS  R30,_menu_ppp
	CPI  R30,0
	BRNE _0x11D
; 0000 0511           {
; 0000 0512            lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0513            sprintf(lcd_buffer,"aa  A  <<<"  );//
	__POINTW1FN _0x0,1262
	CALL SUBOPT_0x8
; 0000 0514            lcd_puts(lcd_buffer);         //      
; 0000 0515            lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 0516            sprintf(lcd_buffer,"aa  B");//
	__POINTW1FN _0x0,1931
	CALL SUBOPT_0x8
; 0000 0517            lcd_puts(lcd_buffer);         //      
; 0000 0518            lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 0519            sprintf(lcd_buffer,"aa  C");//
	__POINTW1FN _0x0,1939
	CALL SUBOPT_0x8
; 0000 051A            lcd_puts(lcd_buffer);         //      
; 0000 051B            }
; 0000 051C            if(menu_ppp==1)    //  
_0x11D:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x1)
	BRNE _0x11E
; 0000 051D           {
; 0000 051E            lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 051F            sprintf(lcd_buffer,"aa  A"  );//
	__POINTW1FN _0x0,1947
	CALL SUBOPT_0x8
; 0000 0520            lcd_puts(lcd_buffer);         //      
; 0000 0521            lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 0522            sprintf(lcd_buffer,"aa  B  <<<");//
	__POINTW1FN _0x0,1314
	CALL SUBOPT_0x8
; 0000 0523            lcd_puts(lcd_buffer);         //      
; 0000 0524            lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 0525            sprintf(lcd_buffer,"aa  C");//
	__POINTW1FN _0x0,1939
	CALL SUBOPT_0x8
; 0000 0526            lcd_puts(lcd_buffer);         //      
; 0000 0527            }
; 0000 0528            if(menu_ppp==2)    //  
_0x11E:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x2)
	BRNE _0x11F
; 0000 0529           {
; 0000 052A            lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 052B            sprintf(lcd_buffer,"aa  A"  );//
	__POINTW1FN _0x0,1947
	CALL SUBOPT_0x8
; 0000 052C            lcd_puts(lcd_buffer);         //      
; 0000 052D            lcd_gotoxy(0,1);              //  2    1 
	CALL SUBOPT_0xB
; 0000 052E            sprintf(lcd_buffer,"aa  B");//
	__POINTW1FN _0x0,1931
	CALL SUBOPT_0x8
; 0000 052F            lcd_puts(lcd_buffer);         //      
; 0000 0530            lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 0531            sprintf(lcd_buffer,"aa  C   <<<");//
	__POINTW1FN _0x0,1955
	CALL SUBOPT_0x8
; 0000 0532            lcd_puts(lcd_buffer);         //      
; 0000 0533            }
; 0000 0534 
; 0000 0535          }
_0x11F:
; 0000 0536         if(menu_pp==1)  //  
_0x11C:
	LDS  R26,_menu_pp
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x120
; 0000 0537         {
; 0000 0538                if(menu_ppp==0)     //
	LDS  R30,_menu_ppp
	CPI  R30,0
	BREQ PC+3
	JMP _0x121
; 0000 0539                 {
; 0000 053A                if(del_a==0)
	LDS  R30,_del_a
	CPI  R30,0
	BREQ PC+3
	JMP _0x122
; 0000 053B                {
; 0000 053C               lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 053D               sprintf(lcd_buffer,"Caca a A",);//     
	__POINTW1FN _0x0,1969
	CALL SUBOPT_0x8
; 0000 053E              lcd_puts(lcd_buffer);         //      
; 0000 053F              lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0x83
; 0000 0540              if(proval_tma[stat_na]==0){sprintf(lcd_buffer,"N=%u  Ta=%um%umc",stat_na, proval_tma[stat_na], proval_ta[stat_na]);}//      
	CALL SUBOPT_0xBD
	CPI  R30,0
	BRNE _0x123
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,1987
	RJMP _0x2E3
; 0000 0541              else{sprintf(lcd_buffer,"N=%u  Ta=%um%uc",stat_na, proval_tma[stat_na], proval_ta[stat_na]);}
_0x123:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,2004
_0x2E3:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_stat_na
	CALL SUBOPT_0xBE
	CALL SUBOPT_0xBD
	CALL SUBOPT_0xBE
	LDS  R30,_stat_na
	CALL SUBOPT_0x0
	CALL SUBOPT_0x88
	CALL SUBOPT_0xBF
; 0000 0542              lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 0543              lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x8B
; 0000 0544              if(proval_ua[stat_na]>=u_n){sprintf(lcd_buffer,"Ua=%u Ua*=+%u", proval_ua[stat_na], proval_ua[stat_na]-u_n );}//      
	CALL SUBOPT_0xC0
	CALL SUBOPT_0x9A
	CP   R30,R8
	CPC  R31,R9
	BRLO _0x125
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,2020
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xC0
	CALL SUBOPT_0x88
	CALL SUBOPT_0xC0
	CALL SUBOPT_0x9A
	CALL SUBOPT_0xC1
	CALL SUBOPT_0x89
; 0000 0545              if(proval_ua[stat_na] <u_n){sprintf(lcd_buffer,"Ua=%u Ua*=-%u", proval_ua[stat_na], u_n-proval_ua[stat_na] );}
_0x125:
	CALL SUBOPT_0xC0
	CALL SUBOPT_0x9A
	CP   R30,R8
	CPC  R31,R9
	BRSH _0x126
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,2034
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xC0
	CALL SUBOPT_0x88
	CALL SUBOPT_0xC0
	CALL SUBOPT_0x9A
	CALL SUBOPT_0xC2
	CALL SUBOPT_0x89
; 0000 0546               lcd_puts(lcd_buffer);         //      
_0x126:
	CALL SUBOPT_0x85
	CALL SUBOPT_0x94
; 0000 0547                lcd_gotoxy(0,3);              //  2    1 
; 0000 0548               sprintf(lcd_buffer,"%i:%i%i - %i/%i  ", time_ha[stat_na], time_ma[stat_na]/10,time_ma[stat_na]%10,date_da[stat_na],date_ma[stat_na] );//      
	CALL SUBOPT_0xC3
	CALL SUBOPT_0xC4
	SUBI R26,LOW(-_time_ha)
	SBCI R27,HIGH(-_time_ha)
	CALL SUBOPT_0xC5
	CALL SUBOPT_0xC4
	SUBI R26,LOW(-_time_ma)
	SBCI R27,HIGH(-_time_ma)
	CALL SUBOPT_0x58
	MOVW R26,R30
	CALL SUBOPT_0xA3
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xC4
	SUBI R26,LOW(-_time_ma)
	SBCI R27,HIGH(-_time_ma)
	CALL SUBOPT_0x58
	CALL SUBOPT_0xC6
	CALL SUBOPT_0xC4
	SUBI R26,LOW(-_date_da)
	SBCI R27,HIGH(-_date_da)
	CALL SUBOPT_0xC5
	CALL SUBOPT_0xC4
	SUBI R26,LOW(-_date_ma)
	SBCI R27,HIGH(-_date_ma)
	CALL SUBOPT_0xC5
	CALL SUBOPT_0xC7
; 0000 0549              lcd_puts(lcd_buffer);         //      
	RJMP _0x2E4
; 0000 054A              }
; 0000 054B              else
_0x122:
; 0000 054C              {
; 0000 054D                            lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 054E             sprintf(lcd_buffer,"a aǿ - A ?",);//      - 
	__POINTW1FN _0x0,2066
	CALL SUBOPT_0x8
; 0000 054F              lcd_puts(lcd_buffer);         //      
; 0000 0550                          lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 0551             sprintf(lcd_buffer," oe - OK    ",);//      - 
	CALL SUBOPT_0xC8
; 0000 0552              lcd_puts(lcd_buffer);         //      
; 0000 0553                          lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 0554             sprintf(lcd_buffer," o㿳epe  ",);//     
	CALL SUBOPT_0xC9
; 0000 0555              lcd_puts(lcd_buffer);         //      
; 0000 0556                     lcd_gotoxy(0,3);              //  1    1 
	CALL SUBOPT_0x16
; 0000 0557             sprintf(lcd_buffer,"ae yc     ",);//     
	CALL SUBOPT_0xCA
; 0000 0558              lcd_puts(lcd_buffer);         //      
_0x2E4:
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	CALL SUBOPT_0x95
; 0000 0559              }
; 0000 055A           }
; 0000 055B                 if(menu_ppp==1)   //
_0x121:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x128
; 0000 055C                  {
; 0000 055D                  if(del_b==0)
	LDS  R30,_del_b
	CPI  R30,0
	BREQ PC+3
	JMP _0x129
; 0000 055E                  {
; 0000 055F                  lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0560                  sprintf(lcd_buffer,"Caca a B",);//      
	__POINTW1FN _0x0,2146
	CALL SUBOPT_0x8
; 0000 0561                  lcd_puts(lcd_buffer);         //      
; 0000 0562                  lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0x83
; 0000 0563                  if(proval_tmb[stat_nb]==0){sprintf(lcd_buffer,"N=%u  Tb=%um%umc",stat_nb, proval_tmb[stat_nb], proval_tb[stat_nb]);}//      
	CALL SUBOPT_0xCB
	CALL __EEPROMRDB
	CPI  R30,0
	BRNE _0x12A
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,2164
	RJMP _0x2E5
; 0000 0564                  else {sprintf(lcd_buffer,"N=%u  Tb=%um%uc",stat_nb, proval_tmb[stat_nb], proval_tb[stat_nb]);}
_0x12A:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,2181
_0x2E5:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_stat_nb
	CALL SUBOPT_0xBE
	CALL SUBOPT_0xCB
	CALL SUBOPT_0xC5
	LDS  R30,_stat_nb
	CALL SUBOPT_0xD
	CALL SUBOPT_0x88
	CALL SUBOPT_0xBF
; 0000 0565                  lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 0566                  lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x8B
; 0000 0567                  if(proval_ub[stat_nb]>=u_n){sprintf(lcd_buffer,"Ub=%u Ub*=+%u", proval_ub[stat_nb], proval_ub[stat_nb] - u_n );}//      
	CALL SUBOPT_0xCC
	CALL SUBOPT_0x9A
	CP   R30,R8
	CPC  R31,R9
	BRLO _0x12C
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,2197
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xCC
	CALL SUBOPT_0x88
	CALL SUBOPT_0xCC
	CALL SUBOPT_0x9A
	CALL SUBOPT_0xC1
	CALL SUBOPT_0x89
; 0000 0568                  if(proval_ub[stat_nb]<u_n){sprintf(lcd_buffer,"Ub=%u Ub*=-%u", proval_ub[stat_nb], u_n - proval_ub[stat_nb] );}
_0x12C:
	CALL SUBOPT_0xCC
	CALL SUBOPT_0x9A
	CP   R30,R8
	CPC  R31,R9
	BRSH _0x12D
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,2211
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xCC
	CALL SUBOPT_0x88
	CALL SUBOPT_0xCC
	CALL SUBOPT_0x9A
	CALL SUBOPT_0xC2
	CALL SUBOPT_0x89
; 0000 0569                  lcd_puts(lcd_buffer);         //      
_0x12D:
	CALL SUBOPT_0x85
	CALL SUBOPT_0x94
; 0000 056A                 lcd_gotoxy(0,3);              //  2    1 
; 0000 056B                 sprintf(lcd_buffer,"%i:%i%i - %i/%i  ", time_hb[stat_nb], time_mb[stat_nb]/10,time_mb[stat_nb]%10,date_db[stat_nb],date_mb[stat_nb] );//      
	CALL SUBOPT_0xC3
	CALL SUBOPT_0xCD
	SUBI R26,LOW(-_time_hb)
	SBCI R27,HIGH(-_time_hb)
	CALL SUBOPT_0xC5
	CALL SUBOPT_0xCD
	SUBI R26,LOW(-_time_mb)
	SBCI R27,HIGH(-_time_mb)
	CALL SUBOPT_0x58
	MOVW R26,R30
	CALL SUBOPT_0xA3
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xCD
	SUBI R26,LOW(-_time_mb)
	SBCI R27,HIGH(-_time_mb)
	CALL SUBOPT_0x58
	CALL SUBOPT_0xC6
	CALL SUBOPT_0xCD
	SUBI R26,LOW(-_date_db)
	SBCI R27,HIGH(-_date_db)
	CALL SUBOPT_0xC5
	CALL SUBOPT_0xCD
	SUBI R26,LOW(-_date_mb)
	SBCI R27,HIGH(-_date_mb)
	CALL SUBOPT_0xC5
	CALL SUBOPT_0xC7
; 0000 056C                 lcd_puts(lcd_buffer);         //      
	RJMP _0x2E6
; 0000 056D                 }
; 0000 056E                else
_0x129:
; 0000 056F                 {
; 0000 0570                            lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0571             sprintf(lcd_buffer,"a aǿ - B ?",);//      - 
	__POINTW1FN _0x0,2225
	CALL SUBOPT_0x8
; 0000 0572              lcd_puts(lcd_buffer);         //      
; 0000 0573                          lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 0574             sprintf(lcd_buffer," oe - OK    ",);//      - 
	CALL SUBOPT_0xC8
; 0000 0575              lcd_puts(lcd_buffer);         //      
; 0000 0576                          lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 0577             sprintf(lcd_buffer," o㿳epe  ",);//     
	CALL SUBOPT_0xC9
; 0000 0578              lcd_puts(lcd_buffer);         //      
; 0000 0579                     lcd_gotoxy(0,3);              //  1    1 
	CALL SUBOPT_0x16
; 0000 057A             sprintf(lcd_buffer,"ae yc     ",);//     
	CALL SUBOPT_0xCA
; 0000 057B              lcd_puts(lcd_buffer);         //      
_0x2E6:
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	CALL SUBOPT_0x95
; 0000 057C              }
; 0000 057D 
; 0000 057E               }
; 0000 057F                 if(menu_ppp==2)    //
_0x128:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0x12F
; 0000 0580                  {
; 0000 0581              if(del_c==0)
	LDS  R30,_del_c
	CPI  R30,0
	BREQ PC+3
	JMP _0x130
; 0000 0582              {
; 0000 0583             lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0584            sprintf(lcd_buffer,"Caca a C",);//      
	__POINTW1FN _0x0,2246
	CALL SUBOPT_0x8
; 0000 0585             lcd_puts(lcd_buffer);         //      
; 0000 0586            lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0x83
; 0000 0587            if(proval_tmc[stat_nc]==0){sprintf(lcd_buffer,"N=%u  Tc=%um%umc",stat_nc, proval_tmc[stat_nc], proval_tc[stat_nc]);}//      
	CALL SUBOPT_0xCE
	CALL __EEPROMRDB
	CPI  R30,0
	BRNE _0x131
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,2264
	RJMP _0x2E7
; 0000 0588            else {sprintf(lcd_buffer,"N=%u  Tc=%um%uc",stat_nc, proval_tmc[stat_nc], proval_tc[stat_nc]);}
_0x131:
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,2281
_0x2E7:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_stat_nc
	CALL SUBOPT_0xBE
	CALL SUBOPT_0xCE
	CALL SUBOPT_0xC5
	LDS  R30,_stat_nc
	CALL SUBOPT_0x10
	CALL SUBOPT_0x88
	CALL SUBOPT_0xBF
; 0000 0589            lcd_puts(lcd_buffer);         //      
	CALL SUBOPT_0x85
	CALL SUBOPT_0x8A
; 0000 058A            lcd_gotoxy(0,2);              //  2    1 
	CALL SUBOPT_0x8B
; 0000 058B            if(proval_uc[stat_nc]>=u_n){sprintf(lcd_buffer,"Uc=%u Uc*=+%u", proval_uc[stat_nc], proval_uc[stat_nc]-u_n );} //      
	CALL SUBOPT_0xCF
	CALL SUBOPT_0x9A
	CP   R30,R8
	CPC  R31,R9
	BRLO _0x133
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,2297
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xCF
	CALL SUBOPT_0x88
	CALL SUBOPT_0xCF
	CALL SUBOPT_0x9A
	CALL SUBOPT_0xC1
	CALL SUBOPT_0x89
; 0000 058C            if(proval_uc[stat_nc]<u_n){sprintf(lcd_buffer,"Uc=%u Uc*=-%u", proval_uc[stat_nc], u_n-proval_uc[stat_nc] );}
_0x133:
	CALL SUBOPT_0xCF
	CALL SUBOPT_0x9A
	CP   R30,R8
	CPC  R31,R9
	BRSH _0x134
	CALL SUBOPT_0x85
	__POINTW1FN _0x0,2311
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xCF
	CALL SUBOPT_0x88
	CALL SUBOPT_0xCF
	CALL SUBOPT_0x9A
	CALL SUBOPT_0xC2
	CALL SUBOPT_0x89
; 0000 058D            lcd_puts(lcd_buffer);         //      
_0x134:
	CALL SUBOPT_0x85
	CALL SUBOPT_0x94
; 0000 058E            lcd_gotoxy(0,3);              //  2    1 
; 0000 058F             sprintf(lcd_buffer,"%i:%i%i - %i/%i  ", time_hc[stat_nc], time_mc[stat_nc]/10,time_mc[stat_nc]%10, date_dc[stat_nc], date_mc[stat_nc] );//      
	CALL SUBOPT_0xC3
	CALL SUBOPT_0xD0
	SUBI R26,LOW(-_time_hc)
	SBCI R27,HIGH(-_time_hc)
	CALL SUBOPT_0xC5
	CALL SUBOPT_0xD0
	SUBI R26,LOW(-_time_mc)
	SBCI R27,HIGH(-_time_mc)
	CALL SUBOPT_0x58
	MOVW R26,R30
	CALL SUBOPT_0xA3
	CALL SUBOPT_0xB5
	CALL SUBOPT_0xD0
	SUBI R26,LOW(-_time_mc)
	SBCI R27,HIGH(-_time_mc)
	CALL SUBOPT_0x58
	CALL SUBOPT_0xC6
	CALL SUBOPT_0xD0
	SUBI R26,LOW(-_date_dc)
	SBCI R27,HIGH(-_date_dc)
	CALL SUBOPT_0xC5
	CALL SUBOPT_0xD0
	SUBI R26,LOW(-_date_mc)
	SBCI R27,HIGH(-_date_mc)
	CALL SUBOPT_0xC5
	CALL SUBOPT_0xC7
; 0000 0590            lcd_puts(lcd_buffer);         //      
	RJMP _0x2E8
; 0000 0591            }
; 0000 0592             else
_0x130:
; 0000 0593              {
; 0000 0594                            lcd_gotoxy(0,0);              //  1    1 
	CALL SUBOPT_0x15
; 0000 0595             sprintf(lcd_buffer,"a aǿ - C ?",);//      - 
	__POINTW1FN _0x0,2325
	CALL SUBOPT_0x8
; 0000 0596              lcd_puts(lcd_buffer);         //      
; 0000 0597                          lcd_gotoxy(0,1);              //  1    1 
	CALL SUBOPT_0xB
; 0000 0598             sprintf(lcd_buffer," oe - OK    ",);//      - 
	CALL SUBOPT_0xC8
; 0000 0599              lcd_puts(lcd_buffer);         //      
; 0000 059A                          lcd_gotoxy(0,2);              //  1    1 
	CALL SUBOPT_0x13
; 0000 059B             sprintf(lcd_buffer," o㿳epe  ",);//     
	CALL SUBOPT_0xC9
; 0000 059C              lcd_puts(lcd_buffer);         //      
; 0000 059D                     lcd_gotoxy(0,3);              //  1    1 
	CALL SUBOPT_0x16
; 0000 059E             sprintf(lcd_buffer,"ae yc     ",);//     
	CALL SUBOPT_0xCA
; 0000 059F              lcd_puts(lcd_buffer);         //      
_0x2E8:
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	CALL SUBOPT_0x95
; 0000 05A0              }
; 0000 05A1          }
; 0000 05A2 
; 0000 05A3         }
_0x12F:
; 0000 05A4 
; 0000 05A5       }
_0x120:
; 0000 05A6 
; 0000 05A7     }
_0x11B:
; 0000 05A8 
; 0000 05A9   }
_0x103:
	RET
;
;  void btn()    // 
; 0000 05AC   {
_btn:
; 0000 05AD    if(menu_def!=8&&menu_def!=9&&menu==0){ if(btn_m==0){delay_ms(50);while(!btn_m){;};menu++; flag_st=0; lcd_clear();} }
	LDS  R26,_menu_def
	CPI  R26,LOW(0x8)
	BREQ _0x137
	CPI  R26,LOW(0x9)
	BREQ _0x137
	LDS  R26,_menu
	CPI  R26,LOW(0x0)
	BREQ _0x138
_0x137:
	RJMP _0x136
_0x138:
	SBIC 0x16,7
	RJMP _0x139
	CALL SUBOPT_0xD1
_0x13A:
	SBIS 0x16,7
	RJMP _0x13A
	LDS  R30,_menu
	SUBI R30,-LOW(1)
	STS  _menu,R30
	LDI  R30,LOW(0)
	STS  _flag_st,R30
	CALL _lcd_clear
_0x139:
; 0000 05AE     if(menu>=5){menu=0;lcd_clear();}
_0x136:
	LDS  R26,_menu
	CPI  R26,LOW(0x5)
	BRLO _0x13D
	LDI  R30,LOW(0)
	CALL SUBOPT_0xD2
; 0000 05AF     if(menu_ppp!=0&&menu_ppp!=1&&menu_ppp!=2){flag_st=0;}
_0x13D:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x0)
	BREQ _0x13F
	CPI  R26,LOW(0x1)
	BREQ _0x13F
	CPI  R26,LOW(0x2)
	BRNE _0x140
_0x13F:
	RJMP _0x13E
_0x140:
	LDI  R30,LOW(0)
	STS  _flag_st,R30
; 0000 05B0     if(menu==0)
_0x13E:
	LDS  R30,_menu
	CPI  R30,0
	BREQ PC+3
	JMP _0x141
; 0000 05B1     {
; 0000 05B2        if(menu_def==0&&btn_plus==0)
	LDS  R26,_menu_def
	CPI  R26,LOW(0x0)
	BRNE _0x143
	CALL SUBOPT_0xD3
	BREQ _0x144
_0x143:
	RJMP _0x142
_0x144:
; 0000 05B3        {
; 0000 05B4        delay_ms(50);
	CALL SUBOPT_0xD1
; 0000 05B5         while(!btn_plus){;};
_0x145:
	SBIS 0x16,5
	RJMP _0x145
; 0000 05B6        lcd_clear();
	CALL _lcd_clear
; 0000 05B7         slep();
	CALL _slep
; 0000 05B8        }
; 0000 05B9       if(menu_def!=8&&menu_def!=9)
_0x142:
	LDS  R26,_menu_def
	CPI  R26,LOW(0x8)
	BREQ _0x149
	CPI  R26,LOW(0x9)
	BRNE _0x14A
_0x149:
	RJMP _0x148
_0x14A:
; 0000 05BA       {
; 0000 05BB        if(btn_plus==0&&menu_def!=0){delay_ms(50);while(!btn_plus){;};lcd_clear(); menu_def--;}
	CALL SUBOPT_0xD3
	BRNE _0x14C
	LDS  R26,_menu_def
	CPI  R26,LOW(0x0)
	BRNE _0x14D
_0x14C:
	RJMP _0x14B
_0x14D:
	CALL SUBOPT_0xD1
_0x14E:
	SBIS 0x16,5
	RJMP _0x14E
	CALL SUBOPT_0xD4
	SUBI R30,LOW(1)
	STS  _menu_def,R30
; 0000 05BC        if(btn_minus==0){delay_ms(50);while(!btn_minus){;};lcd_clear(); menu_def++;}
_0x14B:
	SBIC 0x16,6
	RJMP _0x151
	CALL SUBOPT_0xD1
_0x152:
	SBIS 0x16,6
	RJMP _0x152
	CALL SUBOPT_0xD4
	SUBI R30,-LOW(1)
	STS  _menu_def,R30
; 0000 05BD        if(menu_def>=6){menu_def=0;lcd_clear();}
_0x151:
	LDS  R26,_menu_def
	CPI  R26,LOW(0x6)
	BRLO _0x155
	LDI  R30,LOW(0)
	STS  _menu_def,R30
	CALL _lcd_clear
; 0000 05BE        if(btn_d==0){delay_ms(50);while(!btn_d){;};lcd_clear();menu_def=8;}
_0x155:
	SBIC 0x16,4
	RJMP _0x156
	CALL SUBOPT_0xD1
_0x157:
	SBIS 0x16,4
	RJMP _0x157
	CALL _lcd_clear
	LDI  R30,LOW(8)
	STS  _menu_def,R30
; 0000 05BF       }
_0x156:
; 0000 05C0 
; 0000 05C1       if(menu_def==8||menu_def==9){if(menu_def<8){menu_def=4;}if(menu_def>9){menu_def=0;lcd_clear();}}
_0x148:
	LDS  R26,_menu_def
	CPI  R26,LOW(0x8)
	BREQ _0x15B
	CPI  R26,LOW(0x9)
	BRNE _0x15A
_0x15B:
	LDS  R26,_menu_def
	CPI  R26,LOW(0x8)
	BRSH _0x15D
	LDI  R30,LOW(4)
	STS  _menu_def,R30
_0x15D:
	LDS  R26,_menu_def
	CPI  R26,LOW(0xA)
	BRLO _0x15E
	LDI  R30,LOW(0)
	STS  _menu_def,R30
	CALL _lcd_clear
_0x15E:
; 0000 05C2       if(go_izm==0)
_0x15A:
	LDS  R30,_go_izm
	CPI  R30,0
	BREQ PC+3
	JMP _0x15F
; 0000 05C3      {
; 0000 05C4       if(menu_def==8)
	LDS  R26,_menu_def
	CPI  R26,LOW(0x8)
	BRNE _0x160
; 0000 05C5       {
; 0000 05C6        if(btn_plus==0){delay_ms(50);while(!btn_plus){;};lcd_clear(); menu_def--;}
	SBIC 0x16,5
	RJMP _0x161
	CALL SUBOPT_0xD1
_0x162:
	SBIS 0x16,5
	RJMP _0x162
	CALL SUBOPT_0xD4
	SUBI R30,LOW(1)
	STS  _menu_def,R30
; 0000 05C7        if(btn_minus==0){delay_ms(50);while(!btn_minus){;};lcd_clear(); menu_def++;}
_0x161:
	SBIC 0x16,6
	RJMP _0x165
	CALL SUBOPT_0xD1
_0x166:
	SBIS 0x16,6
	RJMP _0x166
	CALL SUBOPT_0xD4
	SUBI R30,-LOW(1)
	STS  _menu_def,R30
; 0000 05C8          if(btn_d==0)
_0x165:
	SBIC 0x16,4
	RJMP _0x169
; 0000 05C9        {delay_ms(50);
	CALL SUBOPT_0xD1
; 0000 05CA        while(!btn_d){;};
_0x16A:
	SBIS 0x16,4
	RJMP _0x16A
; 0000 05CB        lcd_clear();     //3 phaza
	CALL SUBOPT_0xD5
; 0000 05CC         lcd_gotoxy(0,0);              //   
; 0000 05CD        sprintf(lcd_buffer,"O常 capoa",);//      
	CALL SUBOPT_0xA5
; 0000 05CE         lcd_puts(lcd_buffer);         //      
; 0000 05CF         lcd_gotoxy(0,2);              //   
	CALL SUBOPT_0x13
; 0000 05D0        sprintf(lcd_buffer,"Caep aye!",);//    
	__POINTW1FN _0x0,2346
	CALL SUBOPT_0x8
; 0000 05D1        lcd_puts(lcd_buffer);         //      
; 0000 05D2        delay_ms(1000);
	CALL SUBOPT_0x14
; 0000 05D3        rezjim=1; t_ms=0;
	LDI  R30,LOW(1)
	STS  _rezjim,R30
	CALL SUBOPT_0xD6
; 0000 05D4          t_msa=0;flag_a=0;mem_a=0;
; 0000 05D5          t_msb=0;flag_b=0;mem_b=0;
; 0000 05D6          t_msc=0;flag_c=0;mem_c=0;
; 0000 05D7         // stop_p;
; 0000 05D8          stop ;
; 0000 05D9        go_izm=1;
	LDI  R30,LOW(1)
	STS  _go_izm,R30
; 0000 05DA        menu_def=0;
	LDI  R30,LOW(0)
	STS  _menu_def,R30
; 0000 05DB        }
; 0000 05DC       if(btn_m==0){delay_ms(50);while(!btn_d){;};lcd_clear(); menu_def=0;}
_0x169:
	SBIC 0x16,7
	RJMP _0x16D
	CALL SUBOPT_0xD1
_0x16E:
	SBIS 0x16,4
	RJMP _0x16E
	CALL SUBOPT_0xD7
; 0000 05DD 
; 0000 05DE       }
_0x16D:
; 0000 05DF       if(menu_def==9)
_0x160:
	LDS  R26,_menu_def
	CPI  R26,LOW(0x9)
	BREQ PC+3
	JMP _0x171
; 0000 05E0       {
; 0000 05E1         if(rez==0)
	LDS  R30,_rez
	CPI  R30,0
	BRNE _0x172
; 0000 05E2         {
; 0000 05E3           if(btn_d==0){delay_ms(50);while(!btn_d){;};lcd_clear();rez=1;}
	SBIC 0x16,4
	RJMP _0x173
	CALL SUBOPT_0xD1
_0x174:
	SBIS 0x16,4
	RJMP _0x174
	CALL _lcd_clear
	LDI  R30,LOW(1)
	STS  _rez,R30
; 0000 05E4           if(btn_plus==0){delay_ms(50);while(!btn_plus){;};lcd_clear(); menu_def--;}
_0x173:
	SBIC 0x16,5
	RJMP _0x177
	CALL SUBOPT_0xD1
_0x178:
	SBIS 0x16,5
	RJMP _0x178
	CALL SUBOPT_0xD4
	SUBI R30,LOW(1)
	STS  _menu_def,R30
; 0000 05E5           if(btn_minus==0){delay_ms(50);while(!btn_minus){;};lcd_clear(); menu_def++;}
_0x177:
	SBIC 0x16,6
	RJMP _0x17B
	CALL SUBOPT_0xD1
_0x17C:
	SBIS 0x16,6
	RJMP _0x17C
	CALL SUBOPT_0xD4
	SUBI R30,-LOW(1)
	STS  _menu_def,R30
; 0000 05E6           if(btn_m==0){delay_ms(50);while(!btn_m){;};lcd_clear(); menu_def=0;}
_0x17B:
	SBIC 0x16,7
	RJMP _0x17F
	CALL SUBOPT_0xD1
_0x180:
	SBIS 0x16,7
	RJMP _0x180
	CALL SUBOPT_0xD7
; 0000 05E7         }
_0x17F:
; 0000 05E8         if(rez==1)
_0x172:
	LDS  R26,_rez
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x183
; 0000 05E9         {
; 0000 05EA         if(btn_plus==0) {delay_ms(50);while(!btn_plus){;};lcd_clear(); izm_faza--;lcd_clear();}   //number
	SBIC 0x16,5
	RJMP _0x184
	CALL SUBOPT_0xD1
_0x185:
	SBIS 0x16,5
	RJMP _0x185
	CALL _lcd_clear
	LDS  R30,_izm_faza
	SUBI R30,LOW(1)
	CALL SUBOPT_0xD8
; 0000 05EB         if(btn_minus==0){delay_ms(50);while(!btn_minus){;};lcd_clear(); izm_faza++;lcd_clear();}
_0x184:
	SBIC 0x16,6
	RJMP _0x188
	CALL SUBOPT_0xD1
_0x189:
	SBIS 0x16,6
	RJMP _0x189
	CALL _lcd_clear
	LDS  R30,_izm_faza
	SUBI R30,-LOW(1)
	CALL SUBOPT_0xD8
; 0000 05EC         if(izm_faza>=3){izm_faza=0;lcd_clear();}
_0x188:
	LDS  R26,_izm_faza
	CPI  R26,LOW(0x3)
	BRLO _0x18C
	LDI  R30,LOW(0)
	CALL SUBOPT_0xD8
; 0000 05ED         if(btn_m==0){delay_ms(50);while(!btn_m){;};lcd_clear(); rez=0;}
_0x18C:
	SBIC 0x16,7
	RJMP _0x18D
	CALL SUBOPT_0xD1
_0x18E:
	SBIS 0x16,7
	RJMP _0x18E
	CALL _lcd_clear
	LDI  R30,LOW(0)
	STS  _rez,R30
; 0000 05EE          if(btn_d==0)
_0x18D:
	SBIC 0x16,4
	RJMP _0x191
; 0000 05EF          {
; 0000 05F0           delay_ms(50);
	CALL SUBOPT_0xD1
; 0000 05F1           while(!btn_d){;};
_0x192:
	SBIS 0x16,4
	RJMP _0x192
; 0000 05F2            lcd_clear();     // 1 phaza
	CALL SUBOPT_0xD5
; 0000 05F3           lcd_gotoxy(0,0);              //   
; 0000 05F4           sprintf(lcd_buffer,"O常 capoa",);//      
	CALL SUBOPT_0xA5
; 0000 05F5           lcd_puts(lcd_buffer);         //      
; 0000 05F6           lcd_gotoxy(0,2);              //   
	CALL SUBOPT_0x13
; 0000 05F7          sprintf(lcd_buffer,"Caep aye!",);//      
	__POINTW1FN _0x0,2346
	CALL SUBOPT_0x8
; 0000 05F8          lcd_puts(lcd_buffer);         //      
; 0000 05F9          delay_ms(1000);
	CALL SUBOPT_0x14
; 0000 05FA          rezjim=2;
	LDI  R30,LOW(2)
	STS  _rezjim,R30
; 0000 05FB          go_izm=1;t_ms=0;
	LDI  R30,LOW(1)
	STS  _go_izm,R30
	CALL SUBOPT_0xD6
; 0000 05FC          t_msa=0;flag_a=0;mem_a=0;
; 0000 05FD          t_msb=0;flag_b=0;mem_b=0;
; 0000 05FE          t_msc=0;flag_c=0;mem_c=0;
; 0000 05FF        //  stop_p;
; 0000 0600          stop;
; 0000 0601           menu_def=0;
	LDI  R30,LOW(0)
	STS  _menu_def,R30
; 0000 0602           } // go to scan phaza
; 0000 0603         }
_0x191:
; 0000 0604 
; 0000 0605       }
_0x183:
; 0000 0606 
; 0000 0607       }
_0x171:
; 0000 0608       else
	RJMP _0x195
_0x15F:
; 0000 0609       {
; 0000 060A        if(btn_m==0){delay_ms(50);while(!btn_m){;};lcd_clear(); menu_def=0;}
	SBIC 0x16,7
	RJMP _0x196
	CALL SUBOPT_0xD1
_0x197:
	SBIS 0x16,7
	RJMP _0x197
	CALL SUBOPT_0xD7
; 0000 060B        if(btn_d==0)
_0x196:
	SBIC 0x16,4
	RJMP _0x19A
; 0000 060C         {
; 0000 060D         delay_ms(50);
	CALL SUBOPT_0xD1
; 0000 060E         while(!btn_d){;};
_0x19B:
	SBIS 0x16,4
	RJMP _0x19B
; 0000 060F         lcd_clear();
	CALL SUBOPT_0xD5
; 0000 0610         lcd_gotoxy(0,0);              //   
; 0000 0611         sprintf(lcd_buffer,"O常 capoa",);//      
	CALL SUBOPT_0xA5
; 0000 0612          lcd_puts(lcd_buffer);         //      
; 0000 0613          lcd_gotoxy(0,2);              //   
	CALL SUBOPT_0x13
; 0000 0614          sprintf(lcd_buffer,"Caep ocaoe!",);//     
	__POINTW1FN _0x0,2362
	CALL SUBOPT_0x8
; 0000 0615          lcd_puts(lcd_buffer);         //      
; 0000 0616         delay_ms(1000);
	CALL SUBOPT_0x14
; 0000 0617         rezjim=0;
	LDI  R30,LOW(0)
	STS  _rezjim,R30
; 0000 0618          t_msa=0;flag_a=0;mem_a=0;
	CALL SUBOPT_0xD9
	STS  _mem_a,R30
; 0000 0619          t_msb=0;flag_b=0;mem_b=0;
	LDI  R30,LOW(0)
	CALL SUBOPT_0xDA
	STS  _mem_b,R30
; 0000 061A          t_msc=0;flag_c=0;mem_c=0;
	LDI  R30,LOW(0)
	CALL SUBOPT_0xDB
	STS  _mem_c,R30
; 0000 061B         // stop_p;
; 0000 061C          stop ;t_ms=0;
	LDI  R30,LOW(0)
	OUT  0x25,R30
	CALL SUBOPT_0xDC
; 0000 061D         go_izm=0;
	LDI  R30,LOW(0)
	STS  _go_izm,R30
; 0000 061E          menu_def=0;
	STS  _menu_def,R30
; 0000 061F        }
; 0000 0620       }
_0x19A:
_0x195:
; 0000 0621      }
; 0000 0622      if(menu!=0)
_0x141:
	LDS  R30,_menu
	CPI  R30,0
	BRNE PC+3
	JMP _0x19E
; 0000 0623        {
; 0000 0624       if(menu_p==0)
	LDS  R30,_menu_p
	CPI  R30,0
	BREQ PC+3
	JMP _0x19F
; 0000 0625       {
; 0000 0626       if(btn_m==0){delay_ms(50);while(!btn_m){;};menu=0;lcd_clear(); }
	SBIC 0x16,7
	RJMP _0x1A0
	CALL SUBOPT_0xD1
_0x1A1:
	SBIS 0x16,7
	RJMP _0x1A1
	LDI  R30,LOW(0)
	CALL SUBOPT_0xD2
; 0000 0627       if(btn_d==0&&menu==1){delay_ms(50);while(!btn_d){;};menu_p=1;lcd_clear(); }
_0x1A0:
	CALL SUBOPT_0xDD
	BRNE _0x1A5
	LDS  R26,_menu
	CPI  R26,LOW(0x1)
	BREQ _0x1A6
_0x1A5:
	RJMP _0x1A4
_0x1A6:
	CALL SUBOPT_0xD1
_0x1A7:
	SBIS 0x16,4
	RJMP _0x1A7
	LDI  R30,LOW(1)
	CALL SUBOPT_0xDE
; 0000 0628       if(btn_d==0&&menu==2){delay_ms(50);while(!btn_d){;};menu_p=2;lcd_clear(); }
_0x1A4:
	CALL SUBOPT_0xDD
	BRNE _0x1AB
	LDS  R26,_menu
	CPI  R26,LOW(0x2)
	BREQ _0x1AC
_0x1AB:
	RJMP _0x1AA
_0x1AC:
	CALL SUBOPT_0xD1
_0x1AD:
	SBIS 0x16,4
	RJMP _0x1AD
	LDI  R30,LOW(2)
	CALL SUBOPT_0xDE
; 0000 0629       if(btn_d==0&&menu==3){delay_ms(50);while(!btn_d){;};menu_p=3;lcd_clear(); }
_0x1AA:
	CALL SUBOPT_0xDD
	BRNE _0x1B1
	LDS  R26,_menu
	CPI  R26,LOW(0x3)
	BREQ _0x1B2
_0x1B1:
	RJMP _0x1B0
_0x1B2:
	CALL SUBOPT_0xD1
_0x1B3:
	SBIS 0x16,4
	RJMP _0x1B3
	LDI  R30,LOW(3)
	CALL SUBOPT_0xDE
; 0000 062A       if(btn_d==0&&menu==4)
_0x1B0:
	CALL SUBOPT_0xDD
	BRNE _0x1B7
	LDS  R26,_menu
	CPI  R26,LOW(0x4)
	BREQ _0x1B8
_0x1B7:
	RJMP _0x1B6
_0x1B8:
; 0000 062B        {
; 0000 062C         delay_ms(50);
	CALL SUBOPT_0xD1
; 0000 062D         while(!btn_d){;};
_0x1B9:
	SBIS 0x16,4
	RJMP _0x1B9
; 0000 062E         lcd_clear();
	CALL _lcd_clear
; 0000 062F         save[0]=0;
	CALL SUBOPT_0x18
; 0000 0630         go_izm=0;t_ms=0;
	LDI  R30,LOW(0)
	STS  _go_izm,R30
	CALL SUBOPT_0xDC
; 0000 0631          t_msa=0;flag_a=0;
	CALL SUBOPT_0xD9
; 0000 0632          t_msb=0;flag_b=0;
	CALL SUBOPT_0xDA
; 0000 0633          t_msc=0;flag_c=0;
	CALL SUBOPT_0xDB
; 0000 0634           stop;
	OUT  0x25,R30
; 0000 0635           menu_def=0;
	LDI  R30,LOW(0)
	STS  _menu_def,R30
; 0000 0636           save[5]=0;
	CALL SUBOPT_0x19
; 0000 0637         clear_mem();
	CALL _clear_mem
; 0000 0638         }
; 0000 0639       if(btn_plus==0){delay_ms(50);while(!btn_plus){;};menu--;lcd_clear();}
_0x1B6:
	SBIC 0x16,5
	RJMP _0x1BC
	CALL SUBOPT_0xD1
_0x1BD:
	SBIS 0x16,5
	RJMP _0x1BD
	LDS  R30,_menu
	SUBI R30,LOW(1)
	CALL SUBOPT_0xD2
; 0000 063A       if(btn_minus==0){delay_ms(50);while(!btn_minus){;};menu++;lcd_clear();}
_0x1BC:
	SBIC 0x16,6
	RJMP _0x1C0
	CALL SUBOPT_0xD1
_0x1C1:
	SBIS 0x16,6
	RJMP _0x1C1
	LDS  R30,_menu
	SUBI R30,-LOW(1)
	CALL SUBOPT_0xD2
; 0000 063B       }
_0x1C0:
; 0000 063C      if(menu_p==1)    //options
_0x19F:
	LDS  R26,_menu_p
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x1C4
; 0000 063D       {
; 0000 063E        if(menu_pp==0)
	LDS  R30,_menu_pp
	CPI  R30,0
	BRNE _0x1C5
; 0000 063F         {
; 0000 0640         if(btn_d==0){delay_ms(50);while(!btn_d){;};menu_pp=1;lcd_clear(); }
	SBIC 0x16,4
	RJMP _0x1C6
	CALL SUBOPT_0xD1
_0x1C7:
	SBIS 0x16,4
	RJMP _0x1C7
	LDI  R30,LOW(1)
	CALL SUBOPT_0xDF
; 0000 0641         if(btn_plus==0&&menu_ppp>0){delay_ms(50);while(!btn_plus){;};menu_ppp--;lcd_clear();}
_0x1C6:
	CALL SUBOPT_0xD3
	BRNE _0x1CB
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x1)
	BRSH _0x1CC
_0x1CB:
	RJMP _0x1CA
_0x1CC:
	CALL SUBOPT_0xD1
_0x1CD:
	SBIS 0x16,5
	RJMP _0x1CD
	CALL SUBOPT_0xE0
; 0000 0642         if(btn_minus==0&&menu_ppp<3){delay_ms(50);while(!btn_minus){;};menu_ppp++;lcd_clear();}
_0x1CA:
	CALL SUBOPT_0xE1
	BRNE _0x1D1
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x3)
	BRLO _0x1D2
_0x1D1:
	RJMP _0x1D0
_0x1D2:
	CALL SUBOPT_0xD1
_0x1D3:
	SBIS 0x16,6
	RJMP _0x1D3
	CALL SUBOPT_0xE2
; 0000 0643         if(btn_m==0){delay_ms(50);while(!btn_m){;};menu_p=0;lcd_clear();}
_0x1D0:
	SBIC 0x16,7
	RJMP _0x1D6
	CALL SUBOPT_0xD1
_0x1D7:
	SBIS 0x16,7
	RJMP _0x1D7
	LDI  R30,LOW(0)
	CALL SUBOPT_0xDE
; 0000 0644         }
_0x1D6:
; 0000 0645          if(menu_ppp==0&&menu_pp==1)
_0x1C5:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x0)
	BRNE _0x1DB
	LDS  R26,_menu_pp
	CPI  R26,LOW(0x1)
	BREQ _0x1DC
_0x1DB:
	RJMP _0x1DA
_0x1DC:
; 0000 0646          {
; 0000 0647          if(btn_plus==0){delay_ms(50);while(!btn_plus){;};u_n++;}
	SBIC 0x16,5
	RJMP _0x1DD
	CALL SUBOPT_0xD1
_0x1DE:
	SBIS 0x16,5
	RJMP _0x1DE
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
; 0000 0648          if(btn_minus==0){delay_ms(50);while(!btn_minus){;};u_n--;}
_0x1DD:
	SBIC 0x16,6
	RJMP _0x1E1
	CALL SUBOPT_0xD1
_0x1E2:
	SBIS 0x16,6
	RJMP _0x1E2
	MOVW R30,R8
	SBIW R30,1
	MOVW R8,R30
; 0000 0649          if(btn_m==0){delay_ms(50);while(!btn_m){;};menu_pp=0;lcd_clear();}
_0x1E1:
	SBIC 0x16,7
	RJMP _0x1E5
	CALL SUBOPT_0xD1
_0x1E6:
	SBIS 0x16,7
	RJMP _0x1E6
	LDI  R30,LOW(0)
	CALL SUBOPT_0xDF
; 0000 064A          if(u_n>=500){u_n=220;}
_0x1E5:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	CP   R8,R30
	CPC  R9,R31
	BRLT _0x1E9
	LDI  R30,LOW(220)
	LDI  R31,HIGH(220)
	MOVW R8,R30
; 0000 064B          save[0]=1;
_0x1E9:
	CALL SUBOPT_0xE3
; 0000 064C          save[1]=u_n;
	__POINTW2MN _save,2
	MOVW R30,R8
	CALL __EEPROMWRW
; 0000 064D          }
; 0000 064E         if(menu_ppp==1&&menu_pp==1)
_0x1DA:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x1)
	BRNE _0x1EB
	LDS  R26,_menu_pp
	CPI  R26,LOW(0x1)
	BREQ _0x1EC
_0x1EB:
	RJMP _0x1EA
_0x1EC:
; 0000 064F           {
; 0000 0650            if(btn_plus==0&&ddop<100){delay_ms(50);while(!btn_plus){;};ddop--;}
	CALL SUBOPT_0xD3
	BRNE _0x1EE
	CALL SUBOPT_0xAF
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRLT _0x1EF
_0x1EE:
	RJMP _0x1ED
_0x1EF:
	CALL SUBOPT_0xD1
_0x1F0:
	SBIS 0x16,5
	RJMP _0x1F0
	LDI  R26,LOW(_ddop)
	LDI  R27,HIGH(_ddop)
	CALL SUBOPT_0xE4
; 0000 0651            if(btn_minus==0&&ddop!=0){delay_ms(50);while(!btn_minus){;};ddop++;}
_0x1ED:
	CALL SUBOPT_0xE1
	BRNE _0x1F4
	CALL SUBOPT_0xAF
	SBIW R26,0
	BRNE _0x1F5
_0x1F4:
	RJMP _0x1F3
_0x1F5:
	CALL SUBOPT_0xD1
_0x1F6:
	SBIS 0x16,6
	RJMP _0x1F6
	LDI  R26,LOW(_ddop)
	LDI  R27,HIGH(_ddop)
	CALL SUBOPT_0x47
	SBIW R30,1
; 0000 0652            if(btn_m==0){delay_ms(50);while(!btn_m){;};menu_pp=0;lcd_clear();}
_0x1F3:
	SBIC 0x16,7
	RJMP _0x1F9
	CALL SUBOPT_0xD1
_0x1FA:
	SBIS 0x16,7
	RJMP _0x1FA
	LDI  R30,LOW(0)
	CALL SUBOPT_0xDF
; 0000 0653            if(ddop>=100||ddop==0){ddop=90;}
_0x1F9:
	CALL SUBOPT_0xAF
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRGE _0x1FE
	CALL SUBOPT_0xAF
	SBIW R26,0
	BRNE _0x1FD
_0x1FE:
	LDI  R30,LOW(90)
	LDI  R31,HIGH(90)
	CALL SUBOPT_0x1A
; 0000 0654            save[0]=1;
_0x1FD:
	CALL SUBOPT_0xE3
; 0000 0655            save[2]=ddop;
	__POINTW2MN _save,4
	CALL SUBOPT_0x30
	CALL __EEPROMWRW
; 0000 0656            }
; 0000 0657            if(menu_ppp==2&&menu_pp==1)
_0x1EA:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x2)
	BRNE _0x201
	LDS  R26,_menu_pp
	CPI  R26,LOW(0x1)
	BREQ _0x202
_0x201:
	RJMP _0x200
_0x202:
; 0000 0658           {
; 0000 0659            if(btn_plus==0&&ddop_m<100){delay_ms(50);while(!btn_plus){;};ddop_m--;}
	CALL SUBOPT_0xD3
	BRNE _0x204
	CALL SUBOPT_0xB1
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRLT _0x205
_0x204:
	RJMP _0x203
_0x205:
	CALL SUBOPT_0xD1
_0x206:
	SBIS 0x16,5
	RJMP _0x206
	LDI  R26,LOW(_ddop_m)
	LDI  R27,HIGH(_ddop_m)
	CALL SUBOPT_0xE4
; 0000 065A            if(btn_minus==0&&ddop_m!=0){delay_ms(50);while(!btn_minus){;};ddop_m++;}
_0x203:
	CALL SUBOPT_0xE1
	BRNE _0x20A
	CALL SUBOPT_0xB1
	SBIW R26,0
	BRNE _0x20B
_0x20A:
	RJMP _0x209
_0x20B:
	CALL SUBOPT_0xD1
_0x20C:
	SBIS 0x16,6
	RJMP _0x20C
	LDI  R26,LOW(_ddop_m)
	LDI  R27,HIGH(_ddop_m)
	CALL SUBOPT_0x47
	SBIW R30,1
; 0000 065B            if(btn_m==0){delay_ms(50);while(!btn_m){;};menu_pp=0;lcd_clear();}
_0x209:
	SBIC 0x16,7
	RJMP _0x20F
	CALL SUBOPT_0xD1
_0x210:
	SBIS 0x16,7
	RJMP _0x210
	LDI  R30,LOW(0)
	CALL SUBOPT_0xDF
; 0000 065C            if(ddop_m>=100||ddop_m==0){ddop_m=90;}
_0x20F:
	CALL SUBOPT_0xB1
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRGE _0x214
	CALL SUBOPT_0xB1
	SBIW R26,0
	BRNE _0x213
_0x214:
	LDI  R30,LOW(90)
	LDI  R31,HIGH(90)
	CALL SUBOPT_0x1B
; 0000 065D            save[0]=1;
_0x213:
	CALL SUBOPT_0xE3
; 0000 065E            save[3]=ddop_m;
	__POINTW2MN _save,6
	CALL SUBOPT_0x34
	CALL __EEPROMWRW
; 0000 065F            }
; 0000 0660               if(menu_ppp==3&&menu_pp==1)
_0x200:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x3)
	BRNE _0x217
	LDS  R26,_menu_pp
	CPI  R26,LOW(0x1)
	BREQ _0x218
_0x217:
	RJMP _0x216
_0x218:
; 0000 0661           {
; 0000 0662            if(btn_plus==0&&t_zad<1000){delay_ms(50);while(!btn_plus){;};t_zad++;}
	CALL SUBOPT_0xD3
	BRNE _0x21A
	CALL SUBOPT_0xE5
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	BRLO _0x21B
_0x21A:
	RJMP _0x219
_0x21B:
	CALL SUBOPT_0xD1
_0x21C:
	SBIS 0x16,5
	RJMP _0x21C
	LDI  R26,LOW(_t_zad)
	LDI  R27,HIGH(_t_zad)
	CALL SUBOPT_0x47
	SBIW R30,1
; 0000 0663            if(btn_minus==0&&t_zad!=0){delay_ms(50);while(!btn_minus){;};t_zad--;}
_0x219:
	CALL SUBOPT_0xE1
	BRNE _0x220
	CALL SUBOPT_0xE5
	SBIW R26,0
	BRNE _0x221
_0x220:
	RJMP _0x21F
_0x221:
	CALL SUBOPT_0xD1
_0x222:
	SBIS 0x16,6
	RJMP _0x222
	LDI  R26,LOW(_t_zad)
	LDI  R27,HIGH(_t_zad)
	CALL SUBOPT_0xE4
; 0000 0664            if(btn_m==0){delay_ms(50);while(!btn_m){;};menu_pp=0;lcd_clear();}
_0x21F:
	SBIC 0x16,7
	RJMP _0x225
	CALL SUBOPT_0xD1
_0x226:
	SBIS 0x16,7
	RJMP _0x226
	LDI  R30,LOW(0)
	CALL SUBOPT_0xDF
; 0000 0665            if(t_zad>=1000||t_zad==0){t_zad=1;}
_0x225:
	CALL SUBOPT_0xE5
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	BRSH _0x22A
	CALL SUBOPT_0xE5
	SBIW R26,0
	BRNE _0x229
_0x22A:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _t_zad,R30
	STS  _t_zad+1,R31
; 0000 0666            save[0]=1;
_0x229:
	CALL SUBOPT_0xE3
; 0000 0667            save[4]=t_zad;
	__POINTW2MN _save,8
	CALL SUBOPT_0x54
	CALL __EEPROMWRW
; 0000 0668            }
; 0000 0669 
; 0000 066A      }
_0x216:
; 0000 066B         if(menu_p==2)    //time
_0x1C4:
	LDS  R26,_menu_p
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0x22C
; 0000 066C       {
; 0000 066D        if(menu_pp==0)
	LDS  R30,_menu_pp
	CPI  R30,0
	BRNE _0x22D
; 0000 066E         {
; 0000 066F         if(btn_d==0){delay_ms(50);while(!btn_d){;};rtc++;flag=0;lcd_clear(); }
	SBIC 0x16,4
	RJMP _0x22E
	CALL SUBOPT_0xD1
_0x22F:
	SBIS 0x16,4
	RJMP _0x22F
	LDS  R30,_rtc
	SUBI R30,-LOW(1)
	CALL SUBOPT_0xE6
; 0000 0670         if(btn_m==0){delay_ms(50);while(!btn_m){;};menu_p=0;lcd_clear();}
_0x22E:
	SBIC 0x16,7
	RJMP _0x232
	CALL SUBOPT_0xD1
_0x233:
	SBIS 0x16,7
	RJMP _0x233
	LDI  R30,LOW(0)
	CALL SUBOPT_0xDE
; 0000 0671         }
_0x232:
; 0000 0672 
; 0000 0673        if(rtc==0){flag=0;}
_0x22D:
	LDS  R30,_rtc
	CPI  R30,0
	BRNE _0x236
	LDI  R30,LOW(0)
	STS  _flag,R30
; 0000 0674        if(rtc>=6){rtc=0;flag=0;lcd_clear();}
_0x236:
	LDS  R26,_rtc
	CPI  R26,LOW(0x6)
	BRLO _0x237
	LDI  R30,LOW(0)
	CALL SUBOPT_0xE6
; 0000 0675        if(flag==0){read_time(); read_date(); flag=1;}
_0x237:
	LDS  R30,_flag
	CPI  R30,0
	BRNE _0x238
	CALL _read_time
	CALL _read_date
	LDI  R30,LOW(1)
	STS  _flag,R30
; 0000 0676        if(rtc==0)
_0x238:
	LDS  R30,_rtc
	CPI  R30,0
	BRNE _0x239
; 0000 0677        {
; 0000 0678         if(btn_plus==0){delay_ms(300);hour++;}
	SBIC 0x16,5
	RJMP _0x23A
	CALL SUBOPT_0xE7
	LDS  R30,_hour
	SUBI R30,-LOW(1)
	STS  _hour,R30
; 0000 0679         if(btn_minus==0){delay_ms(300);hour--;}
_0x23A:
	SBIC 0x16,6
	RJMP _0x23B
	CALL SUBOPT_0xE7
	LDS  R30,_hour
	SUBI R30,LOW(1)
	STS  _hour,R30
; 0000 067A        }
_0x23B:
; 0000 067B        if(rtc==1)
_0x239:
	LDS  R26,_rtc
	CPI  R26,LOW(0x1)
	BRNE _0x23C
; 0000 067C        {
; 0000 067D         if(btn_plus==0){delay_ms(300);minut++;}
	SBIC 0x16,5
	RJMP _0x23D
	CALL SUBOPT_0xE7
	LDS  R30,_minut
	SUBI R30,-LOW(1)
	STS  _minut,R30
; 0000 067E         if(btn_minus==0){delay_ms(300);minut--;}
_0x23D:
	SBIC 0x16,6
	RJMP _0x23E
	CALL SUBOPT_0xE7
	LDS  R30,_minut
	SUBI R30,LOW(1)
	STS  _minut,R30
; 0000 067F        }
_0x23E:
; 0000 0680        if(rtc==2)
_0x23C:
	LDS  R26,_rtc
	CPI  R26,LOW(0x2)
	BRNE _0x23F
; 0000 0681         {
; 0000 0682          if(btn_plus==0){delay_ms(300);sek++;}
	SBIC 0x16,5
	RJMP _0x240
	CALL SUBOPT_0xE7
	LDS  R30,_sek
	SUBI R30,-LOW(1)
	STS  _sek,R30
; 0000 0683          if(btn_minus==0){delay_ms(300);sek--;}
_0x240:
	SBIC 0x16,6
	RJMP _0x241
	CALL SUBOPT_0xE7
	LDS  R30,_sek
	SUBI R30,LOW(1)
	STS  _sek,R30
; 0000 0684        }
_0x241:
; 0000 0685        if(rtc==3)
_0x23F:
	LDS  R26,_rtc
	CPI  R26,LOW(0x3)
	BRNE _0x242
; 0000 0686         {
; 0000 0687          if(btn_plus==0){delay_ms(300);day++;}
	SBIC 0x16,5
	RJMP _0x243
	CALL SUBOPT_0xE7
	LDS  R30,_day
	SUBI R30,-LOW(1)
	STS  _day,R30
; 0000 0688          if(btn_minus==0){delay_ms(300);day--;}
_0x243:
	SBIC 0x16,6
	RJMP _0x244
	CALL SUBOPT_0xE7
	LDS  R30,_day
	SUBI R30,LOW(1)
	STS  _day,R30
; 0000 0689         }
_0x244:
; 0000 068A        if(rtc==4)
_0x242:
	LDS  R26,_rtc
	CPI  R26,LOW(0x4)
	BRNE _0x245
; 0000 068B          {
; 0000 068C          if(btn_plus==0){delay_ms(300);month++;}
	SBIC 0x16,5
	RJMP _0x246
	CALL SUBOPT_0xE7
	LDS  R30,_month
	SUBI R30,-LOW(1)
	STS  _month,R30
; 0000 068D         if(btn_minus==0){delay_ms(300);month--;}
_0x246:
	SBIC 0x16,6
	RJMP _0x247
	CALL SUBOPT_0xE7
	LDS  R30,_month
	SUBI R30,LOW(1)
	STS  _month,R30
; 0000 068E          }
_0x247:
; 0000 068F        if(rtc==5)
_0x245:
	LDS  R26,_rtc
	CPI  R26,LOW(0x5)
	BRNE _0x248
; 0000 0690         {
; 0000 0691         if(btn_plus==0){delay_ms(300);year++;}
	SBIC 0x16,5
	RJMP _0x249
	CALL SUBOPT_0xE7
	LDS  R30,_year
	SUBI R30,-LOW(1)
	STS  _year,R30
; 0000 0692         if(btn_minus==0){delay_ms(300);year--;}
_0x249:
	SBIC 0x16,6
	RJMP _0x24A
	CALL SUBOPT_0xE7
	LDS  R30,_year
	SUBI R30,LOW(1)
	STS  _year,R30
; 0000 0693         }
_0x24A:
; 0000 0694          if(hour>=24){hour=0;}
_0x248:
	LDS  R26,_hour
	CPI  R26,LOW(0x18)
	BRLO _0x24B
	LDI  R30,LOW(0)
	STS  _hour,R30
; 0000 0695          if(minut<1){minut=59;hour--;}
_0x24B:
	LDS  R26,_minut
	CPI  R26,LOW(0x1)
	BRSH _0x24C
	LDI  R30,LOW(59)
	STS  _minut,R30
	LDS  R30,_hour
	SUBI R30,LOW(1)
	STS  _hour,R30
; 0000 0696          if(minut>=60){minut=0;hour++;}
_0x24C:
	LDS  R26,_minut
	CPI  R26,LOW(0x3C)
	BRLO _0x24D
	LDI  R30,LOW(0)
	STS  _minut,R30
	LDS  R30,_hour
	SUBI R30,-LOW(1)
	STS  _hour,R30
; 0000 0697          if(sek<1){sek=59;minut--;}
_0x24D:
	LDS  R26,_sek
	CPI  R26,LOW(0x1)
	BRSH _0x24E
	LDI  R30,LOW(59)
	STS  _sek,R30
	LDS  R30,_minut
	SUBI R30,LOW(1)
	STS  _minut,R30
; 0000 0698          if(sek>=60){sek=0;minut++;}
_0x24E:
	LDS  R26,_sek
	CPI  R26,LOW(0x3C)
	BRLO _0x24F
	LDI  R30,LOW(0)
	STS  _sek,R30
	LDS  R30,_minut
	SUBI R30,-LOW(1)
	STS  _minut,R30
; 0000 0699          if(day>=32){day=1;month++;}
_0x24F:
	LDS  R26,_day
	CPI  R26,LOW(0x20)
	BRLO _0x250
	LDI  R30,LOW(1)
	STS  _day,R30
	LDS  R30,_month
	SUBI R30,-LOW(1)
	STS  _month,R30
; 0000 069A           if(day<1){day=31;month--;}
_0x250:
	LDS  R26,_day
	CPI  R26,LOW(0x1)
	BRSH _0x251
	LDI  R30,LOW(31)
	STS  _day,R30
	LDS  R30,_month
	SUBI R30,LOW(1)
	STS  _month,R30
; 0000 069B          if(month>=13){month=1;year++;}
_0x251:
	LDS  R26,_month
	CPI  R26,LOW(0xD)
	BRLO _0x252
	LDI  R30,LOW(1)
	STS  _month,R30
	LDS  R30,_year
	SUBI R30,-LOW(1)
	STS  _year,R30
; 0000 069C          if(month<1){month=12;year--;}
_0x252:
	LDS  R26,_month
	CPI  R26,LOW(0x1)
	BRSH _0x253
	LDI  R30,LOW(12)
	STS  _month,R30
	LDS  R30,_year
	SUBI R30,LOW(1)
	STS  _year,R30
; 0000 069D         if(year>=255){year=0;}
_0x253:
	LDS  R26,_year
	CPI  R26,LOW(0xFF)
	BRLO _0x254
	LDI  R30,LOW(0)
	STS  _year,R30
; 0000 069E         if(rtc==0||rtc==1||rtc==2){rtc_set_time(hour,minut,sek);} // : , , 
_0x254:
	LDS  R26,_rtc
	CPI  R26,LOW(0x0)
	BREQ _0x256
	CPI  R26,LOW(0x1)
	BREQ _0x256
	CPI  R26,LOW(0x2)
	BRNE _0x255
_0x256:
	LDS  R30,_hour
	ST   -Y,R30
	LDS  R30,_minut
	ST   -Y,R30
	LDS  R30,_sek
	ST   -Y,R30
	RCALL _rtc_set_time
; 0000 069F         if(rtc==3||rtc==4||rtc==5){rtc_set_date(day,month,year);} // date
_0x255:
	LDS  R26,_rtc
	CPI  R26,LOW(0x3)
	BREQ _0x259
	CPI  R26,LOW(0x4)
	BREQ _0x259
	CPI  R26,LOW(0x5)
	BRNE _0x258
_0x259:
	LDS  R30,_day
	ST   -Y,R30
	LDS  R30,_month
	ST   -Y,R30
	LDS  R30,_year
	ST   -Y,R30
	RCALL _rtc_set_date
; 0000 06A0       }
_0x258:
; 0000 06A1 
; 0000 06A2       if(menu_p==3)  //statistika
_0x22C:
	LDS  R26,_menu_p
	CPI  R26,LOW(0x3)
	BREQ PC+3
	JMP _0x25B
; 0000 06A3       {
; 0000 06A4        if(menu_pp==0)
	LDS  R30,_menu_pp
	CPI  R30,0
	BRNE _0x25C
; 0000 06A5         {
; 0000 06A6         if(btn_d==0){delay_ms(50);while(!btn_d){;};menu_pp=1;lcd_clear(); }
	SBIC 0x16,4
	RJMP _0x25D
	CALL SUBOPT_0xD1
_0x25E:
	SBIS 0x16,4
	RJMP _0x25E
	LDI  R30,LOW(1)
	CALL SUBOPT_0xDF
; 0000 06A7         if(btn_plus==0){delay_ms(50);while(!btn_plus){;};menu_ppp--;lcd_clear();}
_0x25D:
	SBIC 0x16,5
	RJMP _0x261
	CALL SUBOPT_0xD1
_0x262:
	SBIS 0x16,5
	RJMP _0x262
	CALL SUBOPT_0xE0
; 0000 06A8         if(btn_minus==0){delay_ms(50);while(!btn_minus){;};menu_ppp++;lcd_clear();}
_0x261:
	SBIC 0x16,6
	RJMP _0x265
	CALL SUBOPT_0xD1
_0x266:
	SBIS 0x16,6
	RJMP _0x266
	CALL SUBOPT_0xE2
; 0000 06A9         if(btn_m==0){delay_ms(50);while(!btn_m){;};menu_p=0;lcd_clear();}
_0x265:
	SBIC 0x16,7
	RJMP _0x269
	CALL SUBOPT_0xD1
_0x26A:
	SBIS 0x16,7
	RJMP _0x26A
	LDI  R30,LOW(0)
	CALL SUBOPT_0xDE
; 0000 06AA         if(menu_ppp>=3){menu_ppp=2;}
_0x269:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x3)
	BRLO _0x26D
	LDI  R30,LOW(2)
	STS  _menu_ppp,R30
; 0000 06AB         }
_0x26D:
; 0000 06AC          if(menu_ppp==0&&menu_pp==1)
_0x25C:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x0)
	BRNE _0x26F
	LDS  R26,_menu_pp
	CPI  R26,LOW(0x1)
	BREQ _0x270
_0x26F:
	RJMP _0x26E
_0x270:
; 0000 06AD          {
; 0000 06AE            if(del_a==0)
	LDS  R30,_del_a
	CPI  R30,0
	BREQ PC+3
	JMP _0x271
; 0000 06AF            {
; 0000 06B0            if(btn_m==0){delay_ms(50);while(!btn_m){;};menu_pp=0;lcd_clear();}
	SBIC 0x16,7
	RJMP _0x272
	CALL SUBOPT_0xD1
_0x273:
	SBIS 0x16,7
	RJMP _0x273
	LDI  R30,LOW(0)
	CALL SUBOPT_0xDF
; 0000 06B1            if(flag_st==0){stat_na=proval_na;flag_st=1;}
_0x272:
	LDS  R30,_flag_st
	CPI  R30,0
	BRNE _0x276
	CALL SUBOPT_0x4E
	STS  _stat_na,R30
	LDI  R30,LOW(1)
	STS  _flag_st,R30
; 0000 06B2            if(btn_plus==0){delay_ms(50);while(!btn_plus){;};stat_na++;lcd_clear();}
_0x276:
	SBIC 0x16,5
	RJMP _0x277
	CALL SUBOPT_0xD1
_0x278:
	SBIS 0x16,5
	RJMP _0x278
	LDS  R30,_stat_na
	SUBI R30,-LOW(1)
	STS  _stat_na,R30
	CALL _lcd_clear
; 0000 06B3            if(btn_minus==0){delay_ms(50);while(!btn_minus){;};stat_na--;lcd_clear();}
_0x277:
	SBIC 0x16,6
	RJMP _0x27B
	CALL SUBOPT_0xD1
_0x27C:
	SBIS 0x16,6
	RJMP _0x27C
	LDS  R30,_stat_na
	SUBI R30,LOW(1)
	STS  _stat_na,R30
	CALL _lcd_clear
; 0000 06B4            if(stat_na>=mem){stat_na=0;}
_0x27B:
	LDS  R26,_stat_na
	CPI  R26,LOW(0x25)
	BRLO _0x27F
	LDI  R30,LOW(0)
	STS  _stat_na,R30
; 0000 06B5             if(btn_d==0)
_0x27F:
	SBIC 0x16,4
	RJMP _0x280
; 0000 06B6             {
; 0000 06B7             delay_ms(350);
	CALL SUBOPT_0xE8
; 0000 06B8             while(!btn_d){;};
_0x281:
	SBIS 0x16,4
	RJMP _0x281
; 0000 06B9             lcd_clear();
	CALL _lcd_clear
; 0000 06BA             del_a=1;
	LDI  R30,LOW(1)
	STS  _del_a,R30
; 0000 06BB             }
; 0000 06BC            }
_0x280:
; 0000 06BD           else
	RJMP _0x284
_0x271:
; 0000 06BE            {
; 0000 06BF             if(btn_minus==0){delay_ms(50);while(!btn_minus){;}; clear_mem_a();}
	SBIC 0x16,6
	RJMP _0x285
	CALL SUBOPT_0xD1
_0x286:
	SBIS 0x16,6
	RJMP _0x286
	CALL _clear_mem_a
; 0000 06C0              if(btn_d==0){delay_ms(50);while(!btn_d){;};del_a=0;lcd_clear();}
_0x285:
	SBIC 0x16,4
	RJMP _0x289
	CALL SUBOPT_0xD1
_0x28A:
	SBIS 0x16,4
	RJMP _0x28A
	LDI  R30,LOW(0)
	STS  _del_a,R30
	CALL _lcd_clear
; 0000 06C1            }
_0x289:
_0x284:
; 0000 06C2          }
; 0000 06C3         if(menu_ppp==1&&menu_pp==1)
_0x26E:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x1)
	BRNE _0x28E
	LDS  R26,_menu_pp
	CPI  R26,LOW(0x1)
	BREQ _0x28F
_0x28E:
	RJMP _0x28D
_0x28F:
; 0000 06C4           {
; 0000 06C5            if(del_b==0)
	LDS  R30,_del_b
	CPI  R30,0
	BREQ PC+3
	JMP _0x290
; 0000 06C6            {
; 0000 06C7            if(btn_m==0){delay_ms(50);while(!btn_m){;};menu_pp=0;lcd_clear();}
	SBIC 0x16,7
	RJMP _0x291
	CALL SUBOPT_0xD1
_0x292:
	SBIS 0x16,7
	RJMP _0x292
	LDI  R30,LOW(0)
	CALL SUBOPT_0xDF
; 0000 06C8            if(flag_st==0){stat_nb=proval_nb;flag_st=1;}
_0x291:
	LDS  R30,_flag_st
	CPI  R30,0
	BRNE _0x295
	CALL SUBOPT_0x63
	STS  _stat_nb,R30
	LDI  R30,LOW(1)
	STS  _flag_st,R30
; 0000 06C9            if(btn_plus==0){delay_ms(50);while(!btn_plus){;};stat_nb++;lcd_clear();}
_0x295:
	SBIC 0x16,5
	RJMP _0x296
	CALL SUBOPT_0xD1
_0x297:
	SBIS 0x16,5
	RJMP _0x297
	LDS  R30,_stat_nb
	SUBI R30,-LOW(1)
	STS  _stat_nb,R30
	CALL _lcd_clear
; 0000 06CA            if(btn_minus==0){delay_ms(50);while(!btn_minus){;};stat_nb--;lcd_clear();}
_0x296:
	SBIC 0x16,6
	RJMP _0x29A
	CALL SUBOPT_0xD1
_0x29B:
	SBIS 0x16,6
	RJMP _0x29B
	LDS  R30,_stat_nb
	SUBI R30,LOW(1)
	STS  _stat_nb,R30
	CALL _lcd_clear
; 0000 06CB            if(stat_nb>=mem){stat_nb=0;}
_0x29A:
	LDS  R26,_stat_nb
	CPI  R26,LOW(0x25)
	BRLO _0x29E
	LDI  R30,LOW(0)
	STS  _stat_nb,R30
; 0000 06CC            if(btn_d==0)
_0x29E:
	SBIC 0x16,4
	RJMP _0x29F
; 0000 06CD             {
; 0000 06CE             delay_ms(350);
	CALL SUBOPT_0xE8
; 0000 06CF             while(!btn_d){;};
_0x2A0:
	SBIS 0x16,4
	RJMP _0x2A0
; 0000 06D0             lcd_clear();
	CALL _lcd_clear
; 0000 06D1             del_b=1;
	LDI  R30,LOW(1)
	STS  _del_b,R30
; 0000 06D2             }
; 0000 06D3             }
_0x29F:
; 0000 06D4             else
	RJMP _0x2A3
_0x290:
; 0000 06D5             {
; 0000 06D6              if(btn_minus==0){delay_ms(50);while(!btn_minus){;}; clear_mem_b();}
	SBIC 0x16,6
	RJMP _0x2A4
	CALL SUBOPT_0xD1
_0x2A5:
	SBIS 0x16,6
	RJMP _0x2A5
	CALL _clear_mem_b
; 0000 06D7              if(btn_d==0){delay_ms(50);while(!btn_d){;};del_b=0;lcd_clear();}
_0x2A4:
	SBIC 0x16,4
	RJMP _0x2A8
	CALL SUBOPT_0xD1
_0x2A9:
	SBIS 0x16,4
	RJMP _0x2A9
	LDI  R30,LOW(0)
	STS  _del_b,R30
	CALL _lcd_clear
; 0000 06D8             }
_0x2A8:
_0x2A3:
; 0000 06D9            }
; 0000 06DA            if(menu_ppp==2&&menu_pp==1)
_0x28D:
	LDS  R26,_menu_ppp
	CPI  R26,LOW(0x2)
	BRNE _0x2AD
	LDS  R26,_menu_pp
	CPI  R26,LOW(0x1)
	BREQ _0x2AE
_0x2AD:
	RJMP _0x2AC
_0x2AE:
; 0000 06DB           {
; 0000 06DC            if(del_c==0)
	LDS  R30,_del_c
	CPI  R30,0
	BREQ PC+3
	JMP _0x2AF
; 0000 06DD            {
; 0000 06DE            if(btn_m==0){delay_ms(50);while(!btn_m){;};menu_pp=0;lcd_clear();}
	SBIC 0x16,7
	RJMP _0x2B0
	CALL SUBOPT_0xD1
_0x2B1:
	SBIS 0x16,7
	RJMP _0x2B1
	LDI  R30,LOW(0)
	CALL SUBOPT_0xDF
; 0000 06DF            if(flag_st==0){stat_nc=proval_nc;flag_st=1;}
_0x2B0:
	LDS  R30,_flag_st
	CPI  R30,0
	BRNE _0x2B4
	CALL SUBOPT_0x70
	STS  _stat_nc,R30
	LDI  R30,LOW(1)
	STS  _flag_st,R30
; 0000 06E0            if(btn_plus==0){delay_ms(50);while(!btn_plus){;};stat_nc++;lcd_clear();}
_0x2B4:
	SBIC 0x16,5
	RJMP _0x2B5
	CALL SUBOPT_0xD1
_0x2B6:
	SBIS 0x16,5
	RJMP _0x2B6
	LDS  R30,_stat_nc
	SUBI R30,-LOW(1)
	STS  _stat_nc,R30
	CALL _lcd_clear
; 0000 06E1            if(btn_minus==0){delay_ms(50);while(!btn_minus){;};stat_nc--;lcd_clear();}
_0x2B5:
	SBIC 0x16,6
	RJMP _0x2B9
	CALL SUBOPT_0xD1
_0x2BA:
	SBIS 0x16,6
	RJMP _0x2BA
	LDS  R30,_stat_nc
	SUBI R30,LOW(1)
	STS  _stat_nc,R30
	RCALL _lcd_clear
; 0000 06E2            if(stat_nc>=mem){stat_nc=0;}
_0x2B9:
	LDS  R26,_stat_nc
	CPI  R26,LOW(0x25)
	BRLO _0x2BD
	LDI  R30,LOW(0)
	STS  _stat_nc,R30
; 0000 06E3            if(btn_d==0)
_0x2BD:
	SBIC 0x16,4
	RJMP _0x2BE
; 0000 06E4             {
; 0000 06E5             delay_ms(350);
	CALL SUBOPT_0xE8
; 0000 06E6             while(!btn_d){;};
_0x2BF:
	SBIS 0x16,4
	RJMP _0x2BF
; 0000 06E7             lcd_clear();
	RCALL _lcd_clear
; 0000 06E8             del_c=1;
	LDI  R30,LOW(1)
	STS  _del_c,R30
; 0000 06E9             }
; 0000 06EA            }
_0x2BE:
; 0000 06EB            else
	RJMP _0x2C2
_0x2AF:
; 0000 06EC            {
; 0000 06ED            if(btn_minus==0){delay_ms(50);while(!btn_minus){;}; clear_mem_c();}
	SBIC 0x16,6
	RJMP _0x2C3
	CALL SUBOPT_0xD1
_0x2C4:
	SBIS 0x16,6
	RJMP _0x2C4
	CALL _clear_mem_c
; 0000 06EE              if(btn_d==0){delay_ms(50);while(!btn_d){;};del_c=0;lcd_clear();}
_0x2C3:
	SBIC 0x16,4
	RJMP _0x2C7
	CALL SUBOPT_0xD1
_0x2C8:
	SBIS 0x16,4
	RJMP _0x2C8
	LDI  R30,LOW(0)
	STS  _del_c,R30
	RCALL _lcd_clear
; 0000 06EF            }
_0x2C7:
_0x2C2:
; 0000 06F0            }
; 0000 06F1 
; 0000 06F2       }
_0x2AC:
; 0000 06F3 
; 0000 06F4    }
_0x25B:
; 0000 06F5 
; 0000 06F6    if(u_n==0||u_n>600){u_n=220;}
_0x19E:
	CLR  R0
	CP   R0,R8
	CPC  R0,R9
	BREQ _0x2CC
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	CP   R30,R8
	CPC  R31,R9
	BRGE _0x2CB
_0x2CC:
	LDI  R30,LOW(220)
	LDI  R31,HIGH(220)
	MOVW R8,R30
; 0000 06F7    if(ddop==0||ddop>200){ddop=10;}
_0x2CB:
	CALL SUBOPT_0xAF
	SBIW R26,0
	BREQ _0x2CF
	CALL SUBOPT_0xAF
	CPI  R26,LOW(0xC9)
	LDI  R30,HIGH(0xC9)
	CPC  R27,R30
	BRLT _0x2CE
_0x2CF:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL SUBOPT_0x1A
; 0000 06F8    if(ddop_m==0||ddop_m>200){ddop_m=10;}
_0x2CE:
	CALL SUBOPT_0xB1
	SBIW R26,0
	BREQ _0x2D2
	CALL SUBOPT_0xB1
	CPI  R26,LOW(0xC9)
	LDI  R30,HIGH(0xC9)
	CPC  R27,R30
	BRLT _0x2D1
_0x2D2:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL SUBOPT_0x1B
; 0000 06F9    if(t_zad==0||t_zad>1000){t_zad=10;}
_0x2D1:
	CALL SUBOPT_0xE5
	SBIW R26,0
	BREQ _0x2D5
	CALL SUBOPT_0xE5
	CPI  R26,LOW(0x3E9)
	LDI  R30,HIGH(0x3E9)
	CPC  R27,R30
	BRLO _0x2D4
_0x2D5:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	STS  _t_zad,R30
	STS  _t_zad+1,R31
; 0000 06FA   }
_0x2D4:
	RET
;
;  void programm()    // 
; 0000 06FD   {
_programm:
; 0000 06FE        proval_proverka();
	CALL _proval_proverka
; 0000 06FF        out_adc();
	CALL _out_adc
; 0000 0700        btn();
	RCALL _btn
; 0000 0701        read_time();
	CALL _read_time
; 0000 0702        read_date();
	CALL _read_date
; 0000 0703        lsd();
	CALL _lsd
; 0000 0704   }
	RET
;
;void main(void)
; 0000 0707 {
_main:
; 0000 0708 // Port A initialization
; 0000 0709 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 070A // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 070B PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 070C DDRA=0x00;
	OUT  0x1A,R30
; 0000 070D 
; 0000 070E // Port B initialization
; 0000 070F // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0710 // State7=P State6=P State5=P State4=P State3=P State2=T State1=T State0=T
; 0000 0711 PORTB=0xF8;
	LDI  R30,LOW(248)
	OUT  0x18,R30
; 0000 0712 DDRB=0x00;
	LDI  R30,LOW(0)
	OUT  0x17,R30
; 0000 0713 //DDRB.0=0;PORTB.0=0;
; 0000 0714 //DDRB.1=0;PORTB.1=0;
; 0000 0715 //DDRB.3=0;PORTB.3=1;
; 0000 0716 //DDRB.0=0;PORTB.0=1;
; 0000 0717 //DDRB.1=0;PORTB.1=1;
; 0000 0718 // Port C initialization
; 0000 0719 // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 071A // State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 071B PORTC=0x00;
	OUT  0x15,R30
; 0000 071C DDRC=0x3F;
	LDI  R30,LOW(63)
	OUT  0x14,R30
; 0000 071D 
; 0000 071E // Port D initialization
; 0000 071F // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
; 0000 0720 // State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=T State0=T
; 0000 0721 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 0722 DDRD=0xF0;
	LDI  R30,LOW(240)
	OUT  0x11,R30
; 0000 0723 
; 0000 0724 // Timer/Counter 0 initialization
; 0000 0725 // Clock source: System Clock
; 0000 0726 // Clock value: 2000,000 kHz
; 0000 0727 // Mode: Normal top=0xFF
; 0000 0728 // OC0 output: Disconnected
; 0000 0729 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 072A TCNT0=0x86;
	LDI  R30,LOW(134)
	OUT  0x32,R30
; 0000 072B OCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x3C,R30
; 0000 072C 
; 0000 072D // Timer/Counter 1 initialization
; 0000 072E // Clock source: System Clock
; 0000 072F // Clock value: Timer1 Stopped
; 0000 0730 // Mode: Normal top=0xFFFF
; 0000 0731 // OC1A output: Discon.
; 0000 0732 // OC1B output: Discon.
; 0000 0733 // Noise Canceler: Off
; 0000 0734 // Input Capture on Falling Edge
; 0000 0735 // Timer1 Overflow Interrupt: Off
; 0000 0736 // Input Capture Interrupt: Off
; 0000 0737 // Compare A Match Interrupt: Off
; 0000 0738 // Compare B Match Interrupt: Off
; 0000 0739 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 073A TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 073B TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 073C TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 073D ICR1H=0x00;
	OUT  0x27,R30
; 0000 073E ICR1L=0x00;
	OUT  0x26,R30
; 0000 073F OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0740 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0741 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0742 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0743 
; 0000 0744 // Timer/Counter 2 initialization
; 0000 0745 // Clock source: TOSC1 pin
; 0000 0746 // Clock value: PCK2
; 0000 0747 // Mode: Normal top=0xFF
; 0000 0748 // OC2 output: Disconnected
; 0000 0749 // ASSR |= (1 << 3);  // 
; 0000 074A ASSR=0x08;
	LDI  R30,LOW(8)
	OUT  0x22,R30
; 0000 074B TCCR2=0x00;
	LDI  R30,LOW(0)
	OUT  0x25,R30
; 0000 074C TCNT2=0xE0;
	LDI  R30,LOW(224)
	OUT  0x24,R30
; 0000 074D OCR2=0x00;
	LDI  R30,LOW(0)
	OUT  0x23,R30
; 0000 074E 
; 0000 074F // External Interrupt(s) initialization
; 0000 0750 // INT0: On
; 0000 0751 // INT0 Mode: Rising Edge
; 0000 0752 // INT1: On
; 0000 0753 // INT1 Mode: Rising Edge
; 0000 0754 // INT2: On
; 0000 0755 // INT2 Mode: Rising Edge
; 0000 0756 GICR|=0xE0;
	IN   R30,0x3B
	ORI  R30,LOW(0xE0)
	OUT  0x3B,R30
; 0000 0757 MCUCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x35,R30
; 0000 0758 MCUCSR=0x40;
	LDI  R30,LOW(64)
	OUT  0x34,R30
; 0000 0759 GIFR=0xE0;
	LDI  R30,LOW(224)
	OUT  0x3A,R30
; 0000 075A 
; 0000 075B // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 075C TIMSK=0x41;
	LDI  R30,LOW(65)
	OUT  0x39,R30
; 0000 075D 
; 0000 075E // USART initialization
; 0000 075F // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 0760 // USART Receiver: On
; 0000 0761 // USART Transmitter: On
; 0000 0762 // USART Mode: Asynchronous
; 0000 0763 // USART Baud Rate: 9600
; 0000 0764 //UCSRA=0x00;
; 0000 0765 //UCSRB=0x18;
; 0000 0766 //UCSRC=0x86;
; 0000 0767 //UBRRH=0x00;
; 0000 0768 //UBRRL=0x67;
; 0000 0769 
; 0000 076A // Analog Comparator initialization
; 0000 076B // Analog Comparator: Off
; 0000 076C // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 076D ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 076E SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 076F 
; 0000 0770 // ADC initialization
; 0000 0771 // ADC Clock frequency: 250,000 kHz
; 0000 0772 // ADC Voltage Reference: AVCC pin
; 0000 0773 ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(192)
	OUT  0x7,R30
; 0000 0774 ADCSRA=0x86;
	LDI  R30,LOW(134)
	OUT  0x6,R30
; 0000 0775 
; 0000 0776 // SPI initialization
; 0000 0777 // SPI disabled
; 0000 0778 SPCR=0x00;
	LDI  R30,LOW(0)
	OUT  0xD,R30
; 0000 0779 
; 0000 077A // TWI initialization
; 0000 077B // TWI disabled
; 0000 077C TWCR=0x00;
	OUT  0x36,R30
; 0000 077D 
; 0000 077E // I2C Bus initialization
; 0000 077F i2c_init();
	CALL _i2c_init
; 0000 0780 
; 0000 0781 // DS1307 Real Time Clock initialization
; 0000 0782 // Square wave output on pin SQW/OUT: On
; 0000 0783 // Square wave frequency: 32768Hz
; 0000 0784 //rtc_init(3,1,0);
; 0000 0785 rtc_init(0,0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	ST   -Y,R30
	RCALL _rtc_init
; 0000 0786 
; 0000 0787 // Alphanumeric LCD initialization
; 0000 0788 // Connections specified in the
; 0000 0789 // Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
; 0000 078A // RS - PORTC Bit 0
; 0000 078B // RD - PORTD Bit 7
; 0000 078C // EN - PORTC Bit 1
; 0000 078D // D4 - PORTC Bit 2
; 0000 078E // D5 - PORTC Bit 3
; 0000 078F // D6 - PORTC Bit 4
; 0000 0790 // D7 - PORTC Bit 5
; 0000 0791 // Characters/line: 20
; 0000 0792 lcd_init(20);
	LDI  R30,LOW(20)
	ST   -Y,R30
	RCALL _lcd_init
; 0000 0793 
; 0000 0794 // Global enable interrupts
; 0000 0795 #asm("sei")
	sei
; 0000 0796     start_mem();//   
	CALL _start_mem
; 0000 0797 while (1)
_0x2D7:
; 0000 0798       {
; 0000 0799        programm(); // 
	RCALL _programm
; 0000 079A       }
	RJMP _0x2D7
; 0000 079B }
_0x2DA:
	RJMP _0x2DA

	.CSEG
_rtc_init:
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	STD  Y+2,R30
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x2000003
	LDD  R30,Y+2
	ORI  R30,0x10
	STD  Y+2,R30
_0x2000003:
	LD   R30,Y
	CPI  R30,0
	BREQ _0x2000004
	LDD  R30,Y+2
	ORI  R30,0x80
	STD  Y+2,R30
_0x2000004:
	CALL SUBOPT_0xE9
	LDI  R30,LOW(7)
	CALL SUBOPT_0xEA
	CALL SUBOPT_0xEB
	RJMP _0x20E0003
_rtc_get_time:
	CALL SUBOPT_0xE9
	LDI  R30,LOW(0)
	CALL SUBOPT_0xEC
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0xED
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RJMP _0x20E0004
_rtc_set_time:
	CALL SUBOPT_0xE9
	LDI  R30,LOW(0)
	CALL SUBOPT_0xEE
	CALL SUBOPT_0xEF
	CALL SUBOPT_0xEA
	CALL _bin2bcd
	ST   -Y,R30
	CALL SUBOPT_0xEB
	RJMP _0x20E0003
_rtc_get_date:
	CALL SUBOPT_0xE9
	LDI  R30,LOW(4)
	CALL SUBOPT_0xEC
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL SUBOPT_0xED
	LD   R26,Y
	LDD  R27,Y+1
_0x20E0004:
	ST   X,R30
	CALL _i2c_stop
	ADIW R28,6
	RET
_rtc_set_date:
	CALL SUBOPT_0xE9
	LDI  R30,LOW(4)
	CALL SUBOPT_0xEA
	CALL _bin2bcd
	ST   -Y,R30
	CALL SUBOPT_0xEF
	CALL SUBOPT_0xEE
	CALL SUBOPT_0xEB
	RJMP _0x20E0003
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G101:
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2020004
	SBI  0x12,4
	RJMP _0x2020005
_0x2020004:
	CBI  0x12,4
_0x2020005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2020006
	SBI  0x12,5
	RJMP _0x2020007
_0x2020006:
	CBI  0x12,5
_0x2020007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2020008
	SBI  0x12,6
	RJMP _0x2020009
_0x2020008:
	CBI  0x12,6
_0x2020009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x202000A
	SBI  0x12,7
	RJMP _0x202000B
_0x202000A:
	CBI  0x12,7
_0x202000B:
	__DELAY_USB 11
	SBI  0x15,1
	__DELAY_USB 27
	CBI  0x15,1
	__DELAY_USB 27
	RJMP _0x20E0002
__lcd_write_data:
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G101
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G101
	__DELAY_USW 200
	RJMP _0x20E0002
_lcd_gotoxy:
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G101)
	SBCI R31,HIGH(-__base_y_G101)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	RCALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R30,LOW(2)
	CALL SUBOPT_0xF0
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(1)
	CALL SUBOPT_0xF0
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2020011
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2020010
_0x2020011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	ST   -Y,R30
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2020013
	RJMP _0x20E0002
_0x2020013:
_0x2020010:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	SBI  0x15,0
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_data
	CBI  0x15,0
	RJMP _0x20E0002
_lcd_puts:
	ST   -Y,R17
_0x2020014:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2020016
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2020014
_0x2020016:
	LDD  R17,Y+0
_0x20E0003:
	ADIW R28,3
	RET
_lcd_init:
	SBI  0x11,4
	SBI  0x11,5
	SBI  0x11,6
	SBI  0x11,7
	SBI  0x14,1
	SBI  0x14,0
	SBI  0x14,2
	CBI  0x15,1
	CBI  0x15,0
	CBI  0x15,2
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G101,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G101,3
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CALL SUBOPT_0x17
	CALL SUBOPT_0xF1
	CALL SUBOPT_0xF1
	CALL SUBOPT_0xF1
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_write_nibble_G101
	__DELAY_USW 400
	LDI  R30,LOW(40)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(133)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x20E0002:
	ADIW R28,1
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G102:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2040010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2040012
	__CPWRN 16,17,2
	BRLO _0x2040013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2040012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL SUBOPT_0x47
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2040014
	CALL SUBOPT_0x47
_0x2040014:
_0x2040013:
	RJMP _0x2040015
_0x2040010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2040015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
__print_G102:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2040016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2040018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x204001C
	CPI  R18,37
	BRNE _0x204001D
	LDI  R17,LOW(1)
	RJMP _0x204001E
_0x204001D:
	CALL SUBOPT_0xF2
_0x204001E:
	RJMP _0x204001B
_0x204001C:
	CPI  R30,LOW(0x1)
	BRNE _0x204001F
	CPI  R18,37
	BRNE _0x2040020
	CALL SUBOPT_0xF2
	RJMP _0x20400C9
_0x2040020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2040021
	LDI  R16,LOW(1)
	RJMP _0x204001B
_0x2040021:
	CPI  R18,43
	BRNE _0x2040022
	LDI  R20,LOW(43)
	RJMP _0x204001B
_0x2040022:
	CPI  R18,32
	BRNE _0x2040023
	LDI  R20,LOW(32)
	RJMP _0x204001B
_0x2040023:
	RJMP _0x2040024
_0x204001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2040025
_0x2040024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2040026
	ORI  R16,LOW(128)
	RJMP _0x204001B
_0x2040026:
	RJMP _0x2040027
_0x2040025:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x204001B
_0x2040027:
	CPI  R18,48
	BRLO _0x204002A
	CPI  R18,58
	BRLO _0x204002B
_0x204002A:
	RJMP _0x2040029
_0x204002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x204001B
_0x2040029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x204002F
	CALL SUBOPT_0xF3
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0xF4
	RJMP _0x2040030
_0x204002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2040032
	CALL SUBOPT_0xF3
	CALL SUBOPT_0xF5
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2040033
_0x2040032:
	CPI  R30,LOW(0x70)
	BRNE _0x2040035
	CALL SUBOPT_0xF3
	CALL SUBOPT_0xF5
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2040033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2040036
_0x2040035:
	CPI  R30,LOW(0x64)
	BREQ _0x2040039
	CPI  R30,LOW(0x69)
	BRNE _0x204003A
_0x2040039:
	ORI  R16,LOW(4)
	RJMP _0x204003B
_0x204003A:
	CPI  R30,LOW(0x75)
	BRNE _0x204003C
_0x204003B:
	LDI  R30,LOW(_tbl10_G102*2)
	LDI  R31,HIGH(_tbl10_G102*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x204003D
_0x204003C:
	CPI  R30,LOW(0x58)
	BRNE _0x204003F
	ORI  R16,LOW(8)
	RJMP _0x2040040
_0x204003F:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2040071
_0x2040040:
	LDI  R30,LOW(_tbl16_G102*2)
	LDI  R31,HIGH(_tbl16_G102*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x204003D:
	SBRS R16,2
	RJMP _0x2040042
	CALL SUBOPT_0xF3
	CALL SUBOPT_0xF6
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2040043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2040043:
	CPI  R20,0
	BREQ _0x2040044
	SUBI R17,-LOW(1)
	RJMP _0x2040045
_0x2040044:
	ANDI R16,LOW(251)
_0x2040045:
	RJMP _0x2040046
_0x2040042:
	CALL SUBOPT_0xF3
	CALL SUBOPT_0xF6
_0x2040046:
_0x2040036:
	SBRC R16,0
	RJMP _0x2040047
_0x2040048:
	CP   R17,R21
	BRSH _0x204004A
	SBRS R16,7
	RJMP _0x204004B
	SBRS R16,2
	RJMP _0x204004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x204004D
_0x204004C:
	LDI  R18,LOW(48)
_0x204004D:
	RJMP _0x204004E
_0x204004B:
	LDI  R18,LOW(32)
_0x204004E:
	CALL SUBOPT_0xF2
	SUBI R21,LOW(1)
	RJMP _0x2040048
_0x204004A:
_0x2040047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x204004F
_0x2040050:
	CPI  R19,0
	BREQ _0x2040052
	SBRS R16,3
	RJMP _0x2040053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2040054
_0x2040053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2040054:
	CALL SUBOPT_0xF2
	CPI  R21,0
	BREQ _0x2040055
	SUBI R21,LOW(1)
_0x2040055:
	SUBI R19,LOW(1)
	RJMP _0x2040050
_0x2040052:
	RJMP _0x2040056
_0x204004F:
_0x2040058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x204005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x204005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x204005A
_0x204005C:
	CPI  R18,58
	BRLO _0x204005D
	SBRS R16,3
	RJMP _0x204005E
	SUBI R18,-LOW(7)
	RJMP _0x204005F
_0x204005E:
	SUBI R18,-LOW(39)
_0x204005F:
_0x204005D:
	SBRC R16,4
	RJMP _0x2040061
	CPI  R18,49
	BRSH _0x2040063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2040062
_0x2040063:
	RJMP _0x20400CA
_0x2040062:
	CP   R21,R19
	BRLO _0x2040067
	SBRS R16,0
	RJMP _0x2040068
_0x2040067:
	RJMP _0x2040066
_0x2040068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2040069
	LDI  R18,LOW(48)
_0x20400CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x204006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0xF4
	CPI  R21,0
	BREQ _0x204006B
	SUBI R21,LOW(1)
_0x204006B:
_0x204006A:
_0x2040069:
_0x2040061:
	CALL SUBOPT_0xF2
	CPI  R21,0
	BREQ _0x204006C
	SUBI R21,LOW(1)
_0x204006C:
_0x2040066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2040059
	RJMP _0x2040058
_0x2040059:
_0x2040056:
	SBRS R16,0
	RJMP _0x204006D
_0x204006E:
	CPI  R21,0
	BREQ _0x2040070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0xF4
	RJMP _0x204006E
_0x2040070:
_0x204006D:
_0x2040071:
_0x2040030:
_0x20400C9:
	LDI  R17,LOW(0)
_0x204001B:
	RJMP _0x2040016
_0x2040018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0xF7
	SBIW R30,0
	BRNE _0x2040072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20E0001
_0x2040072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0xF7
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G102)
	LDI  R31,HIGH(_put_buff_G102)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G102
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20E0001:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_sleep_enable:
   in   r30,power_ctrl_reg
   sbr  r30,__se_bit
   out  power_ctrl_reg,r30
	RET
_powerdown:
   in   r30,power_ctrl_reg
   cbr  r30,__sm_mask
   sbr  r30,__sm_powerdown
   out  power_ctrl_reg,r30
   in   r30,sreg
   sei
   sleep
   out  sreg,r30
	RET

	.CSEG
_bcd2bin:
    ld   r30,y
    swap r30
    andi r30,0xf
    mov  r26,r30
    lsl  r26
    lsl  r26
    add  r30,r26
    lsl  r30
    ld   r26,y+
    andi r26,0xf
    add  r30,r26
    ret
_bin2bcd:
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret

	.CSEG

	.DSEG
_lcd_buffer:
	.BYTE 0x80
_u_delta_b:
	.BYTE 0x2
_u_delta_c:
	.BYTE 0x2
_u_delta_ua:
	.BYTE 0x2
_u_delta_ub:
	.BYTE 0x2
_u_delta_uc:
	.BYTE 0x2
_ua_r:
	.BYTE 0x2
_ub_r:
	.BYTE 0x2
_uc_r:
	.BYTE 0x2
_u_a:
	.BYTE 0x2
_u_b:
	.BYTE 0x2
_u_c:
	.BYTE 0x2
_u_aa:
	.BYTE 0x4
_u_bb:
	.BYTE 0x4
_u_cc:
	.BYTE 0x4
_u_nn:
	.BYTE 0x4
_u_batp:
	.BYTE 0x2
_u_bat:
	.BYTE 0x2
_sis:
	.BYTE 0x2
_zar:
	.BYTE 0x2
_u_batt:
	.BYTE 0x4
_tna:
	.BYTE 0x2
_tnb:
	.BYTE 0x2
_tnc:
	.BYTE 0x2
_t_msa:
	.BYTE 0x2
_t_msb:
	.BYTE 0x2
_t_msc:
	.BYTE 0x2
_t_ms:
	.BYTE 0x4
_menu:
	.BYTE 0x1
_menu_def:
	.BYTE 0x1
_i:
	.BYTE 0x1
_menu_p:
	.BYTE 0x1
_menu_pp:
	.BYTE 0x1
_menu_ppp:
	.BYTE 0x1
_flag:
	.BYTE 0x1
_rtc:
	.BYTE 0x1
_stat_na:
	.BYTE 0x1
_stat_nb:
	.BYTE 0x1
_stat_nc:
	.BYTE 0x1
_flag_st:
	.BYTE 0x1
_dopusk:
	.BYTE 0x4
_dop:
	.BYTE 0x4
_dopusk_m:
	.BYTE 0x4
_dop_m:
	.BYTE 0x4
_ddop:
	.BYTE 0x2
_ddop_m:
	.BYTE 0x2
_faza:
	.BYTE 0x1
_izm:
	.BYTE 0x1
_go_izm:
	.BYTE 0x1
_izm_faza:
	.BYTE 0x1
_rezjim:
	.BYTE 0x1
_rez:
	.BYTE 0x1
_del_a:
	.BYTE 0x1
_del_b:
	.BYTE 0x1
_del_c:
	.BYTE 0x1
_t_zad:
	.BYTE 0x2
_tt:
	.BYTE 0x2
_ta:
	.BYTE 0x2
_tb:
	.BYTE 0x2
_tc:
	.BYTE 0x2
_hour:
	.BYTE 0x1
_minut:
	.BYTE 0x1
_sek:
	.BYTE 0x1
_m:
	.BYTE 0x1
_h:
	.BYTE 0x1
_s:
	.BYTE 0x1
_mm:
	.BYTE 0x2
_hh:
	.BYTE 0x2
_ss:
	.BYTE 0x2
_day:
	.BYTE 0x1
_month:
	.BYTE 0x1
_year:
	.BYTE 0x1
_d:
	.BYTE 0x1
_mo:
	.BYTE 0x1
_y:
	.BYTE 0x1
_sssa:
	.BYTE 0x4
_temp_sa:
	.BYTE 0x4
_temp_ssa:
	.BYTE 0x4
_temp_ma:
	.BYTE 0x4
_sss:
	.BYTE 0x4
_sma:
	.BYTE 0x4
_sha:
	.BYTE 0x4
_sssb:
	.BYTE 0x4
_temp_sb:
	.BYTE 0x4
_temp_ssb:
	.BYTE 0x4
_temp_mb:
	.BYTE 0x4
_smb:
	.BYTE 0x4
_shb:
	.BYTE 0x4
_sssc:
	.BYTE 0x4
_temp_sc:
	.BYTE 0x4
_temp_ssc:
	.BYTE 0x4
_temp_mc:
	.BYTE 0x4
_smc:
	.BYTE 0x4
_shc:
	.BYTE 0x4
_dat_a:
	.BYTE 0x1
_dat_b:
	.BYTE 0x1
_dat_c:
	.BYTE 0x1
_mem_a:
	.BYTE 0x1
_mem_b:
	.BYTE 0x1
_mem_c:
	.BYTE 0x1

	.ESEG
_save:
	.BYTE 0xC
_proval_ua:
	.BYTE 0x4A
_proval_ub:
	.BYTE 0x4A
_proval_uc:
	.BYTE 0x4A
_proval_ta:
	.BYTE 0x4A
_proval_tb:
	.BYTE 0x4A
_proval_tc:
	.BYTE 0x4A
_proval_tma:
	.BYTE 0x25
_proval_tmb:
	.BYTE 0x25
_proval_tmc:
	.BYTE 0x25
_time_ha:
	.BYTE 0x25
_time_ma:
	.BYTE 0x25
_date_ma:
	.BYTE 0x25
_date_da:
	.BYTE 0x25
_time_hb:
	.BYTE 0x25
_time_mb:
	.BYTE 0x25
_date_mb:
	.BYTE 0x25
_date_db:
	.BYTE 0x25
_time_hc:
	.BYTE 0x25
_time_mc:
	.BYTE 0x25
_date_mc:
	.BYTE 0x25
_date_dc:
	.BYTE 0x25
_proval_na:
	.BYTE 0x1
_proval_nb:
	.BYTE 0x1
_proval_nc:
	.BYTE 0x1

	.DSEG
__base_y_G101:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x0:
	LDI  R26,LOW(_proval_ta)
	LDI  R27,HIGH(_proval_ta)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1:
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDS  R30,_i
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x2:
	LDI  R26,LOW(_proval_ua)
	LDI  R27,HIGH(_proval_ua)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x3:
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __EEPROMWRW
	MOVW R26,R0
	CALL __EEPROMWRB
	MOVW R26,R22
	LDI  R31,0
	CALL __EEPROMWRW
	LDS  R30,_i
	LDI  R31,0
	MOVW R0,R30
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	MOVW R0,R30
	LDS  R26,_i
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
	MOVW R26,R0
	CALL __EEPROMWRB
	MOVW R26,R22
	CALL __EEPROMWRB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x6:
	CALL __EEPROMWRB
	LDI  R26,LOW(_proval_na)
	LDI  R27,HIGH(_proval_na)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:85 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,0
	ST   -Y,R31
	ST   -Y,R30
	LDS  R26,_i
	LDI  R30,LOW(2)
	MUL  R30,R26
	MOVW R30,R0
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 118 TIMES, CODE SIZE REDUCTION:1167 WORDS
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9:
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	CALL _lcd_clear
	LDI  R30,LOW(0)
	STS  _i,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 33 TIMES, CODE SIZE REDUCTION:253 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	CALL _lcd_clear
	LDI  R30,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xD:
	LDI  R26,LOW(_proval_tb)
	LDI  R27,HIGH(_proval_tb)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0xE:
	LDI  R26,LOW(_proval_ub)
	LDI  R27,HIGH(_proval_ub)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xF:
	CALL __EEPROMWRB
	LDI  R26,LOW(_proval_nb)
	LDI  R27,HIGH(_proval_nb)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x10:
	LDI  R26,LOW(_proval_tc)
	LDI  R27,HIGH(_proval_tc)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x11:
	LDI  R26,LOW(_proval_uc)
	LDI  R27,HIGH(_proval_uc)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x12:
	CALL __EEPROMWRB
	LDI  R26,LOW(_proval_nc)
	LDI  R27,HIGH(_proval_nc)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 38 TIMES, CODE SIZE REDUCTION:293 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 42 TIMES, CODE SIZE REDUCTION:325 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 33 TIMES, CODE SIZE REDUCTION:253 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 84 TIMES, CODE SIZE REDUCTION:163 WORDS
SUBOPT_0x17:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	LDI  R26,LOW(_save)
	LDI  R27,HIGH(_save)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	__POINTW2MN _save,10
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1A:
	STS  _ddop,R30
	STS  _ddop+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1B:
	STS  _ddop_m,R30
	STS  _ddop_m+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1C:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
	LDS  R30,_izm
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1D:
	LDI  R30,LOW(2)
	OUT  0x33,R30
	LDI  R30,LOW(1)
	STS  _izm,R30
	LDI  R30,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1E:
	STS  _ta,R30
	STS  _ta+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1F:
	STS  _tb,R30
	STS  _tb+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x20:
	STS  _tc,R30
	STS  _tc+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x21:
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _read_adc
	LSL  R30
	ROL  R31
	STS  _u_a,R30
	STS  _u_a+1,R31
	LDI  R30,LOW(0)
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _read_adc
	LSL  R30
	ROL  R31
	STS  _u_b,R30
	STS  _u_b+1,R31
	LDI  R30,LOW(0)
	RJMP SUBOPT_0x1F

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x23:
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _read_adc
	LSL  R30
	ROL  R31
	STS  _u_c,R30
	STS  _u_c+1,R31
	LDI  R30,LOW(0)
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 25 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x24:
	LDS  R26,_u_a
	LDS  R27,_u_a+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x25:
	LDS  R30,_ua_r
	LDS  R31,_ua_r+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x26:
	LDS  R30,_u_a
	LDS  R31,_u_a+1
	STS  _ua_r,R30
	STS  _ua_r+1,R31
	LDI  R26,LOW(_proval_na)
	LDI  R27,HIGH(_proval_na)
	CALL __EEPROMRDB
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x27:
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x25
	CALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 25 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x28:
	LDS  R26,_u_b
	LDS  R27,_u_b+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x29:
	LDS  R30,_ub_r
	LDS  R31,_ub_r+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2A:
	LDS  R30,_u_b
	LDS  R31,_u_b+1
	STS  _ub_r,R30
	STS  _ub_r+1,R31
	LDI  R26,LOW(_proval_nb)
	LDI  R27,HIGH(_proval_nb)
	CALL __EEPROMRDB
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x29
	CALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 25 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x2C:
	LDS  R26,_u_c
	LDS  R27,_u_c+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2D:
	LDS  R30,_uc_r
	LDS  R31,_uc_r+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2E:
	LDS  R30,_u_c
	LDS  R31,_u_c+1
	STS  _uc_r,R30
	STS  _uc_r+1,R31
	LDI  R26,LOW(_proval_nc)
	LDI  R27,HIGH(_proval_nc)
	CALL __EEPROMRDB
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2F:
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x2D
	CALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x30:
	LDS  R30,_ddop
	LDS  R31,_ddop+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x31:
	CALL __CWD1
	CALL __CDF1
	CALL __PUTDP1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x32:
	__GETD1N 0x42C80000
	CALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x33:
	STS  _dop,R30
	STS  _dop+1,R31
	STS  _dop+2,R22
	STS  _dop+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x34:
	LDS  R30,_ddop_m
	LDS  R31,_ddop_m+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	STS  _dop_m,R30
	STS  _dop_m+1,R31
	STS  _dop_m+2,R22
	STS  _dop_m+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x36:
	LDS  R30,_u_a
	LDS  R31,_u_a+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x37:
	MOVW R30,R8
	LDI  R26,LOW(_u_nn)
	LDI  R27,HIGH(_u_nn)
	RJMP SUBOPT_0x31

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:57 WORDS
SUBOPT_0x38:
	LDS  R26,_u_nn
	LDS  R27,_u_nn+1
	LDS  R24,_u_nn+2
	LDS  R25,_u_nn+3
	__GETD1N 0x42C80000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x39:
	LDS  R26,_u_aa
	LDS  R27,_u_aa+1
	LDS  R24,_u_aa+2
	LDS  R25,_u_aa+3
	__GETD1N 0x42C80000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:67 WORDS
SUBOPT_0x3A:
	CALL __SWAPD12
	CALL __SUBF12
	MOVW R26,R30
	MOVW R24,R22
	LDS  R30,_u_nn
	LDS  R31,_u_nn+1
	LDS  R22,_u_nn+2
	LDS  R23,_u_nn+3
	CALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3B:
	__GETD2N 0xC2C80000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3C:
	RCALL SUBOPT_0x24
	CP   R26,R8
	CPC  R27,R9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x3D:
	__GETD2N 0x42C80000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x3E:
	MOVW R30,R8
	SUB  R30,R26
	SBC  R31,R27
	CALL __CWD1
	__GETD2N 0x10000
	CALL __SWAPD12
	CALL __SUBD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3F:
	LDS  R30,_u_b
	LDS  R31,_u_b+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x40:
	LDS  R26,_u_bb
	LDS  R27,_u_bb+1
	LDS  R24,_u_bb+2
	LDS  R25,_u_bb+3
	__GETD1N 0x42C80000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x41:
	LDI  R26,LOW(_u_delta_b)
	LDI  R27,HIGH(_u_delta_b)
	CALL __CFD1
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x42:
	RCALL SUBOPT_0x28
	CP   R26,R8
	CPC  R27,R9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x43:
	LDS  R30,_u_c
	LDS  R31,_u_c+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x44:
	LDS  R26,_u_cc
	LDS  R27,_u_cc+1
	LDS  R24,_u_cc+2
	LDS  R25,_u_cc+3
	__GETD1N 0x42C80000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x45:
	LDI  R26,LOW(_u_delta_c)
	LDI  R27,HIGH(_u_delta_c)
	CALL __CFD1
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x46:
	RCALL SUBOPT_0x2C
	CP   R26,R8
	CPC  R27,R9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x47:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:69 WORDS
SUBOPT_0x48:
	LDS  R30,_dop_m
	LDS  R31,_dop_m+1
	LDS  R22,_dop_m+2
	LDS  R23,_dop_m+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x49:
	MOVW R26,R8
	CALL __CWD2
	CALL __CDF2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:69 WORDS
SUBOPT_0x4A:
	LDS  R30,_dop
	LDS  R31,_dop+1
	LDS  R22,_dop+2
	LDS  R23,_dop+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x4B:
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x24
	CALL __CWD2
	CALL __CDF2
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x4C:
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x24
	CALL __CWD2
	CALL __CDF2
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x4D:
	CLR  R4
	LDI  R30,LOW(0)
	STS  _t_msa,R30
	STS  _t_msa+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x4E:
	LDI  R26,LOW(_proval_na)
	LDI  R27,HIGH(_proval_na)
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x4F:
	LDI  R31,0
	SUBI R30,LOW(-_time_ma)
	SBCI R31,HIGH(-_time_ma)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x50:
	MOVW R26,R30
	CALL __EEPROMRDB
	MOV  R26,R30
	LDS  R30,_m
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x51:
	LDS  R30,_t_ms
	LDS  R31,_t_ms+1
	STS  _tna,R30
	STS  _tna+1,R31
	LDI  R30,LOW(1)
	MOV  R4,R30
	OUT  0x25,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x52:
	LDI  R30,LOW(219)
	LDI  R31,HIGH(219)
	STS  _ua_r,R30
	STS  _ua_r+1,R31
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x53:
	LDI  R30,LOW(221)
	LDI  R31,HIGH(221)
	STS  _ua_r,R30
	STS  _ua_r+1,R31
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x54:
	LDS  R30,_t_zad
	LDS  R31,_t_zad+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x55:
	LDS  R26,_t_msa
	LDS  R27,_t_msa+1
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x56:
	SUBI R30,-LOW(1)
	CALL __EEPROMWRB
	SUBI R30,LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x57:
	LDI  R31,0
	SUBI R30,LOW(-_time_ha)
	SBCI R31,HIGH(-_time_ha)
	MOVW R26,R30
	LDS  R30,_h
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 42 TIMES, CODE SIZE REDUCTION:120 WORDS
SUBOPT_0x58:
	CALL __EEPROMRDB
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x59:
	SUBI R30,LOW(-_date_ma)
	SBCI R31,HIGH(-_date_ma)
	MOVW R26,R30
	LDS  R30,_mo
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x5A:
	SUBI R30,LOW(-_date_da)
	SBCI R31,HIGH(-_date_da)
	MOVW R26,R30
	LDS  R30,_d
	CALL __EEPROMWRB
	LDS  R30,_s
	CLR  R31
	CLR  R22
	CLR  R23
	STS  _temp_sa,R30
	STS  _temp_sa+1,R31
	STS  _temp_sa+2,R22
	STS  _temp_sa+3,R23
	LDI  R30,LOW(2)
	MOV  R4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x5B:
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x28
	CALL __CWD2
	CALL __CDF2
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x5C:
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x28
	CALL __CWD2
	CALL __CDF2
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x5D:
	CLR  R5
	LDI  R30,LOW(0)
	STS  _t_msb,R30
	STS  _t_msb+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x5E:
	LDI  R26,LOW(_proval_nb)
	LDI  R27,HIGH(_proval_nb)
	RJMP SUBOPT_0x58

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x5F:
	LDS  R30,_t_ms
	LDS  R31,_t_ms+1
	STS  _tnb,R30
	STS  _tnb+1,R31
	LDI  R30,LOW(1)
	MOV  R5,R30
	OUT  0x25,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x60:
	LDI  R30,LOW(219)
	LDI  R31,HIGH(219)
	STS  _ub_r,R30
	STS  _ub_r+1,R31
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x61:
	LDI  R30,LOW(221)
	LDI  R31,HIGH(221)
	STS  _ub_r,R30
	STS  _ub_r+1,R31
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x62:
	RCALL SUBOPT_0x54
	LDS  R26,_t_msb
	LDS  R27,_t_msb+1
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x63:
	LDI  R26,LOW(_proval_nb)
	LDI  R27,HIGH(_proval_nb)
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x64:
	SUBI R30,LOW(-_time_hb)
	SBCI R31,HIGH(-_time_hb)
	MOVW R26,R30
	LDS  R30,_h
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x65:
	SUBI R30,LOW(-_time_mb)
	SBCI R31,HIGH(-_time_mb)
	MOVW R26,R30
	LDS  R30,_m
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x66:
	SUBI R30,LOW(-_date_mb)
	SBCI R31,HIGH(-_date_mb)
	MOVW R26,R30
	LDS  R30,_mo
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x67:
	SUBI R30,LOW(-_date_db)
	SBCI R31,HIGH(-_date_db)
	MOVW R26,R30
	LDS  R30,_d
	CALL __EEPROMWRB
	LDS  R30,_s
	CLR  R31
	CLR  R22
	CLR  R23
	STS  _temp_sb,R30
	STS  _temp_sb+1,R31
	STS  _temp_sb+2,R22
	STS  _temp_sb+3,R23
	LDI  R30,LOW(2)
	MOV  R5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x68:
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x2C
	CALL __CWD2
	CALL __CDF2
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x69:
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x2C
	CALL __CWD2
	CALL __CDF2
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x6A:
	CLR  R7
	LDI  R30,LOW(0)
	STS  _t_msc,R30
	STS  _t_msc+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x6B:
	LDI  R26,LOW(_proval_nc)
	LDI  R27,HIGH(_proval_nc)
	RJMP SUBOPT_0x58

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x6C:
	LDS  R30,_t_ms
	LDS  R31,_t_ms+1
	STS  _tnc,R30
	STS  _tnc+1,R31
	LDI  R30,LOW(1)
	MOV  R7,R30
	OUT  0x25,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6D:
	LDI  R30,LOW(219)
	LDI  R31,HIGH(219)
	STS  _uc_r,R30
	STS  _uc_r+1,R31
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6E:
	LDI  R30,LOW(221)
	LDI  R31,HIGH(221)
	STS  _uc_r,R30
	STS  _uc_r+1,R31
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x6F:
	RCALL SUBOPT_0x54
	LDS  R26,_t_msc
	LDS  R27,_t_msc+1
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x70:
	LDI  R26,LOW(_proval_nc)
	LDI  R27,HIGH(_proval_nc)
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x71:
	SUBI R30,LOW(-_time_hc)
	SBCI R31,HIGH(-_time_hc)
	MOVW R26,R30
	LDS  R30,_h
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x72:
	SUBI R30,LOW(-_time_mc)
	SBCI R31,HIGH(-_time_mc)
	MOVW R26,R30
	LDS  R30,_m
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x73:
	SUBI R30,LOW(-_date_mc)
	SBCI R31,HIGH(-_date_mc)
	MOVW R26,R30
	LDS  R30,_mo
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x74:
	SUBI R30,LOW(-_date_dc)
	SBCI R31,HIGH(-_date_dc)
	MOVW R26,R30
	LDS  R30,_d
	CALL __EEPROMWRB
	LDS  R30,_s
	CLR  R31
	CLR  R22
	CLR  R23
	STS  _temp_sc,R30
	STS  _temp_sc+1,R31
	STS  _temp_sc+2,R22
	STS  _temp_sc+3,R23
	LDI  R30,LOW(2)
	MOV  R7,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x75:
	LDS  R26,_t_ms
	LDS  R27,_t_ms+1
	LDS  R24,_t_ms+2
	LDS  R25,_t_ms+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x76:
	LDS  R30,_tna
	LDS  R31,_tna+1
	RCALL SUBOPT_0x75
	CLR  R22
	CLR  R23
	CALL __SWAPD12
	CALL __SUBD12
	STS  _t_msa,R30
	STS  _t_msa+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x77:
	LDS  R30,_tnb
	LDS  R31,_tnb+1
	RCALL SUBOPT_0x75
	CLR  R22
	CLR  R23
	CALL __SWAPD12
	CALL __SUBD12
	STS  _t_msb,R30
	STS  _t_msb+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x78:
	LDS  R30,_tnc
	LDS  R31,_tnc+1
	RCALL SUBOPT_0x75
	CLR  R22
	CLR  R23
	CALL __SWAPD12
	CALL __SUBD12
	STS  _t_msc,R30
	STS  _t_msc+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:41 WORDS
SUBOPT_0x79:
	MOVW R26,R30
	CALL __EEPROMRDB
	CLR  R31
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7A:
	__GETD2N 0xE10
	CALL __MULD12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x7B:
	__GETD2N 0x3C
	CALL __MULD12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x7C:
	LDS  R30,_sss
	LDS  R31,_sss+1
	LDS  R22,_sss+2
	LDS  R23,_sss+3
	CALL __SUBD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7D:
	LDS  R26,_temp_ssa
	LDS  R27,_temp_ssa+1
	LDS  R24,_temp_ssa+2
	LDS  R25,_temp_ssa+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7E:
	__GETD1N 0x3C
	CALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7F:
	LDI  R31,0
	SUBI R30,LOW(-_proval_tma)
	SBCI R31,HIGH(-_proval_tma)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x80:
	CALL __SWAPD12
	CALL __SUBD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x81:
	LDS  R26,_temp_ssb
	LDS  R27,_temp_ssb+1
	LDS  R24,_temp_ssb+2
	LDS  R25,_temp_ssb+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x82:
	LDS  R26,_temp_ssc
	LDS  R27,_temp_ssc+1
	LDS  R24,_temp_ssc+2
	LDS  R25,_temp_ssc+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x83:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x84:
	LDS  R26,_t_msa
	LDS  R27,_t_msa+1
	CPI  R26,LOW(0xE678)
	LDI  R30,HIGH(0xE678)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 92 TIMES, CODE SIZE REDUCTION:179 WORDS
SUBOPT_0x85:
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 28 TIMES, CODE SIZE REDUCTION:51 WORDS
SUBOPT_0x86:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 25 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x87:
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:41 WORDS
SUBOPT_0x88:
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDW
	RJMP SUBOPT_0x86

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x89:
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x8A:
	CALL _lcd_puts
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x8B:
	LDI  R30,LOW(2)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8C:
	LDS  R26,_t_msb
	LDS  R27,_t_msb+1
	CPI  R26,LOW(0xE678)
	LDI  R30,HIGH(0xE678)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8D:
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8E:
	LDS  R26,_t_msc
	LDS  R27,_t_msc+1
	CPI  R26,LOW(0xE678)
	LDI  R30,HIGH(0xE678)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:83 WORDS
SUBOPT_0x8F:
	__POINTW1FN _0x0,505
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_h
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDS  R26,_m
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	CALL __CWD1
	CALL __PUTPARD1
	LDS  R26,_m
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	CALL __CWD1
	CALL __PUTPARD1
	LDS  R26,_s
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	CALL __CWD1
	CALL __PUTPARD1
	LDS  R26,_s
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	CALL __CWD1
	CALL __PUTPARD1
	LDS  R30,_d
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDS  R30,_mo
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDS  R30,_y
	LDI  R31,0
	SUBI R30,LOW(-2000)
	SBCI R31,HIGH(-2000)
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,32
	CALL _sprintf
	ADIW R28,36
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x90:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x91:
	RCALL SUBOPT_0x36
	CALL __CWD1
	CALL __PUTPARD1
	RJMP SUBOPT_0x87

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x92:
	RCALL SUBOPT_0x3F
	CALL __CWD1
	CALL __PUTPARD1
	RJMP SUBOPT_0x87

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x93:
	RCALL SUBOPT_0x43
	CALL __CWD1
	CALL __PUTPARD1
	RJMP SUBOPT_0x87

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x94:
	CALL _lcd_puts
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x95:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x96:
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x36
	CALL __CWD1
	CALL __PUTPARD1
	MOVW R26,R12
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __DIVW21
	CALL __CWD1
	CALL __PUTPARD1
	RJMP SUBOPT_0x89

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x97:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_u_delta_ua
	LDS  R31,_u_delta_ua+1
	CALL __CWD1
	CALL __PUTPARD1
	RJMP SUBOPT_0x87

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x98:
	LDS  R26,_t_msa
	LDS  R27,_t_msa+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x99:
	CALL __DIVW21U
	RJMP SUBOPT_0x86

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x9A:
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x9B:
	CALL __PUTPARD1
	RJMP SUBOPT_0x89

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x9C:
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x3F
	CALL __CWD1
	CALL __PUTPARD1
	LDS  R26,_u_delta_b
	LDS  R27,_u_delta_b+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __DIVW21
	CALL __CWD1
	RJMP SUBOPT_0x9B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x9D:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_u_delta_ub
	LDS  R31,_u_delta_ub+1
	CALL __CWD1
	CALL __PUTPARD1
	RJMP SUBOPT_0x87

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9E:
	LDS  R26,_t_msb
	LDS  R27,_t_msb+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x9F:
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x43
	CALL __CWD1
	CALL __PUTPARD1
	LDS  R26,_u_delta_c
	LDS  R27,_u_delta_c+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __DIVW21
	CALL __CWD1
	RJMP SUBOPT_0x9B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xA0:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_u_delta_uc
	LDS  R31,_u_delta_uc+1
	CALL __CWD1
	CALL __PUTPARD1
	RJMP SUBOPT_0x87

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA1:
	LDS  R26,_t_msc
	LDS  R27,_t_msc+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA2:
	LDI  R30,LOW(10)
	CALL __MULB1W2U
	RJMP SUBOPT_0x86

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0xA3:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xA4:
	SUB  R30,R26
	SBC  R31,R27
	CALL __CWD1
	CALL __PUTPARD1
	RJMP SUBOPT_0x87

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xA5:
	__POINTW1FN _0x0,1177
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA6:
	__POINTW1FN _0x0,1389
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA7:
	__POINTW1FN _0x0,1395
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA8:
	__POINTW1FN _0x0,1406
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA9:
	__POINTW1FN _0x0,1412
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xAA:
	__POINTW1FN _0x0,1484
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xAB:
	__POINTW1FN _0x0,1513
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xAC:
	__POINTW1FN _0x0,1524
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xAD:
	__POINTW1FN _0x0,1617
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xAE:
	CALL __CWD1
	CALL __PUTPARD1
	RJMP SUBOPT_0x87

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xAF:
	LDS  R26,_ddop
	LDS  R27,_ddop+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB0:
	MOVW R26,R10
	CALL __MULW12
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xB1:
	LDS  R26,_ddop_m
	LDS  R27,_ddop_m+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xB2:
	__POINTW1FN _0x0,1739
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:63 WORDS
SUBOPT_0xB3:
	__POINTW1FN _0x0,1760
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_d
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDS  R30,_mo
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDS  R30,_y
	LDI  R31,0
	SUBI R30,LOW(-2000)
	SBCI R31,HIGH(-2000)
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
	RJMP SUBOPT_0x85

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:67 WORDS
SUBOPT_0xB4:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_h
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDS  R26,_m
	LDI  R27,0
	RJMP SUBOPT_0xA3

;OPTIMIZER ADDED SUBROUTINE, CALLED 33 TIMES, CODE SIZE REDUCTION:61 WORDS
SUBOPT_0xB5:
	CALL __CWD1
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0xB6:
	LDS  R26,_m
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	RJMP SUBOPT_0xB5

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xB7:
	LDS  R26,_s
	LDI  R27,0
	RJMP SUBOPT_0xA3

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0xB8:
	LDS  R26,_s
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	RJMP SUBOPT_0xB5

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0xB9:
	LDI  R24,20
	CALL _sprintf
	ADIW R28,24
	RJMP SUBOPT_0x85

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:43 WORDS
SUBOPT_0xBA:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_d
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDS  R30,_mo
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDS  R30,_y
	LDI  R31,0
	SUBI R30,LOW(-2000)
	SBCI R31,HIGH(-2000)
	RJMP SUBOPT_0xB5

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xBB:
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
	RJMP SUBOPT_0x85

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xBC:
	__POINTW1FN _0x0,1871
	RJMP SUBOPT_0xB4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xBD:
	LDS  R26,_stat_na
	LDI  R27,0
	SUBI R26,LOW(-_proval_tma)
	SBCI R27,HIGH(-_proval_tma)
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:39 WORDS
SUBOPT_0xBE:
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xBF:
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xC0:
	LDS  R30,_stat_na
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC1:
	SUB  R30,R8
	SBC  R31,R9
	RJMP SUBOPT_0x86

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xC2:
	MOVW R26,R30
	MOVW R30,R8
	SUB  R30,R26
	SBC  R31,R27
	RJMP SUBOPT_0x86

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC3:
	__POINTW1FN _0x0,2048
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xC4:
	LDS  R26,_stat_na
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0xC5:
	CALL __EEPROMRDB
	RJMP SUBOPT_0xBE

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xC6:
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	RJMP SUBOPT_0xB5

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC7:
	LDI  R24,20
	CALL _sprintf
	ADIW R28,24
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC8:
	__POINTW1FN _0x0,2087
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC9:
	__POINTW1FN _0x0,2107
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xCA:
	__POINTW1FN _0x0,2127
	RJMP SUBOPT_0x90

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xCB:
	LDS  R26,_stat_nb
	LDI  R27,0
	SUBI R26,LOW(-_proval_tmb)
	SBCI R27,HIGH(-_proval_tmb)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xCC:
	LDS  R30,_stat_nb
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xCD:
	LDS  R26,_stat_nb
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xCE:
	LDS  R26,_stat_nc
	LDI  R27,0
	SUBI R26,LOW(-_proval_tmc)
	SBCI R27,HIGH(-_proval_tmc)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xCF:
	LDS  R30,_stat_nc
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xD0:
	LDS  R26,_stat_nc
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 63 TIMES, CODE SIZE REDUCTION:121 WORDS
SUBOPT_0xD1:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xD2:
	STS  _menu,R30
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xD3:
	LDI  R26,0
	SBIC 0x16,5
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xD4:
	CALL _lcd_clear
	LDS  R30,_menu_def
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD5:
	CALL _lcd_clear
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0xD6:
	LDI  R30,LOW(0)
	STS  _t_ms,R30
	STS  _t_ms+1,R30
	STS  _t_ms+2,R30
	STS  _t_ms+3,R30
	STS  _t_msa,R30
	STS  _t_msa+1,R30
	CLR  R4
	STS  _mem_a,R30
	STS  _t_msb,R30
	STS  _t_msb+1,R30
	CLR  R5
	STS  _mem_b,R30
	STS  _t_msc,R30
	STS  _t_msc+1,R30
	CLR  R7
	STS  _mem_c,R30
	OUT  0x25,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xD7:
	CALL _lcd_clear
	LDI  R30,LOW(0)
	STS  _menu_def,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD8:
	STS  _izm_faza,R30
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xD9:
	LDI  R30,LOW(0)
	STS  _t_msa,R30
	STS  _t_msa+1,R30
	CLR  R4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xDA:
	STS  _t_msb,R30
	STS  _t_msb+1,R30
	CLR  R5
	LDI  R30,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xDB:
	STS  _t_msc,R30
	STS  _t_msc+1,R30
	CLR  R7
	LDI  R30,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xDC:
	LDI  R30,LOW(0)
	STS  _t_ms,R30
	STS  _t_ms+1,R30
	STS  _t_ms+2,R30
	STS  _t_ms+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xDD:
	LDI  R26,0
	SBIC 0x16,4
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xDE:
	STS  _menu_p,R30
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xDF:
	STS  _menu_pp,R30
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE0:
	LDS  R30,_menu_ppp
	SUBI R30,LOW(1)
	STS  _menu_ppp,R30
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xE1:
	LDI  R26,0
	SBIC 0x16,6
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE2:
	LDS  R30,_menu_ppp
	SUBI R30,-LOW(1)
	STS  _menu_ppp,R30
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xE3:
	LDI  R26,LOW(_save)
	LDI  R27,HIGH(_save)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xE4:
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
	ADIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xE5:
	LDS  R26,_t_zad
	LDS  R27,_t_zad+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE6:
	STS  _rtc,R30
	LDI  R30,LOW(0)
	STS  _flag,R30
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0xE7:
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE8:
	LDI  R30,LOW(350)
	LDI  R31,HIGH(350)
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xE9:
	CALL _i2c_start
	LDI  R30,LOW(208)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xEA:
	ST   -Y,R30
	CALL _i2c_write
	LDD  R30,Y+2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xEB:
	CALL _i2c_write
	JMP  _i2c_stop

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xEC:
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_start
	LDI  R30,LOW(209)
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	ST   -Y,R30
	JMP  _bcd2bin

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xED:
	ST   X,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	ST   -Y,R30
	CALL _bcd2bin
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_read
	ST   -Y,R30
	JMP  _bcd2bin

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xEE:
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
	ST   -Y,R30
	CALL _bin2bcd
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xEF:
	CALL _i2c_write
	LDD  R30,Y+1
	ST   -Y,R30
	JMP  _bin2bcd

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xF0:
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xF1:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL __lcd_write_nibble_G101
	__DELAY_USW 400
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0xF2:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xF3:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xF4:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xF5:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xF6:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF7:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,27
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,53
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	rjmp __i2c_delay1

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__SUBD12:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULB1W2U:
	MOV  R22,R30
	MUL  R22,R26
	MOVW R30,R0
	MUL  R22,R27
	ADD  R31,R0
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
